GNU bug report logs - #45688
28.0.50; New action for display-buffer?

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: emacs; Reported by: Lars Ingebrigtsen <larsi@HIDDEN>; dated Wed, 6 Jan 2021 12:03:02 UTC; Maintainer for emacs is bug-gnu-emacs@HIDDEN.

Message received at 45688 <at> debbugs.gnu.org:


Received: (at 45688) by debbugs.gnu.org; 20 Jan 2021 21:46:04 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Jan 20 16:46:04 2021
Received: from localhost ([127.0.0.1]:56389 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1l2LIh-0007vU-Qk
	for submit <at> debbugs.gnu.org; Wed, 20 Jan 2021 16:46:04 -0500
Received: from relay3-d.mail.gandi.net ([217.70.183.195]:60561)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <juri@HIDDEN>) id 1l2LIg-0007oh-FU
 for 45688 <at> debbugs.gnu.org; Wed, 20 Jan 2021 16:46:02 -0500
X-Originating-IP: 91.129.98.64
Received: from mail.gandi.net (m91-129-98-64.cust.tele2.ee [91.129.98.64])
 (Authenticated sender: juri@HIDDEN)
 by relay3-d.mail.gandi.net (Postfix) with ESMTPSA id 98ADF6000D;
 Wed, 20 Jan 2021 21:45:54 +0000 (UTC)
From: Juri Linkov <juri@HIDDEN>
To: martin rudalics <rudalics@HIDDEN>
Subject: Re: bug#45688: 28.0.50; New action for display-buffer?
Organization: LINKOV.NET
References: <87im8a1dff.fsf@HIDDEN> <83y2h6133r.fsf@HIDDEN>
 <8735ze0yp7.fsf@HIDDEN> <83o8i20w1f.fsf@HIDDEN>
 <87lfd5yny9.fsf@HIDDEN>
 <a25dc85e-cd8e-8164-676e-bb6a0f381c06@HIDDEN>
 <87o8i03gem.fsf@HIDDEN>
 <528b7d6b-403a-ffef-b0a0-4a0b6d92bec8@HIDDEN>
 <87turpvxv0.fsf@HIDDEN>
 <fe796e77-3248-b3fc-0f1b-35b12761e860@HIDDEN>
 <fb97d5c9-91eb-b8ce-5639-1a875bf40ae9@HIDDEN>
 <87turnh6u8.fsf@HIDDEN>
 <b9059f39-b3af-3ec7-c0ee-d1a493a3a2f5@HIDDEN>
 <87im83cn02.fsf@HIDDEN>
 <568151d0-c8fd-1643-56a7-87ff36ce234d@HIDDEN>
 <8735ywdf0q.fsf@HIDDEN>
 <c2f05bea-c1e0-d3d5-3517-9664cf9a1bc9@HIDDEN>
Date: Wed, 20 Jan 2021 23:45:29 +0200
In-Reply-To: <c2f05bea-c1e0-d3d5-3517-9664cf9a1bc9@HIDDEN> (martin rudalics's
 message of "Wed, 20 Jan 2021 09:09:12 +0100")
Message-ID: <87lfcnqo3q.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (x86_64-pc-linux-gnu)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 45688
Cc: Lars Ingebrigtsen <larsi@HIDDEN>, 45688 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

>> I didn't know this trick.  But it works only for 'C-x 4 f',
>> not for 'C-x 4 1':
>>
>> with enabled temp-buffer-resize-mode
>> 1. C-h f push RET
>> 2. C-x o TAB
>> 3. C-x 4 1 RET
>>
>> doesn't re-enlarge the window to its prior size.
>
> Only 'display-buffer-use-some-window' currently does.  What does C-x 4 1
> call?

It calls same-window-prefix, i.e. display-buffer-same-window.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#45688; Package emacs. Full text available.

Message received at 45688 <at> debbugs.gnu.org:


Received: (at 45688) by debbugs.gnu.org; 20 Jan 2021 17:11:57 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Jan 20 12:11:57 2021
Received: from localhost ([127.0.0.1]:56169 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1l2H1R-0002Is-2b
	for submit <at> debbugs.gnu.org; Wed, 20 Jan 2021 12:11:57 -0500
Received: from mout.gmx.net ([212.227.17.20]:47565)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <rudalics@HIDDEN>) id 1l2H1O-0002Ie-HH
 for 45688 <at> debbugs.gnu.org; Wed, 20 Jan 2021 12:11:55 -0500
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=gmx.net;
 s=badeba3b8450; t=1611162708;
 bh=42OVo0wpjMNQlkrLH93rwmVPLo8htUJj3asbKpsE+B8=;
 h=X-UI-Sender-Class:Subject:To:Cc:References:From:Date:In-Reply-To;
 b=F72Azm1ZJHiX4PrU/493aGGupAnbJaQMvnKK0vVZv9g4NsF5Chg/mkokcWEs2AVt9
 7Yxl6LVvEKGIXyLjmmXiSZ3U+80XdZv5VY+e4BpRKhk5lhG8sgu7owrpfIEeJnzEGI
 eAdrrgv7zRlxoGcfhuRihb7ugO4CEYjTrVYSuI9M=
X-UI-Sender-Class: 01bb95c1-4bf8-414a-932a-4f6e2808ef9c
Received: from [192.168.1.100] ([212.95.5.241]) by mail.gmx.net (mrgmx104
 [212.227.17.168]) with ESMTPSA (Nemesis) id 1MEFzx-1lCPVR0709-00AFPf; Wed, 20
 Jan 2021 18:11:48 +0100
Subject: Re: bug#45688: 28.0.50; New action for display-buffer?
To: Lars Ingebrigtsen <larsi@HIDDEN>
References: <87im8a1dff.fsf@HIDDEN> <83y2h6133r.fsf@HIDDEN>
 <8735ze0yp7.fsf@HIDDEN> <83o8i20w1f.fsf@HIDDEN> <87lfd5yny9.fsf@HIDDEN>
 <a25dc85e-cd8e-8164-676e-bb6a0f381c06@HIDDEN> <87o8i03gem.fsf@HIDDEN>
 <528b7d6b-403a-ffef-b0a0-4a0b6d92bec8@HIDDEN> <87turpvxv0.fsf@HIDDEN>
 <fe796e77-3248-b3fc-0f1b-35b12761e860@HIDDEN>
 <fb97d5c9-91eb-b8ce-5639-1a875bf40ae9@HIDDEN> <87turnh6u8.fsf@HIDDEN>
 <b9059f39-b3af-3ec7-c0ee-d1a493a3a2f5@HIDDEN> <87im83cn02.fsf@HIDDEN>
 <568151d0-c8fd-1643-56a7-87ff36ce234d@HIDDEN> <878s8psj2l.fsf@HIDDEN>
 <ea317e6f-1e3d-e56f-d603-5a192019587d@HIDDEN> <874kjbr2i6.fsf@HIDDEN>
From: martin rudalics <rudalics@HIDDEN>
Message-ID: <bf1cdab3-422d-baa5-16e0-2bad76a753b0@HIDDEN>
Date: Wed, 20 Jan 2021 18:11:46 +0100
MIME-Version: 1.0
In-Reply-To: <874kjbr2i6.fsf@HIDDEN>
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Language: en-US
Content-Transfer-Encoding: 7bit
X-Provags-ID: V03:K1:QZQPYtEzUpAQLNhtjYkq9032WV/UgaMeWhhP6nLTT2Xgr3oXI+M
 sgQHb7pJxLn6ohtuvzcWtmTqrwKzcVZut51B7QzglgT+67HyAbxsHQYmDPkahJBA7sM9KNT
 SGHEeroGBEgASVNUKEcRWEMm23elCFphTyHtjjCKV3H4xY1VIn5sy5GHvyKhpB6dDwdLsjU
 5cXcbtre0SKZ6Kqj9pSKw==
X-Spam-Flag: NO
X-UI-Out-Filterresults: notjunk:1;V03:K0:j+EfXk6mgUc=:BdNayiIpfuPJB5np/QWB8v
 B7KKghMkeICEMoAOhnXZdgHpyc/es/EIvJ4bIJpLuEFqlPx3IRdsJG2nex5roW+1Qdpuy9/34
 vlfUqUDQC9c75buJte2EZRLPBJYsIvd/RdRZ/kbVwaAlwApdo6AqyPcJBkT++eRb9YrjcAn93
 jn4A7QRxd6fB/eFGYM2IxV16l5Y8g5PIk4sWGeeEvD+eOkenc46l8wQpTkOmcPB2lG3ZXwSNk
 lmkrBhhlQ6zQzWJCzryiYcGOpBcY8Xj6au8v6Y7FQuE8IWGCf/jkDqME06Fm5OrajTSYtdgIX
 H5AyYrqfUNizNMurSwq7ppGsT6mmm/PEP6/xdJdeLz1YNJ7A+VnZENTuAGviMpm0V1a2JujPh
 C0NXaRypkO2D2N68+C/AyobLvAmcVKVaQRIAnSt+Z76p0fZk13SP28Z35kwyI784X0Ly1ZtRL
 +HFlZ070pJA5iWbP8IL8BWd5CotSsIuBuFyeukJPDeAy+GdlXm6+iVKhToJHr3t93uk1t4i2H
 bOf/2mPg2O3qVFfJeSVmeDjZaCuz0sY+Rss0hbFYE76FjWLHu/8ZY9T3QhXuqVx0H6ecYlNJS
 263No/hws1FUersuvEaccupRSzf9wEu8ieVrWSp7I/TfbM2bhXIVkF6C6kp51QeLExKxbgFPL
 z1jRHlf/QxbL/lL7HAiEW24Ha7ENmMk8UaNclAfrH7M1F47sC/ucJYr4DIjxsMZ8KD6b7G0xK
 ipk/Qv1R4bNExbueMmN6BsFxBhg9eEpqVfSW8seBI5N+GYGhWQWODPC9yafMqbc1upr32tvmz
 UUPV1NfM2HO3W0Ae8wela4dwEbiTIBrtI5iXvTMjmgzQjfpNNnUJXOzU0NfukZwKpXzkWPqYz
 bOwt4MsCuJSgeUtgHR7g==
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 45688
Cc: Eli Zaretskii <eliz@HIDDEN>, 45688 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

 >> Where and how?   If you do that in the minibuffer window alone, you
 >> should get a result not affected by 'select-window'.  Otherwise, all
 >> bets are off.
 >
 > `C-x C-e'  :-)

With emacs -Q, do C-x 2 twice so you get three windows (since you don't
want to count the selected one) at least and do C-x C-e in the selected
window with point after the following form:

(let ((lru (get-lru-window (next-frame) nil t)))
   (window-bump-use-time lru)
   (message "%s .. %s" lru (get-lru-window (next-frame) nil t)))

martin




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#45688; Package emacs. Full text available.

Message received at 45688 <at> debbugs.gnu.org:


Received: (at 45688) by debbugs.gnu.org; 20 Jan 2021 16:34:37 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Jan 20 11:34:36 2021
Received: from localhost ([127.0.0.1]:56039 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1l2GRI-0005W6-N7
	for submit <at> debbugs.gnu.org; Wed, 20 Jan 2021 11:34:36 -0500
Received: from quimby.gnus.org ([95.216.78.240]:46386)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1l2GRH-0005Vu-BQ
 for 45688 <at> debbugs.gnu.org; Wed, 20 Jan 2021 11:34:35 -0500
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnus.org;
 s=20200322; h=Content-Type:MIME-Version:Message-ID:In-Reply-To:Date:
 References:Subject:Cc:To:From:Sender:Reply-To:Content-Transfer-Encoding:
 Content-ID:Content-Description:Resent-Date:Resent-From:Resent-Sender:
 Resent-To:Resent-Cc:Resent-Message-ID:List-Id:List-Help:List-Unsubscribe:
 List-Subscribe:List-Post:List-Owner:List-Archive;
 bh=Z02TK9lc18OJCk1r3kBjl5S5CR04H4fG76A7PrivG1I=; b=PI6L+TWSVX9ZCHKWXm3d8IO0XS
 kKnRDU7e9n+Or0lkdsCZ4Hof540SzBgO3ap+3nHtll+pMrSS5iDhjIfCW9XsprWGxv1HMKo9kS2Kw
 v2dU3cuk8DWUC446RsIpQC5HP9s/sJTezZUnyZ88p4+eHJShB4lbAxAPHs0uc9DQjIG8=;
Received: from cm-84.212.202.86.getinternet.no ([84.212.202.86] helo=xo)
 by quimby.gnus.org with esmtpsa (TLS1.3:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.92) (envelope-from <larsi@HIDDEN>)
 id 1l2GR9-0001Nb-0x; Wed, 20 Jan 2021 17:34:29 +0100
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: martin rudalics <rudalics@HIDDEN>
Subject: Re: bug#45688: 28.0.50; New action for display-buffer?
References: <87im8a1dff.fsf@HIDDEN> <83y2h6133r.fsf@HIDDEN>
 <8735ze0yp7.fsf@HIDDEN> <83o8i20w1f.fsf@HIDDEN>
 <87lfd5yny9.fsf@HIDDEN>
 <a25dc85e-cd8e-8164-676e-bb6a0f381c06@HIDDEN>
 <87o8i03gem.fsf@HIDDEN>
 <528b7d6b-403a-ffef-b0a0-4a0b6d92bec8@HIDDEN>
 <87turpvxv0.fsf@HIDDEN>
 <fe796e77-3248-b3fc-0f1b-35b12761e860@HIDDEN>
 <fb97d5c9-91eb-b8ce-5639-1a875bf40ae9@HIDDEN>
 <87turnh6u8.fsf@HIDDEN>
 <b9059f39-b3af-3ec7-c0ee-d1a493a3a2f5@HIDDEN>
 <87im83cn02.fsf@HIDDEN>
 <568151d0-c8fd-1643-56a7-87ff36ce234d@HIDDEN>
 <878s8psj2l.fsf@HIDDEN>
 <ea317e6f-1e3d-e56f-d603-5a192019587d@HIDDEN>
Face: iVBORw0KGgoAAAANSUhEUgAAADAAAAAwBAMAAAClLOS0AAAABGdBTUEAALGPC/xhBQAAACBj
 SFJNAAB6JgAAgIQAAPoAAACA6AAAdTAAAOpgAAA6mAAAF3CculE8AAAAGFBMVEUiKDkGAwYeGiRc
 SCdcJAujWw7tvkD///9yuJSCAAAAAWJLR0QHFmGI6wAAAAd0SU1FB+UBFBAQLuJ0dQcAAAGQSURB
 VDjLbZPbkYMwDEWFK0Aa9t/WsgXskAaSECrAqWBx/yWsJJtHwMzEGXzQvdbD0GDrkBnw9MAvogv7
 O911CQYIDp/3CrqHgRZgDxnvtuYI4j1iXFdokJDcybkLKPL0YbKdSn/g6sAfzA+AAokPX0Eb0PPV
 RYBp+Qpg74hX+1fO0ICeiVb7GB/Yjw8axZx1cy3vO874iiOP+u7UpWhNi4AURwOt7K/HnZKCZTap
 Y3mn9CdAQkDbcch8Sgv+pJRmMGPYEuyeN+zeEpI3PJzKRXZKz/5aRSjfhxqQ6WmrIOB1rKy14J1v
 qgDcXt04DDcuUo3fut5LCvLcv9+WYKmwBL9sP8190lqJ0pp3DkhLLxFeC1IS73RX4biBfN4vBVG1
 3tpzFhc0tR8zUFiKKC0n+38O0nTRWlJJWcP2h4dhsEYFmbpwybwFSbtWK5nc2lTLp97xZaRLPy6d
 letpcxX2a9Dl2e1za4NNYwbRAOokknjwh9QzS1E4G5dGHcv7mSCAaB0uLt1WoO5ciQiqdh6TfxW5
 dCpjs1zAAAAAJXRFWHRkYXRlOmNyZWF0ZQAyMDIxLTAxLTIwVDE2OjE2OjQ1KzAwOjAwP2Ki3AAA
 ACV0RVh0ZGF0ZTptb2RpZnkAMjAyMS0wMS0yMFQxNjoxNjo0NSswMDowME4/GmAAAAAASUVORK5C
 YII=
X-Now-Playing: Joe Jackson's _Live 1980-86 (2)_: "Memphis"
Date: Wed, 20 Jan 2021 17:34:25 +0100
In-Reply-To: <ea317e6f-1e3d-e56f-d603-5a192019587d@HIDDEN> (martin rudalics's
 message of "Wed, 20 Jan 2021 09:08:56 +0100")
Message-ID: <874kjbr2i6.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview:  martin rudalics <rudalics@HIDDEN> writes: > Where and how?
 If you do that in the minibuffer window alone, you > should get a result
 not affected by 'select-window'. Otherwise, all > bets are off. `C-x C-e'
 :-) Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 45688
Cc: Eli Zaretskii <eliz@HIDDEN>, 45688 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

martin rudalics <rudalics@HIDDEN> writes:

> Where and how?   If you do that in the minibuffer window alone, you
> should get a result not affected by 'select-window'.  Otherwise, all
> bets are off.

`C-x C-e'  :-)

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#45688; Package emacs. Full text available.

Message received at 45688 <at> debbugs.gnu.org:


Received: (at 45688) by debbugs.gnu.org; 20 Jan 2021 08:09:24 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Jan 20 03:09:24 2021
Received: from localhost ([127.0.0.1]:52710 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1l28YN-0006yu-VZ
	for submit <at> debbugs.gnu.org; Wed, 20 Jan 2021 03:09:24 -0500
Received: from mout.gmx.net ([212.227.15.15]:47027)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <rudalics@HIDDEN>) id 1l28YJ-0006yf-8Z
 for 45688 <at> debbugs.gnu.org; Wed, 20 Jan 2021 03:09:22 -0500
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=gmx.net;
 s=badeba3b8450; t=1611130152;
 bh=8XeQfFWZdKz8dzDK5ZKmjx7f1fyuNYcUrcRY4MPMNJ4=;
 h=X-UI-Sender-Class:Subject:To:Cc:References:From:Date:In-Reply-To;
 b=U5uXUGYGSTkk7da9TxklWdnXtnedDtsu1osauUwlB1VuhjnmnGAiI0+XWv24EgsrC
 Zswek75uM9WkUyo9lfwcBNLp5O4v40jMNiTgxjylePN4WkdBUzsuewiw/mugfwlPkw
 8LWjvJiDiqikVKYF8ek7uRitQVSUBJaXmMW3XXns=
X-UI-Sender-Class: 01bb95c1-4bf8-414a-932a-4f6e2808ef9c
Received: from [192.168.1.100] ([212.95.5.39]) by mail.gmx.com (mrgmx005
 [212.227.17.190]) with ESMTPSA (Nemesis) id 1M3UZ6-1l1aaQ2qws-000dBD; Wed, 20
 Jan 2021 09:09:12 +0100
Subject: Re: bug#45688: 28.0.50; New action for display-buffer?
To: Juri Linkov <juri@HIDDEN>
References: <87im8a1dff.fsf@HIDDEN> <83y2h6133r.fsf@HIDDEN>
 <8735ze0yp7.fsf@HIDDEN> <83o8i20w1f.fsf@HIDDEN> <87lfd5yny9.fsf@HIDDEN>
 <a25dc85e-cd8e-8164-676e-bb6a0f381c06@HIDDEN> <87o8i03gem.fsf@HIDDEN>
 <528b7d6b-403a-ffef-b0a0-4a0b6d92bec8@HIDDEN> <87turpvxv0.fsf@HIDDEN>
 <fe796e77-3248-b3fc-0f1b-35b12761e860@HIDDEN>
 <fb97d5c9-91eb-b8ce-5639-1a875bf40ae9@HIDDEN> <87turnh6u8.fsf@HIDDEN>
 <b9059f39-b3af-3ec7-c0ee-d1a493a3a2f5@HIDDEN> <87im83cn02.fsf@HIDDEN>
 <568151d0-c8fd-1643-56a7-87ff36ce234d@HIDDEN>
 <8735ywdf0q.fsf@HIDDEN>
From: martin rudalics <rudalics@HIDDEN>
Message-ID: <c2f05bea-c1e0-d3d5-3517-9664cf9a1bc9@HIDDEN>
Date: Wed, 20 Jan 2021 09:09:12 +0100
MIME-Version: 1.0
In-Reply-To: <8735ywdf0q.fsf@HIDDEN>
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Language: en-US
Content-Transfer-Encoding: 7bit
X-Provags-ID: V03:K1:YpBi0RtaBGKrfEit9SdMJk0eGje+R0Gwm8NFY7umNoRYABvIzQk
 SVxR9kTnP5KSfQb7ijwD8E6KJhWsP9ePrMS+wYbhIsyK3Ui8JOWKInTztOy4QyJpGwiDG1V
 p7bFcYw2p/+bYbOoBw/zDlzSH4fRnu4kI4k8A+x9KhkPiN0X3rcokx2epl2CM0RzSlANef3
 BfzfFRDFt1lGivCwagihQ==
X-Spam-Flag: NO
X-UI-Out-Filterresults: notjunk:1;V03:K0:xFOCL+Z+ako=:jjq7/IsYhm16woGXgWagPv
 iI7w+ebKhFVc+zBCIMJ+IFQYevxRnuRrcYqc1mvIkyxdBmVe8MuGorVhaTX1oE9eESRiMK0jg
 B6ANm5BigCJoF0uqS4+2I9GqjGaZRPOgYW+IjkY677DVxdUOrcETRc7EmxN/j6p27oHZRHRDy
 5iHe0mo++7/B+7CW+OHj9pgPZK61ngbIcDQyBCBiCGO8OjcY+aMlk3V/1W/iK1mnk3H7yW9HK
 YKkWjeAYWKZhEkOaAoDAraZAGpl+X7syjcdFsadPZzGgJC1UaTL9IruOkPEt7tbSRIRqij9ZN
 sj1M7U+wXbz4ASIH6iUnhY+nTyfRqbiC4Lajk7jmrwk0Y41hpuiKToUzHC2mS8zoAzHRn/N2S
 /GVP83znU/tJqup22ysAtBRN6xsqefEx/Ut8klc9Fqj/4BDMsMS0hXLL5j/tNtTAmTOX1v+Hc
 sv8obvL368ZjvlyyeMbOJWOLhuzKePAkwEq/vl+NsSx5yTRRFkJLLjQqFQ8Uqjb9XInveMzF1
 M4DsidkCUuPTAs6M9JXJ8WCTobK8LXk3Cj0JZ4n96SD/mfcgKxOy2Ve2uKnrK/qDUTOBv4u5d
 jPfz0XaroG3bpho+7WBIsV7Q86+oPKFap1iJCJmgKv6YRLzlp4LM37mLp8mL09adU/2d32N0h
 QDSnpJzbyCZ9F+fVV++eZ+jo2ifJDNciOPBfzDfMt8ENq1zshdFCDiA5zg1SEKA4NxUEWunWv
 UYzyoLBzNH220JfUG0YgJO7WXcwa6WURb/KfpmZunpFe11A+MKymiMDuZAmXq3poDyHSuOlt6
 YSWTolvFpwV6gjVlBBHBAz+Doe8tutdP7DyptwrbdKHQmpGiZ0wS6I9hEaZ/BwGSWKmPCBtVU
 NWxJxkA16lym8SxPgKAw==
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 45688
Cc: Lars Ingebrigtsen <larsi@HIDDEN>, 45688 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

 > I didn't know this trick.  But it works only for 'C-x 4 f',
 > not for 'C-x 4 1':
 >
 > with enabled temp-buffer-resize-mode
 > 1. C-h f push RET
 > 2. C-x o TAB
 > 3. C-x 4 1 RET
 >
 > doesn't re-enlarge the window to its prior size.

Only 'display-buffer-use-some-window' currently does.  What does C-x 4 1
call?

martin




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#45688; Package emacs. Full text available.

Message received at 45688 <at> debbugs.gnu.org:


Received: (at 45688) by debbugs.gnu.org; 20 Jan 2021 08:09:09 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Jan 20 03:09:08 2021
Received: from localhost ([127.0.0.1]:52707 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1l28Y8-0006yU-LV
	for submit <at> debbugs.gnu.org; Wed, 20 Jan 2021 03:09:08 -0500
Received: from mout.gmx.net ([212.227.15.19]:45447)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <rudalics@HIDDEN>) id 1l28Y4-0006xx-Ql
 for 45688 <at> debbugs.gnu.org; Wed, 20 Jan 2021 03:09:06 -0500
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=gmx.net;
 s=badeba3b8450; t=1611130138;
 bh=ceoMwbJs56AnhGDtcW9D8NepdYD92h/xjWswj0T08L0=;
 h=X-UI-Sender-Class:Subject:To:Cc:References:From:Date:In-Reply-To;
 b=LBffdwZgRC5kkQQ+3pO30lVfA/5DnxoP2EJnoMBP11dvbArfbqBqCc6Jxlsk1/42m
 GtYO+gmcZ/I2kINf+eVjgy66YLIViksU9htSodIIMn6O4mhOR9sPkwhqj5PE57tCnO
 OSbVb7CxiN/uW/MxrQuEKj82U4TuwFOJvykx8wvY=
X-UI-Sender-Class: 01bb95c1-4bf8-414a-932a-4f6e2808ef9c
Received: from [192.168.1.100] ([212.95.5.39]) by mail.gmx.com (mrgmx005
 [212.227.17.190]) with ESMTPSA (Nemesis) id 1N49h5-1m1DWl1W5p-0103uD; Wed, 20
 Jan 2021 09:08:58 +0100
Subject: Re: bug#45688: 28.0.50; New action for display-buffer?
To: Lars Ingebrigtsen <larsi@HIDDEN>
References: <87im8a1dff.fsf@HIDDEN> <83y2h6133r.fsf@HIDDEN>
 <8735ze0yp7.fsf@HIDDEN> <83o8i20w1f.fsf@HIDDEN> <87lfd5yny9.fsf@HIDDEN>
 <a25dc85e-cd8e-8164-676e-bb6a0f381c06@HIDDEN> <87o8i03gem.fsf@HIDDEN>
 <528b7d6b-403a-ffef-b0a0-4a0b6d92bec8@HIDDEN> <87turpvxv0.fsf@HIDDEN>
 <fe796e77-3248-b3fc-0f1b-35b12761e860@HIDDEN>
 <fb97d5c9-91eb-b8ce-5639-1a875bf40ae9@HIDDEN> <87turnh6u8.fsf@HIDDEN>
 <b9059f39-b3af-3ec7-c0ee-d1a493a3a2f5@HIDDEN> <87im83cn02.fsf@HIDDEN>
 <568151d0-c8fd-1643-56a7-87ff36ce234d@HIDDEN> <878s8psj2l.fsf@HIDDEN>
From: martin rudalics <rudalics@HIDDEN>
Message-ID: <ea317e6f-1e3d-e56f-d603-5a192019587d@HIDDEN>
Date: Wed, 20 Jan 2021 09:08:56 +0100
MIME-Version: 1.0
In-Reply-To: <878s8psj2l.fsf@HIDDEN>
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Language: en-US
Content-Transfer-Encoding: 7bit
X-Provags-ID: V03:K1:czJEh6H/T13oEe3jEf6Ud96aSuFOnxRgxf9yNshKHQAr1TfpDAN
 V1Heu9w0JAEZBifl0RkyqfLwz0j5+5XHMi8cMDqAZZiLYHdHkSUkU9jXUlYASqvIclIP5VN
 wN7njhblW7vmXd0NZDgnEwYzY2jePsRaZi2my35IUTizmL7gvfxqgqEelx4hp55nMHAD5UK
 5vld3lZoGQQkle8j2vIzg==
X-Spam-Flag: NO
X-UI-Out-Filterresults: notjunk:1;V03:K0:ioAK7Df5YoY=:HCfUT02rmi8mH+L54fp+T0
 tFMheekOy+Zp+Cyn8QoVz/W/sNZ8zXo6ugzw1MvHAL9bpr7+M0nq7hqeOv0/MtJVzNdBCXGV4
 IEt3jJFTf1R8XkfyeXSj4nSNGiy2nx8SqdPh8zXz7GhvNRZRJCCHUcQExmtZuo0I08Zl5YTV7
 TUv2pB+KJTya+JPCulIb8BKFcVh/iKl8zbLSttUUV5eAspomhNMu8+H6uQhkx8SNe/kEXcZJP
 0LsB7IFlial94BCOyHVsDPHB3Uhx3uUXMotwaJFtC4IiGrKr0OL0CYROrsSyV4NjMo4nE0xQw
 b5DI9qUMk0I1HPcYlbrr346kDC7VMszETrI2ET2bIid9EDhaEI7wttDRhBuYld4ByQl7uKVWO
 FLExxdHuBvHIgtHm3igz65RHWoDg3trNF95a3CairXwhFSzdxnFyYMHaa8p32g8+mJCxty6V7
 3DpJ6yrwjuc+/AwFA0T4HNA2luUiCdgvG/ip1fWZTWTTozl81wJ2ss3tOZNIWRskzRB2pKkFi
 R/009F2FG9qol8zyMDCi4s6/uq0fVA4yJ1BPdwkEFozO09N8yPuGW7jQAQWKiufYYOkwV9GyU
 q/zT0fa+UwRAXfeBS9aOS7YVfjspnpixCD5rlLBHcIM5S5t+bfGA7kPua0H/cv4yM4zc8rljA
 bNvjPM6LXPdGrj4jjkJVXeO1GiXhpXlSayj7hbNF3kfIlgKLS+Ff44ZG0vdDt6bkBalFHg0pp
 J5S1jNmqYrz8DLHBveQ1cbIxjt0QKW6+T+r7R4MRzY6NA5FO38UE+HGXILzTqnJQsuzYVQp2T
 6ee6KqUrGt5ksWQqV5pz/BWLHVx7ZIwyZuwYKXP8UhPu9L+RgWiNFVbY0RJizxYTi13G0Vu13
 dQJSzd7FCxO0KkgHtw3g==
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 45688
Cc: Eli Zaretskii <eliz@HIDDEN>, 45688 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

 > Well, it's certainly the most common one, but having more than two
 > windows in a frame isn't unheard of, either.

Right.  But how reconcile the two approaches?

 > I think that makes sense...  if you have that mode enabled.  But if
 > you're not asking Emacs to resize windows in this way, then having
 > `display-buffer' resizing windows is somewhat confusing.

The one you cited earlier certainly is.  The basic idea is that a window
that was good for 'display-buffer' once, should be good again.  Unless
it shrunk in between.

 >>> In related news, get-lru-window doesn't seem to work reliably?  I don't
 >>> have a reproducer for that, either, but it seems to happen if I have a
 >>> three window frame, and I call:
 >>>
 >>> (setq lru (get-lru-window (selected-frame) nil t))
 >>> (window-bump-use-time lru)
 >>> (get-lru-window (selected-frame) nil t)
 >>>
 >>> will then return the same window as `lru'...
 >>
 >> How do you "call"?  I suppose there's no chance to make another window
 >> but the selected one the mru one.  We would have to look into the inner
 >> workings of that "call".
 >
 > eval the expressions.

Where and how?   If you do that in the minibuffer window alone, you
should get a result not affected by 'select-window'.  Otherwise, all
bets are off.

martin




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#45688; Package emacs. Full text available.

Message received at 45688 <at> debbugs.gnu.org:


Received: (at 45688) by debbugs.gnu.org; 19 Jan 2021 17:59:15 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Jan 19 12:59:15 2021
Received: from localhost ([127.0.0.1]:51596 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1l1vHf-0002X2-8t
	for submit <at> debbugs.gnu.org; Tue, 19 Jan 2021 12:59:15 -0500
Received: from relay6-d.mail.gandi.net ([217.70.183.198]:51969)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <juri@HIDDEN>) id 1l1vHZ-0002WK-RJ
 for 45688 <at> debbugs.gnu.org; Tue, 19 Jan 2021 12:59:10 -0500
X-Originating-IP: 91.129.98.64
Received: from mail.gandi.net (m91-129-98-64.cust.tele2.ee [91.129.98.64])
 (Authenticated sender: juri@HIDDEN)
 by relay6-d.mail.gandi.net (Postfix) with ESMTPSA id 2ADB2C0003;
 Tue, 19 Jan 2021 17:59:01 +0000 (UTC)
From: Juri Linkov <juri@HIDDEN>
To: Lars Ingebrigtsen <larsi@HIDDEN>
Subject: Re: bug#45688: 28.0.50; New action for display-buffer?
Organization: LINKOV.NET
References: <87im8a1dff.fsf@HIDDEN> <83y2h6133r.fsf@HIDDEN>
 <8735ze0yp7.fsf@HIDDEN> <83o8i20w1f.fsf@HIDDEN>
 <87lfd5yny9.fsf@HIDDEN> <87ft3cpoy9.fsf@HIDDEN>
 <6859d73c-da77-af77-481f-3046d5195d53@HIDDEN>
 <87pn2dvxqi.fsf@HIDDEN> <87v9c2rpfi.fsf@HIDDEN>
Date: Tue, 19 Jan 2021 19:52:20 +0200
In-Reply-To: <87v9c2rpfi.fsf@HIDDEN> (Juri Linkov's message of "Tue, 
 12 Jan 2021 20:36:33 +0200")
Message-ID: <87mtx4c04z.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (x86_64-pc-linux-gnu)
MIME-Version: 1.0
Content-Type: multipart/mixed; boundary="=-=-="
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 45688
Cc: 45688 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

--=-=-=
Content-Type: text/plain

> One problem is that other display-buffer actions don't set
> 'display-buffer-previous-window'.  It would be nice to do
> this in some low-level function in window.el.

If this is impossible to add this to window.el then a workaround is
to use such advice that helps to visit grep/xref hits in the window
where all previous hits were visited:

#+begin_src emacs-lisp
(advice-add 'window--display-buffer :around
            (lambda (orig-fun &rest args)
              (let ((buffer (current-buffer))
                    (window (apply orig-fun args)))
                (with-current-buffer buffer
                  (setq-local display-buffer-previous-window window))
                window))
            '((name . window--display-buffer-set-previous-window)))

(defvar-local display-buffer-previous-window nil)

(defun display-buffer-from-grep-p (_buffer-name _action)
  (with-current-buffer (window-buffer)
    (derived-mode-p 'compilation-mode)))

(add-to-list 'display-buffer-alist
             '(display-buffer-from-grep-p
               nil (previous-window . display-buffer-previous-window)))
#+end_src

The only problem is that display-buffer-in-previous-window
doesn't support 'previous-window' as a variable, only as a value,
i.e. currently it only supports:

  `(previous-window . ,display-buffer-previous-window)

maybe the following patch could be installed to support also

  '(previous-window . display-buffer-previous-window)


--=-=-=
Content-Type: text/x-diff
Content-Disposition: inline; filename=previous-window.patch

diff --git a/lisp/window.el b/lisp/window.el
index 0a37d16273..d6b3d69b3d 100644
--- a/lisp/window.el
+++ b/lisp/window.el
@@ -8239,6 +8239,7 @@ display-buffer-in-previous-window
 		   0)
 		  (display-buffer-reuse-frames 0)
 		  (t (last-nonminibuffer-frame))))
+         (previous-window (cdr (assq 'previous-window alist)))
 	 best-window second-best-window window)
     ;; Scan windows whether they have shown the buffer recently.
     (catch 'best
@@ -8252,7 +8253,9 @@ display-buffer-in-previous-window
 	    (throw 'best t)))))
     ;; When ALIST has a `previous-window' entry, that entry may override
     ;; anything we found so far.
-    (when (and (setq window (cdr (assq 'previous-window alist)))
+    (when (and previous-window (boundp previous-window))
+      (setq previous-window (symbol-value previous-window)))
+    (when (and (setq window previous-window)
 	       (window-live-p window)
 	       (or (eq buffer (window-buffer window))
                    (not (window-dedicated-p window))))

--=-=-=--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#45688; Package emacs. Full text available.

Message received at 45688 <at> debbugs.gnu.org:


Received: (at 45688) by debbugs.gnu.org; 19 Jan 2021 17:59:10 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Jan 19 12:59:10 2021
Received: from localhost ([127.0.0.1]:51593 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1l1vHa-0002Wf-07
	for submit <at> debbugs.gnu.org; Tue, 19 Jan 2021 12:59:10 -0500
Received: from relay5-d.mail.gandi.net ([217.70.183.197]:52743)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <juri@HIDDEN>) id 1l1vHV-0002VP-N4
 for 45688 <at> debbugs.gnu.org; Tue, 19 Jan 2021 12:59:06 -0500
X-Originating-IP: 91.129.98.64
Received: from mail.gandi.net (m91-129-98-64.cust.tele2.ee [91.129.98.64])
 (Authenticated sender: juri@HIDDEN)
 by relay5-d.mail.gandi.net (Postfix) with ESMTPSA id F34681C0007;
 Tue, 19 Jan 2021 17:58:57 +0000 (UTC)
From: Juri Linkov <juri@HIDDEN>
To: martin rudalics <rudalics@HIDDEN>
Subject: Re: bug#45688: 28.0.50; New action for display-buffer?
Organization: LINKOV.NET
References: <87im8a1dff.fsf@HIDDEN> <83y2h6133r.fsf@HIDDEN>
 <8735ze0yp7.fsf@HIDDEN> <83o8i20w1f.fsf@HIDDEN>
 <87lfd5yny9.fsf@HIDDEN>
 <a25dc85e-cd8e-8164-676e-bb6a0f381c06@HIDDEN>
 <87o8i03gem.fsf@HIDDEN>
 <528b7d6b-403a-ffef-b0a0-4a0b6d92bec8@HIDDEN>
 <87turpvxv0.fsf@HIDDEN>
 <fe796e77-3248-b3fc-0f1b-35b12761e860@HIDDEN>
 <fb97d5c9-91eb-b8ce-5639-1a875bf40ae9@HIDDEN>
 <87turnh6u8.fsf@HIDDEN>
 <b9059f39-b3af-3ec7-c0ee-d1a493a3a2f5@HIDDEN>
 <87im83cn02.fsf@HIDDEN>
 <568151d0-c8fd-1643-56a7-87ff36ce234d@HIDDEN>
Date: Tue, 19 Jan 2021 19:50:33 +0200
In-Reply-To: <568151d0-c8fd-1643-56a7-87ff36ce234d@HIDDEN> (martin rudalics's
 message of "Tue, 12 Jan 2021 10:06:45 +0100")
Message-ID: <8735ywdf0q.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (x86_64-pc-linux-gnu)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 45688
Cc: Lars Ingebrigtsen <larsi@HIDDEN>, 45688 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

> If we don't want to do that, we can try to do some cosmetics in the size
> restoring mechanism.  Basically, that mechanism is used when you display
> a temporary buffer in a two windows layout and you have
> 'temp-buffer-resize-mode' enabled.  Suppose with emacs -Q you enable
> that mode and type C-h f push RET and then C-x 4 f to find some file.
> This will re-enlarge the window used for showing the 'push' help to its
> prior size so you get what you intend for showing that file.

I didn't know this trick.  But it works only for 'C-x 4 f',
not for 'C-x 4 1':

with enabled temp-buffer-resize-mode
1. C-h f push RET
2. C-x o TAB
3. C-x 4 1 RET

doesn't re-enlarge the window to its prior size.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#45688; Package emacs. Full text available.

Message received at 45688 <at> debbugs.gnu.org:


Received: (at 45688) by debbugs.gnu.org; 19 Jan 2021 03:26:55 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Jan 18 22:26:55 2021
Received: from localhost ([127.0.0.1]:48962 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1l1hfT-0003Mq-55
	for submit <at> debbugs.gnu.org; Mon, 18 Jan 2021 22:26:55 -0500
Received: from quimby.gnus.org ([95.216.78.240]:53538)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1l1hfR-0003Mb-Ad
 for 45688 <at> debbugs.gnu.org; Mon, 18 Jan 2021 22:26:53 -0500
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnus.org;
 s=20200322; h=Content-Transfer-Encoding:Content-Type:MIME-Version:Message-ID
 :In-Reply-To:Date:References:Subject:Cc:To:From:Sender:Reply-To:Content-ID:
 Content-Description:Resent-Date:Resent-From:Resent-Sender:Resent-To:Resent-Cc
 :Resent-Message-ID:List-Id:List-Help:List-Unsubscribe:List-Subscribe:
 List-Post:List-Owner:List-Archive;
 bh=6e/kLsIysTNOfyyjegsLInYcG4a0re7ykh/DwKI/tJU=; b=ijpEvElDj4DemoQ/Ra0Qb5LY2n
 6+Eu32OlRgJtpmMQSTKL/mLffR2zFpGc/YOoZIFJ/80109URuJW8OD6AIkMQHpDtymruIi1xrL2RE
 hXMzRDY0GC1BLK1SAS+O0XSK8kUloxNnRz8eh6vPJVWQJs8RuNWJEPNdgBJavu3Fvjtg=;
Received: from cm-84.212.202.86.getinternet.no ([84.212.202.86] helo=xo)
 by quimby.gnus.org with esmtpsa (TLS1.3:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.92) (envelope-from <larsi@HIDDEN>)
 id 1l1hfH-0002qF-N1; Tue, 19 Jan 2021 04:26:47 +0100
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: martin rudalics <rudalics@HIDDEN>
Subject: Re: bug#45688: 28.0.50; New action for display-buffer?
References: <87im8a1dff.fsf@HIDDEN> <83y2h6133r.fsf@HIDDEN>
 <8735ze0yp7.fsf@HIDDEN> <83o8i20w1f.fsf@HIDDEN>
 <87lfd5yny9.fsf@HIDDEN>
 <a25dc85e-cd8e-8164-676e-bb6a0f381c06@HIDDEN>
 <87o8i03gem.fsf@HIDDEN>
 <528b7d6b-403a-ffef-b0a0-4a0b6d92bec8@HIDDEN>
 <87turpvxv0.fsf@HIDDEN>
 <fe796e77-3248-b3fc-0f1b-35b12761e860@HIDDEN>
 <fb97d5c9-91eb-b8ce-5639-1a875bf40ae9@HIDDEN>
 <87turnh6u8.fsf@HIDDEN>
 <b9059f39-b3af-3ec7-c0ee-d1a493a3a2f5@HIDDEN>
 <87im83cn02.fsf@HIDDEN>
 <568151d0-c8fd-1643-56a7-87ff36ce234d@HIDDEN>
X-Now-Playing: Ultra =?utf-8?Q?Nat=C3=A9's?= _Blue Notes in the Basement_:
 "Funny (How Things Change)"
Date: Tue, 19 Jan 2021 04:26:42 +0100
In-Reply-To: <568151d0-c8fd-1643-56a7-87ff36ce234d@HIDDEN> (martin rudalics's
 message of "Tue, 12 Jan 2021 10:06:45 +0100")
Message-ID: <878s8psj2l.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview: martin rudalics <rudalics@HIDDEN> writes: > 'display-buffer'
 still lives in the paradigm of <= 2 windows frames set > up in the past
 century
 and probably still the only reasonable one for > TTY frames. For that it
 supports things like 'even-w [...] 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 45688
Cc: Eli Zaretskii <eliz@HIDDEN>, 45688 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

martin rudalics <rudalics@HIDDEN> writes:

> 'display-buffer' still lives in the paradigm of <=3D 2 windows frames set
> up in the past century and probably still the only reasonable one for
> TTY frames.  For that it supports things like 'even-window-heights' and
> a 'split-height-threshold' of 80 with its "If, however, a window is the
> only window on its frame, or all the other ones are dedicated,
> =E2=80=98split-window-sensibly=E2=80=99 may split it vertically disregard=
ing the value
> of this variable." exception.  Hence a first step to get your rampages
> produce more reasonable results might be to ask whether that paradigm is
> still a valid one.

Well, it's certainly the most common one, but having more than two
windows in a frame isn't unheard of, either.

> If we don't want to do that, we can try to do some cosmetics in the size
> restoring mechanism.  Basically, that mechanism is used when you display
> a temporary buffer in a two windows layout and you have
> 'temp-buffer-resize-mode' enabled.  Suppose with emacs -Q you enable
> that mode and type C-h f push RET and then C-x 4 f to find some file.
> This will re-enlarge the window used for showing the 'push' help to its
> prior size so you get what you intend for showing that file.

I think that makes sense...  if you have that mode enabled.  But if
you're not asking Emacs to resize windows in this way, then having
`display-buffer' resizing windows is somewhat confusing.

> If we want 'display-buffer-use-some-window' to not do such size
> restorations, we can just add a 'do-no-restore-size' alist entry and an
> appropriate check like
>
>       (when (and (not (cdr (assq 'do-no-restore-size alist)))
>                  (listp quad)
>                  (integerp (nth 3 quad))
>                  (> (nth 3 quad) (window-total-height window)))
>
> 'display-buffer-use-least-recent-window' (and/or the application/user)
> could then set that entry at their like.

Makes sense.

>> In related news, get-lru-window doesn't seem to work reliably?  I don't
>> have a reproducer for that, either, but it seems to happen if I have a
>> three window frame, and I call:
>>
>> (setq lru (get-lru-window (selected-frame) nil t))
>> (window-bump-use-time lru)
>> (get-lru-window (selected-frame) nil t)
>>
>> will then return the same window as `lru'...
>
> How do you "call"?  I suppose there's no chance to make another window
> but the selected one the mru one.  We would have to look into the inner
> workings of that "call".

eval the expressions.

--=20
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#45688; Package emacs. Full text available.

Message received at 45688 <at> debbugs.gnu.org:


Received: (at 45688) by debbugs.gnu.org; 19 Jan 2021 03:20:25 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Jan 18 22:20:25 2021
Received: from localhost ([127.0.0.1]:48958 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1l1hZB-0003C8-Cg
	for submit <at> debbugs.gnu.org; Mon, 18 Jan 2021 22:20:25 -0500
Received: from quimby.gnus.org ([95.216.78.240]:53472)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1l1hZA-0003Bq-CL
 for 45688 <at> debbugs.gnu.org; Mon, 18 Jan 2021 22:20:24 -0500
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnus.org;
 s=20200322; h=Content-Type:MIME-Version:Message-ID:In-Reply-To:Date:
 References:Subject:Cc:To:From:Sender:Reply-To:Content-Transfer-Encoding:
 Content-ID:Content-Description:Resent-Date:Resent-From:Resent-Sender:
 Resent-To:Resent-Cc:Resent-Message-ID:List-Id:List-Help:List-Unsubscribe:
 List-Subscribe:List-Post:List-Owner:List-Archive;
 bh=0b7mlT7zXVtHtQ3Q3q6CdOyjsmOlYvwHEa00h6EZYFs=; b=tCI1o6QPx7/qKRrrD3MKdfJ8Oo
 jQLnrwXGMFo/rmG0mTpTGu56wyFopIezDxGxtYy4Cpdfg+2Or1rknUNcHwbaiTGAHd/srCT04Uwbd
 GhYRE2aGTNYaspb6BA+Os9/f/vzoUukWAV4FdPZnM6q6DzcmqaMarJR4MCpkjnuL6Aps=;
Received: from cm-84.212.202.86.getinternet.no ([84.212.202.86] helo=xo)
 by quimby.gnus.org with esmtpsa (TLS1.3:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.92) (envelope-from <larsi@HIDDEN>)
 id 1l1hYu-0002mO-78; Tue, 19 Jan 2021 04:20:18 +0100
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: martin rudalics <rudalics@HIDDEN>
Subject: Re: bug#45688: 28.0.50; New action for display-buffer?
References: <87im8a1dff.fsf@HIDDEN> <83y2h6133r.fsf@HIDDEN>
 <8735ze0yp7.fsf@HIDDEN> <83o8i20w1f.fsf@HIDDEN>
 <87lfd5yny9.fsf@HIDDEN>
 <a25dc85e-cd8e-8164-676e-bb6a0f381c06@HIDDEN>
 <87o8i03gem.fsf@HIDDEN>
 <528b7d6b-403a-ffef-b0a0-4a0b6d92bec8@HIDDEN>
 <87turpvxv0.fsf@HIDDEN>
 <fe796e77-3248-b3fc-0f1b-35b12761e860@HIDDEN>
 <fb97d5c9-91eb-b8ce-5639-1a875bf40ae9@HIDDEN>
 <87turnh6u8.fsf@HIDDEN>
 <b9059f39-b3af-3ec7-c0ee-d1a493a3a2f5@HIDDEN>
 <c42c070f-8948-1583-4011-0ee97650e1fe@HIDDEN>
X-Now-Playing: Ultra =?utf-8?Q?Nat=C3=A9's?= _Blue Notes in the Basement_:
 "Funny (How Things Change)"
Date: Tue, 19 Jan 2021 04:20:06 +0100
In-Reply-To: <c42c070f-8948-1583-4011-0ee97650e1fe@HIDDEN> (martin rudalics's
 message of "Mon, 11 Jan 2021 19:55:03 +0100")
Message-ID: <87czy1sjdl.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview: martin rudalics <rudalics@HIDDEN> writes: > Just found a
 related
 bug in the code. When 'display-buffer' makes a new > window on the left or
 right, it sets that value to the window's width > which doesn't make any
 sense. The current code can h [...] 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 45688
Cc: 45688 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

martin rudalics <rudalics@HIDDEN> writes:

> Just found a related bug in the code.  When 'display-buffer' makes a new
> window on the left or right, it sets that value to the window's width
> which doesn't make any sense.  The current code can handle only height
> values as for 'shrink-window-if-larger-than-buffer' or the default
> 'fit-window-to-buffer'.  So please use the patch attached here.

That one seems to fix the reproducer, too.

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#45688; Package emacs. Full text available.

Message received at 45688 <at> debbugs.gnu.org:


Received: (at 45688) by debbugs.gnu.org; 12 Jan 2021 18:51:23 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Jan 12 13:51:23 2021
Received: from localhost ([127.0.0.1]:33133 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kzOlH-0003nE-Ff
	for submit <at> debbugs.gnu.org; Tue, 12 Jan 2021 13:51:23 -0500
Received: from relay7-d.mail.gandi.net ([217.70.183.200]:55113)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <juri@HIDDEN>) id 1kzOlF-0003mR-Ut
 for 45688 <at> debbugs.gnu.org; Tue, 12 Jan 2021 13:51:22 -0500
X-Originating-IP: 91.129.98.64
Received: from mail.gandi.net (m91-129-98-64.cust.tele2.ee [91.129.98.64])
 (Authenticated sender: juri@HIDDEN)
 by relay7-d.mail.gandi.net (Postfix) with ESMTPSA id 641442000C;
 Tue, 12 Jan 2021 18:51:13 +0000 (UTC)
From: Juri Linkov <juri@HIDDEN>
To: Lars Ingebrigtsen <larsi@HIDDEN>
Subject: Re: bug#45688: 28.0.50; New action for display-buffer?
Organization: LINKOV.NET
References: <87im8a1dff.fsf@HIDDEN> <83y2h6133r.fsf@HIDDEN>
 <8735ze0yp7.fsf@HIDDEN> <83o8i20w1f.fsf@HIDDEN>
 <87lfd5yny9.fsf@HIDDEN> <87ft3cpoy9.fsf@HIDDEN>
 <6859d73c-da77-af77-481f-3046d5195d53@HIDDEN>
 <87pn2dvxqi.fsf@HIDDEN>
Date: Tue, 12 Jan 2021 20:36:33 +0200
In-Reply-To: <87pn2dvxqi.fsf@HIDDEN> (Lars Ingebrigtsen's message of "Sun,
 10 Jan 2021 12:26:45 +0100")
Message-ID: <87v9c2rpfi.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (x86_64-pc-linux-gnu)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 45688
Cc: martin rudalics <rudalics@HIDDEN>, 45688 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

>> We're asking too much from 'display-buffer' here.  It can't second-guess
>> a user's intentions in particular with the interpretation of grep and
>> xref hits.  I see three basic patterns here:
>
> I'm wondering whether there should be a separate
> `display-buffer-command' that's bound to `C-x 4 C-o' with its own
> display rules.  :-)  That is, when the user is using this command
> explicitly, then it's not obvious that the user wants the same rules as
> with the "automatic" display-buffer stuff (popping from *grep* buffers
> and the like).

Currently I'm using windmove-display-* group of commands to
instruct display-buffer where I want to display the buffer, e.g.:

's-<down> C-o' to open a grep/xref hit in the bottom window,
's-<left> C-o' to open a grep/xref hit in the left window, etc.

It's quite tedious to type that prefix before every key that
visits a grep hit.  What is still missing is some kind of DWIM
to make display-buffer smarter.

Here is what seems to work to visit grep/xref hits in the same window
where all previous hits were visited:

#+begin_src emacs-lisp
(defun display-buffer-from-grep-p (_buffer-name _action)
  (with-current-buffer (window-buffer)
    (derived-mode-p 'compilation-mode)))

(push '(display-buffer-from-grep-p display-buffer-reuse-previous-window)
      display-buffer-alist)

(defvar-local display-buffer-previous-window nil)

(defun display-buffer-reuse-previous-window (buffer alist)
  "Display BUFFER in the same window that was already used as destination."
  (let ((window display-buffer-previous-window))
    (if (window-live-p window)
        (window--display-buffer buffer window 'reuse alist)
      (setq window (display-buffer-use-some-window
                    buffer (cons (cons 'inhibit-same-window t) alist)))
      (setq-local display-buffer-previous-window window)
      window)))
#+end_src

One problem is that other display-buffer actions don't set
'display-buffer-previous-window'.  It would be nice to do
this in some low-level function in window.el.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#45688; Package emacs. Full text available.

Message received at 45688 <at> debbugs.gnu.org:


Received: (at 45688) by debbugs.gnu.org; 12 Jan 2021 09:06:56 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Jan 12 04:06:56 2021
Received: from localhost ([127.0.0.1]:59249 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kzFdf-0004DL-W5
	for submit <at> debbugs.gnu.org; Tue, 12 Jan 2021 04:06:56 -0500
Received: from mout.gmx.net ([212.227.15.18]:34001)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <rudalics@HIDDEN>) id 1kzFdd-0004D1-I0
 for 45688 <at> debbugs.gnu.org; Tue, 12 Jan 2021 04:06:54 -0500
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=gmx.net;
 s=badeba3b8450; t=1610442407;
 bh=i0thByFna1yR664jb9Amtw0BPYCJpWROK2332+l92Xk=;
 h=X-UI-Sender-Class:Subject:To:Cc:References:From:Date:In-Reply-To;
 b=SzhFx0fJlrINYntITVq66m2/GzO/BrGMFPb+MP9uojfnUrOm7hcrk0mlRaS8haX8p
 2MVq5dZzkeH+DgBmlk4j3HerSFpfd90TiixvruojF1wmyQkhluWrj2uYL9YvfW4/Uv
 OC5fNOi2F8jKm/LrLLAnGvngWcK58aXjSI2/WP2Y=
X-UI-Sender-Class: 01bb95c1-4bf8-414a-932a-4f6e2808ef9c
Received: from [192.168.1.100] ([46.125.249.21]) by mail.gmx.com (mrgmx004
 [212.227.17.190]) with ESMTPSA (Nemesis) id 1MAONd-1koV3c0TiF-00BsBB; Tue, 12
 Jan 2021 10:06:47 +0100
Subject: Re: bug#45688: 28.0.50; New action for display-buffer?
To: Lars Ingebrigtsen <larsi@HIDDEN>
References: <87im8a1dff.fsf@HIDDEN> <83y2h6133r.fsf@HIDDEN>
 <8735ze0yp7.fsf@HIDDEN> <83o8i20w1f.fsf@HIDDEN> <87lfd5yny9.fsf@HIDDEN>
 <a25dc85e-cd8e-8164-676e-bb6a0f381c06@HIDDEN> <87o8i03gem.fsf@HIDDEN>
 <528b7d6b-403a-ffef-b0a0-4a0b6d92bec8@HIDDEN> <87turpvxv0.fsf@HIDDEN>
 <fe796e77-3248-b3fc-0f1b-35b12761e860@HIDDEN>
 <fb97d5c9-91eb-b8ce-5639-1a875bf40ae9@HIDDEN> <87turnh6u8.fsf@HIDDEN>
 <b9059f39-b3af-3ec7-c0ee-d1a493a3a2f5@HIDDEN> <87im83cn02.fsf@HIDDEN>
From: martin rudalics <rudalics@HIDDEN>
Message-ID: <568151d0-c8fd-1643-56a7-87ff36ce234d@HIDDEN>
Date: Tue, 12 Jan 2021 10:06:45 +0100
MIME-Version: 1.0
In-Reply-To: <87im83cn02.fsf@HIDDEN>
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Language: en-US
Content-Transfer-Encoding: quoted-printable
X-Provags-ID: V03:K1:lJhhT+CD47utTjbGJGN5VasLC+iLyc89uPbHmTU02ShGSTuQi0P
 wgLilVJ7yzBuyvzaVc3Dgv5cZVU/4NinLwnwqbGIHcopBeiE5xISIia4Min+bq0AQTULOzk
 4eQu0FCgdsMbjboGCVJRue4iOxyaO4+XGLpT4D0nTNddNPuLmMFdG3rkChMvzIOFxR4J84v
 USOrUWrOhzAqcQm0WpzKg==
X-Spam-Flag: NO
X-UI-Out-Filterresults: notjunk:1;V03:K0:v+Tshi86KZE=:mITdIgXdwWcUNvyCL5Zina
 5WhFBfipDCw9j+5EG0ZLB/OWqdhG1CKqDPPEGb1Do7qHV4iJy/RM8wcOS+S9JvR/ffFeYLEoJ
 31fK+VnYUwmNyOYnlOlvuUI8kjeLA9UhTohddtDxpkdiQdS2X3Vx2A0wPA8HwxoSU8MiwpsAg
 /h457WVHz/uhYw2XFcgmvAomNC2/tgoTTB0XwQQTFuWJrbTy8ProQcCk1TCDtadEjne1A6uHF
 zFFIZRAzxKrw+MB5ctKar+AitVwfsz4y5gTXEassGQWPe87+dxmtWQrRTciECWfDOEhoFS/o6
 BF+RMpiYmSN96FAhm8PDk+Hg/+k+Z1TU4TElisBMFzDBVhPMHTHoKz/rvnLUmir7/uq0Kqczm
 EBw//JCJHplpUA5QCIrGwACdlwrQihzbk7oabTf5nLj0wg9V0nsF5dSsw+W9QBfs4ybnB42Bc
 D9zMEiavV08/Eo95vz54YEm3krzanolyKvtgV4r5IeTMoEjBxtqllwLC5+CZtEaUtWhd0lx7P
 d8aAq9oNnKK+QyNAvZc0oR4km5ImUyJs4enu935cXvBWtskP3D/yYjcnZLkjhVo3hCVpJrKeD
 iRGf5d8B6G3M1eTMglppzt7mUMfkuVK8OOM411sX8UTRFOIiodoUZM5v3cNyCE1bvAPpRylWR
 oM+WXxFL3WcNiX0pbLk1dMo4AvaQyubqV1uTHyPdpdElNdOkOkeaW6b0BXcN/Fq2P7VUPFvS+
 p5j3kr2W3mt9R3Mxru1e5SroQHaevhUrUDvHBTTAyTHIGkQ+KOcRot/52apBJdCe6DmfUZ8J7
 Vq4SOaRrShIcI0tfr7ekm3UoQhzmCiLYZ1HLUZznTH9t/ZvK0ZCacwurrW74R1p+JM7nfiT/l
 iAGR34YQCem/NElqvDtw==
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 45688
Cc: Eli Zaretskii <eliz@HIDDEN>, 45688 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

 > This fixes the reproducer, but not the case of actually jumping around=

 > manually -- `M-x display-buffer' sometimes chooses to resize the
 > windows.  :-/

Have you ever read the Elisp manual where it says

      =E2=80=98display-buffer=E2=80=99 is not overly well suited for disp=
laying several
      buffers in sequence and making sure that all these buffers are
      shown orderly in the resulting window configuration.  Again, the
      standard action functions =E2=80=98display-buffer-pop-up-window=E2=80=
=99 and
      =E2=80=98display-buffer-use-some-window=E2=80=99 are not very suite=
d for this
      purpose due to their somewhat chaotic nature in more complex
      configurations.

Maybe you bumped into this with your experiments, in particular when
trying to reuse a window that you've already used before.

'display-buffer' still lives in the paradigm of <=3D 2 windows frames set=

up in the past century and probably still the only reasonable one for
TTY frames.  For that it supports things like 'even-window-heights' and
a 'split-height-threshold' of 80 with its "If, however, a window is the
only window on its frame, or all the other ones are dedicated,
=E2=80=98split-window-sensibly=E2=80=99 may split it vertically disregard=
ing the value
of this variable." exception.  Hence a first step to get your rampages
produce more reasonable results might be to ask whether that paradigm is
still a valid one.

If we don't want to do that, we can try to do some cosmetics in the size
restoring mechanism.  Basically, that mechanism is used when you display
a temporary buffer in a two windows layout and you have
'temp-buffer-resize-mode' enabled.  Suppose with emacs -Q you enable
that mode and type C-h f push RET and then C-x 4 f to find some file.
This will re-enlarge the window used for showing the 'push' help to its
prior size so you get what you intend for showing that file.

If we want 'display-buffer-use-some-window' to not do such size
restorations, we can just add a 'do-no-restore-size' alist entry and an
appropriate check like

       (when (and (not (cdr (assq 'do-no-restore-size alist)))
                  (listp quad)
                  (integerp (nth 3 quad))
                  (> (nth 3 quad) (window-total-height window)))

'display-buffer-use-least-recent-window' (and/or the application/user)
could then set that entry at their like.

 > In related news, get-lru-window doesn't seem to work reliably?  I don'=
t
 > have a reproducer for that, either, but it seems to happen if I have a=

 > three window frame, and I call:
 >
 > (setq lru (get-lru-window (selected-frame) nil t))
 > (window-bump-use-time lru)
 > (get-lru-window (selected-frame) nil t)
 >
 > will then return the same window as `lru'...

How do you "call"?  I suppose there's no chance to make another window
but the selected one the mru one.  We would have to look into the inner
workings of that "call".

martin





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#45688; Package emacs. Full text available.

Message received at 45688 <at> debbugs.gnu.org:


Received: (at 45688) by debbugs.gnu.org; 11 Jan 2021 19:06:08 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Jan 11 14:06:08 2021
Received: from localhost ([127.0.0.1]:58275 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kz2W0-0002a9-9b
	for submit <at> debbugs.gnu.org; Mon, 11 Jan 2021 14:06:08 -0500
Received: from quimby.gnus.org ([95.216.78.240]:56354)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1kz2Vx-0002Za-76
 for 45688 <at> debbugs.gnu.org; Mon, 11 Jan 2021 14:06:07 -0500
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnus.org;
 s=20200322; h=Content-Type:MIME-Version:Message-ID:In-Reply-To:Date:
 References:Subject:Cc:To:From:Sender:Reply-To:Content-Transfer-Encoding:
 Content-ID:Content-Description:Resent-Date:Resent-From:Resent-Sender:
 Resent-To:Resent-Cc:Resent-Message-ID:List-Id:List-Help:List-Unsubscribe:
 List-Subscribe:List-Post:List-Owner:List-Archive;
 bh=DdM0clVk93T2ktNbYbg9Q85u+EUZqwgyGtZBou+swmo=; b=gZipbQUbc8ZDdn9rrBAya5TK/4
 FWE0jj1YKastQ6mm+JswVV7TwS/ziNung/5wXGK5frBwBF7OKcAbX7aexBME1sbT2o3IxFgF7Udhw
 p00vnzd26WyDZWNBGh8PYWhpIZzP2VaAMeymxLQtBoE3iIntEs7QeCGc/krWnTwTXfKA=;
Received: from cm-84.212.202.86.getinternet.no ([84.212.202.86] helo=xo)
 by quimby.gnus.org with esmtpsa (TLS1.3:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.92) (envelope-from <larsi@HIDDEN>)
 id 1kz2Vi-0001og-Vc; Mon, 11 Jan 2021 20:05:58 +0100
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: martin rudalics <rudalics@HIDDEN>
Subject: Re: bug#45688: 28.0.50; New action for display-buffer?
References: <87im8a1dff.fsf@HIDDEN> <83y2h6133r.fsf@HIDDEN>
 <8735ze0yp7.fsf@HIDDEN> <83o8i20w1f.fsf@HIDDEN>
 <87lfd5yny9.fsf@HIDDEN>
 <a25dc85e-cd8e-8164-676e-bb6a0f381c06@HIDDEN>
 <87o8i03gem.fsf@HIDDEN>
 <528b7d6b-403a-ffef-b0a0-4a0b6d92bec8@HIDDEN>
 <87turpvxv0.fsf@HIDDEN>
 <fe796e77-3248-b3fc-0f1b-35b12761e860@HIDDEN>
 <fb97d5c9-91eb-b8ce-5639-1a875bf40ae9@HIDDEN>
 <87turnh6u8.fsf@HIDDEN>
 <b9059f39-b3af-3ec7-c0ee-d1a493a3a2f5@HIDDEN>
X-Now-Playing: The Home Current's _Scarred For Life 2_: "Unknown Sameness"
Date: Mon, 11 Jan 2021 20:05:49 +0100
In-Reply-To: <b9059f39-b3af-3ec7-c0ee-d1a493a3a2f5@HIDDEN> (martin rudalics's
 message of "Mon, 11 Jan 2021 19:23:23 +0100")
Message-ID: <87im83cn02.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview: martin rudalics <rudalics@HIDDEN> writes: >> Here's a
 reproducer
 from emacs -Q: >> >> (progn >> (setq display-buffer-alist '((".*" >>
 display-buffer-use-least-recent-window)))
 >> (pop-to-buffer "file1") >> (pop-to-buffer "file2") >> (split-wi [...] 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 45688
Cc: Eli Zaretskii <eliz@HIDDEN>, 45688 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

martin rudalics <rudalics@HIDDEN> writes:

>> Here's a reproducer from emacs -Q:
>>
>> (progn
>>    (setq display-buffer-alist '((".*"
>> display-buffer-use-least-recent-window)))
>>    (pop-to-buffer "file1")
>>    (pop-to-buffer "file2")
>>    (split-window-below)
>>    (pop-to-buffer "file3"))
>>
>> I end up with the following, and file3 in an oddly large window.
>
> So you have been splicing in a 'split-window-below' between those calls.
> Why didn't you tell me before?

I wasn't -- I was jumping around between windows manually, but that's
the reproducer I came up with.

> 'split-window-below' copies the
> 'quit-restore' parameter to the new window and that's what you get.
>
> Let's try to clean up the height value when copying the 'quit-restore'
> parameter as attached.

This fixes the reproducer, but not the case of actually jumping around
manually -- `M-x display-buffer' sometimes chooses to resize the
windows.  :-/

In related news, get-lru-window doesn't seem to work reliably?  I don't
have a reproducer for that, either, but it seems to happen if I have a
three window frame, and I call:

(setq lru (get-lru-window (selected-frame) nil t))
(window-bump-use-time lru)
(get-lru-window (selected-frame) nil t)

will then return the same window as `lru'...

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#45688; Package emacs. Full text available.

Message received at 45688 <at> debbugs.gnu.org:


Received: (at 45688) by debbugs.gnu.org; 11 Jan 2021 18:55:14 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Jan 11 13:55:14 2021
Received: from localhost ([127.0.0.1]:58251 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kz2LR-0002IW-R1
	for submit <at> debbugs.gnu.org; Mon, 11 Jan 2021 13:55:14 -0500
Received: from mout.gmx.net ([212.227.15.15]:40417)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <rudalics@HIDDEN>) id 1kz2LP-0002IE-DK
 for 45688 <at> debbugs.gnu.org; Mon, 11 Jan 2021 13:55:12 -0500
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=gmx.net;
 s=badeba3b8450; t=1610391305;
 bh=PKHF48mdYPo9dNkCnxnYL+bJF/WLYlARnm/rjKBanP8=;
 h=X-UI-Sender-Class:Subject:From:To:Cc:References:Date:In-Reply-To;
 b=YgepkJcVZGslc9B7qAGMng0YnMN7ow9XHJTNB88BDDRhPrToBpDqiXxnLUvu0ZmGA
 5eoTm5rXcIqenQJ20fBoO6uQx1aa34wpQi4dJ/CmuReuU+sHcypChFFMZpM81fxeg5
 vBAAJCFSkDjaU8KTq6Pd8QeTMXT4CGxrZN5ueUBQ=
X-UI-Sender-Class: 01bb95c1-4bf8-414a-932a-4f6e2808ef9c
Received: from [192.168.1.100] ([212.95.5.67]) by mail.gmx.com (mrgmx005
 [212.227.17.190]) with ESMTPSA (Nemesis) id 1MiaY9-1kL0EZ3eGl-00fhJ5; Mon, 11
 Jan 2021 19:55:04 +0100
Subject: Re: bug#45688: 28.0.50; New action for display-buffer?
From: martin rudalics <rudalics@HIDDEN>
To: Lars Ingebrigtsen <larsi@HIDDEN>
References: <87im8a1dff.fsf@HIDDEN> <83y2h6133r.fsf@HIDDEN>
 <8735ze0yp7.fsf@HIDDEN> <83o8i20w1f.fsf@HIDDEN> <87lfd5yny9.fsf@HIDDEN>
 <a25dc85e-cd8e-8164-676e-bb6a0f381c06@HIDDEN> <87o8i03gem.fsf@HIDDEN>
 <528b7d6b-403a-ffef-b0a0-4a0b6d92bec8@HIDDEN> <87turpvxv0.fsf@HIDDEN>
 <fe796e77-3248-b3fc-0f1b-35b12761e860@HIDDEN>
 <fb97d5c9-91eb-b8ce-5639-1a875bf40ae9@HIDDEN> <87turnh6u8.fsf@HIDDEN>
 <b9059f39-b3af-3ec7-c0ee-d1a493a3a2f5@HIDDEN>
Message-ID: <c42c070f-8948-1583-4011-0ee97650e1fe@HIDDEN>
Date: Mon, 11 Jan 2021 19:55:03 +0100
MIME-Version: 1.0
In-Reply-To: <b9059f39-b3af-3ec7-c0ee-d1a493a3a2f5@HIDDEN>
Content-Type: multipart/mixed; boundary="------------E578D16EBCC62219B76301A0"
Content-Language: en-US
X-Provags-ID: V03:K1:fsLotdLTdszE4veVBgI2wIqrhiyCXDHEYcQb/Ct3e2klYd6UafV
 JRlozn+QxTaOPWvTiI+BfKx7w/1fY65qJ9ZqdTTqJ1nzCCt1bcaafl4DSFWN2IXJJ+r9Gv2
 0p95M0fHwXZD80O4f6L3X2ttjG2+4Kgx5/kFjHBLwwc93sxjfbZMYIibp1llroo89riVbZ1
 54ySikov9KCfGI06CL/6w==
X-Spam-Flag: NO
X-UI-Out-Filterresults: notjunk:1;V03:K0:2tH6IxpHFs4=:WgJGQotngrmCl9sbEpmLY7
 Psf1U/NrHz1egY40dURuc6OWzafVf2eeEhyEDsnLFqllbir//86T1AagIBH+1lGAvH5iqf0x+
 M+iZ4/wAmJ9JGwcgPdoEzDYLZd2b4V5ZBzRKSLEtXMXuTDAt7iKv6QV/zk1kXUBVtgg4IPHAM
 /iFXxqgkEDmgxBGdRGI/Uqq1QRsMr4dZ5M83x1FB7zY3bJtbEOrR2H+fXPPlLxmAu1X6b9Cld
 avv9Fj/qFg3B5Xo/NYEIwvm+A6T0cKO3e5wtH8++ngIJL7kLoOr+Nsp1xgH4ygju32uk4H4Pw
 P5KqawUueMwUIySi9nnbwZ2amIWme1eEJrFh/j4b7fKZgyUPNxzjdgomeWxVRW7QdxJvLhPoi
 XwmBEfHr6Mk3sp73g7ErVkhPD517Anx1Ix/dv2oaVC7gvpJEttr78dq2oFGjvwcqCdWctuKNl
 JeEDtN7w7aBwbfkIw+SknVLO0X78TMmZmr6Mm+CHTX5vozgBfYUvmBM3OJ67gUMVdjBeq6/VO
 kmjLNiFi3H3hH3zZte22F9nJ+tGRnQFP7A1q5Zk38/uYDFhIbT41PQRzkGRi+xuHN2cn8ybVL
 0YemgjYefywK0AyFULA3QkJIXBqTLRdZAM2UhOt1A/apvwV1HP4aiBfk1gJh/hmRtTlLFmhuX
 Qk99qt8LXr6hfMGR8ml2iie6RcBDT1XPuZWQya+QHljoQ4IvBsw3u9cPaNPZ5fNWD5NmyP6Rv
 tgzpvictUETAooX+ejq28qvd/Xk/a0LdSZ138TqDS8WlPHv8tENuoBGpgS7bOqwGUg8hIcouA
 VDxhMRC7v6W1mTZTvjt1wXLa7JvHLjKUWCbmItRruDeBjB3R1QU4rW4Pkm1AOcAbIZXzWMHrj
 8NMfjLL3tMC0QJMlND3Q==
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 45688
Cc: 45688 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

This is a multi-part message in MIME format.
--------------E578D16EBCC62219B76301A0
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Transfer-Encoding: 7bit

 > Let's try to clean up the height value when copying the 'quit-restore'
 > parameter as attached.

Just found a related bug in the code.  When 'display-buffer' makes a new
window on the left or right, it sets that value to the window's width
which doesn't make any sense.  The current code can handle only height
values as for 'shrink-window-if-larger-than-buffer' or the default
'fit-window-to-buffer'.  So please use the patch attached here.

martin

--------------E578D16EBCC62219B76301A0
Content-Type: text/x-patch;
 name="split-window-quit-restore.diff"
Content-Transfer-Encoding: quoted-printable
Content-Disposition: attachment;
 filename="split-window-quit-restore.diff"

diff --git a/lisp/window.el b/lisp/window.el
index a6cdd4dec2..c09d9532e3 100644
=2D-- a/lisp/window.el
+++ b/lisp/window.el
@@ -5543,10 +5543,12 @@ split-window-below
 Otherwise, the window starts are chosen so as to minimize the
 amount of redisplay; this is convenient on slow terminals."
   (interactive "P")
-  (let ((old-window (selected-window))
-	(old-point (window-point))
-	(size (and size (prefix-numeric-value size)))
-        moved-by-window-height moved new-window bottom)
+  (let* ((old-window (selected-window))
+	 (old-point (window-point))
+	 (size (and size (prefix-numeric-value size)))
+         (quit-restore (window-parameter old-window 'quit-restore))
+	 (quad (nth 1 quit-restore))
+         moved-by-window-height moved new-window bottom)
     (when (and size (< size 0) (< (- size) window-min-height))
       ;; `split-window' would not signal an error here.
       (error "Size of new window too small"))
@@ -5574,10 +5576,18 @@ split-window-below
 	     (<=3D (window-start new-window) old-point)
 	     (set-window-point new-window old-point)
 	     (select-window new-window))))
-    ;; Always copy quit-restore parameter in interactive use.
-    (let ((quit-restore (window-parameter old-window 'quit-restore)))
-      (when quit-restore
-	(set-window-parameter new-window 'quit-restore quit-restore)))
+
+    (when quit-restore
+      (when (and (listp quad) (integerp (nth 3 quad)))
+        ;; nth 3 of quad is the old-window height of OLD-WINDOW.  This
+        ;; value is meaningless in NEW-WINDOW so set it to the present
+        ;; height of NEW-WINDOW.
+        (setq quit-restore (copy-tree quit-restore))
+        (rplaca (cdddr (nth 1 quit-restore))
+                (window-total-height new-window)))
+
+      (set-window-parameter new-window 'quit-restore quit-restore))
+
     new-window))

 (defalias 'split-window-vertically 'split-window-below)
@@ -6440,9 +6450,7 @@ display-buffer-record-window
 		     ;; Preserve window-point-insertion-type (Bug#12855).
 		     (copy-marker
 		      (window-point window) window-point-insertion-type)
-		     (if (window-combined-p window)
-                         (window-total-height window)
-                       (window-total-width window)))
+                     (window-total-height window))
 	       (selected-window) buffer)))))
    ((eq type 'window)
     ;; WINDOW has been created on an existing frame.

--------------E578D16EBCC62219B76301A0--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#45688; Package emacs. Full text available.

Message received at 45688 <at> debbugs.gnu.org:


Received: (at 45688) by debbugs.gnu.org; 11 Jan 2021 18:23:38 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Jan 11 13:23:38 2021
Received: from localhost ([127.0.0.1]:58226 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kz1qr-0001Ut-UY
	for submit <at> debbugs.gnu.org; Mon, 11 Jan 2021 13:23:38 -0500
Received: from mout.gmx.net ([212.227.17.22]:42103)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <rudalics@HIDDEN>) id 1kz1qp-0001Uc-84
 for 45688 <at> debbugs.gnu.org; Mon, 11 Jan 2021 13:23:37 -0500
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=gmx.net;
 s=badeba3b8450; t=1610389408;
 bh=mgGHafDVz5ejemjkKMFhVHVS9y26wBApw2AfsMTxXKc=;
 h=X-UI-Sender-Class:Subject:To:Cc:References:From:Date:In-Reply-To;
 b=Y+1P1LdoQgq6XKKd+H7/3OdhG7d0ZXvbDDK6E3KACykL3yMv1o1sci2SFj16ECSCM
 y7r6dN34VZhXVHfDui13EPKi8XTyNdgonwkvYIaqwzgKfckLqQH/LR5w/nq/zN5ePU
 mgp+FWQNmj0nXTR9AHVsleiWpg4xw5NfnvzoDr1g=
X-UI-Sender-Class: 01bb95c1-4bf8-414a-932a-4f6e2808ef9c
Received: from [192.168.1.100] ([212.95.5.67]) by mail.gmx.com (mrgmx104
 [212.227.17.168]) with ESMTPSA (Nemesis) id 1MSc1B-1kWogL1CPp-00StCY; Mon, 11
 Jan 2021 19:23:28 +0100
Subject: Re: bug#45688: 28.0.50; New action for display-buffer?
To: Lars Ingebrigtsen <larsi@HIDDEN>
References: <87im8a1dff.fsf@HIDDEN> <83y2h6133r.fsf@HIDDEN>
 <8735ze0yp7.fsf@HIDDEN> <83o8i20w1f.fsf@HIDDEN> <87lfd5yny9.fsf@HIDDEN>
 <a25dc85e-cd8e-8164-676e-bb6a0f381c06@HIDDEN> <87o8i03gem.fsf@HIDDEN>
 <528b7d6b-403a-ffef-b0a0-4a0b6d92bec8@HIDDEN> <87turpvxv0.fsf@HIDDEN>
 <fe796e77-3248-b3fc-0f1b-35b12761e860@HIDDEN>
 <fb97d5c9-91eb-b8ce-5639-1a875bf40ae9@HIDDEN> <87turnh6u8.fsf@HIDDEN>
From: martin rudalics <rudalics@HIDDEN>
Message-ID: <b9059f39-b3af-3ec7-c0ee-d1a493a3a2f5@HIDDEN>
Date: Mon, 11 Jan 2021 19:23:23 +0100
MIME-Version: 1.0
In-Reply-To: <87turnh6u8.fsf@HIDDEN>
Content-Type: multipart/mixed; boundary="------------F31D7A4D2398D283E065F2C5"
Content-Language: en-US
X-Provags-ID: V03:K1:1xr8veRxZbc2tADHeSrpYSrIT3aZlTzXIAumlEj2Z1s98NvvmX9
 ATwplSpkedvo1YGTYNCvo7jK791a+nawvFu7rIjH5AWCQuYZQV6MMzK9ttMIcRgTw90YmQj
 srgFEsLMcJw0bVlHFGKmV0trJsR7+rSkR9HD2BqUVELcOdZKRklaxdvYRU7s//NBrJr57aI
 ODAWpaTYs3B7Um//X5ufg==
X-Spam-Flag: NO
X-UI-Out-Filterresults: notjunk:1;V03:K0:HtmXS1Mg8+4=:7JLW/v5EInF6Mw8dkk156Z
 L2X1HWpqQMsvNthRaFvN5CSf2YLVjafjq9uyvwP4Owq5DD6N5l1TDZZ9iZjW3Cx4hH1Gc9lYi
 q9/zBuhrp11d4BX1csDQ2dzAHrxF7iBoMKlG7SA+BYPxdPgBT/izd+MZWZvSv/hoxt3fcP/Lv
 K5p9ms2HJ7DfdziJgEYFDn447aLaQVT1sxqL9k3p8838gbsa60pQoS1V2LlQ5o+ieu+ibNBOq
 wbJgsa8ASA5BS5l86683KAFjy8XbrtrkWyu7tsL3AEEl70cZsB7bqVUhmg5vB27LZD9zr19b3
 cl+jHP94B8ZhREr2oymtABevXYaFhJiZ8AOpFKe4q87Nt2D9YVNzUrWz2uvDQtSVQzOEMd8ke
 DcbvK7hUONpLeCRrdJdazGMovMTGB5Km+XoOFRUWx5d4qGWvkbf5KoGBGHbwlh7LRcz4wqacY
 1sylrNd/CMRgMTHgEqkSg6v1GrrXnZl4rvuOGYLXUjf/ixDbSWYtfuCzOv3waoWzjFaXz9we3
 Wrn9rJLdEIsJkvushnDrPyf/kc1phx/4gS5+6VkwxCycBjVVn9mZS5n7SEf+TdjZc34waVUcS
 Ym8HDGLQtITWaqJA1Kw94FF0kVFdIMQyPXWs2iexJcqLQfKvPpg7JgzJUHo80RJf76HFFZrs4
 MPX/51cMiOoIZwxrWritu2noGWEM4Up9XOwsNXgHDIvr3xdCmWlXfqC8CA7uSOrGUy8+X+DKN
 2/GbKN5NUCkMXBrDk0tIpFKg0MW259JjdDD0pAWwLnKbWQrIIEdhQO/B04uML4XfNQsaTX+PE
 1XKlQvLXf7cib6PGhSgTmnP1Wy9AXNSAXcUr8Qf6Y6cd8HQ8lPaRZ3lNpl4v7sNrA6Q42eeDh
 Sqzf5hpeW+lWYq5a8kqw==
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 45688
Cc: Eli Zaretskii <eliz@HIDDEN>, 45688 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

This is a multi-part message in MIME format.
--------------F31D7A4D2398D283E065F2C5
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Transfer-Encoding: 7bit

 > I put some messaging in that code, and it is indeed that bit that does
 > the resizing.
 >
 > Here's a reproducer from emacs -Q:
 >
 > (progn
 >    (setq display-buffer-alist '((".*" display-buffer-use-least-recent-window)))
 >    (pop-to-buffer "file1")
 >    (pop-to-buffer "file2")
 >    (split-window-below)
 >    (pop-to-buffer "file3"))
 >
 > I end up with the following, and file3 in an oddly large window.

So you have been splicing in a 'split-window-below' between those calls.
Why didn't you tell me before?  'split-window-below' copies the
'quit-restore' parameter to the new window and that's what you get.

Let's try to clean up the height value when copying the 'quit-restore'
parameter as attached.

martin

--------------F31D7A4D2398D283E065F2C5
Content-Type: text/x-patch;
 name="split-window-quit-restore.diff"
Content-Transfer-Encoding: quoted-printable
Content-Disposition: attachment;
 filename="split-window-quit-restore.diff"

diff --git a/lisp/window.el b/lisp/window.el
index a6cdd4dec2..8651d7502f 100644
=2D-- a/lisp/window.el
+++ b/lisp/window.el
@@ -5528,6 +5528,24 @@ split-window-keep-point
   :type 'boolean
   :group 'windows)

+(defun window--split-window-quit-restore (old-window new-window)
+  "Copy 'quit-restore' parameter to new window after splitting.
+OLD-WINDOW is the window that was split, NEW-WINDOW is the new
+window.  This cleans up any height value that could be used to
+restore the old height of NEW-WINDOW in a later invocation of
+`display-buffer'."
+  (let* ((quit-restore (window-parameter old-window 'quit-restore))
+	 (quad (nth 1 quit-restore)))
+    (when quit-restore
+      (when (and (listp quad) (integerp (nth 3 quad)))
+        ;; nth 3 of quad is the old-window height of OLD-WINDOW.  This
+        ;; value is meaningless in NEW-WINDOW so set it to the present
+        ;; height of NEW-WINDOW.
+        (setq quit-restore (copy-tree quit-restore))
+        (rplaca (cdddr (nth 1 quit-restore)) (window-total-height new-win=
dow)))
+
+      (set-window-parameter new-window 'quit-restore quit-restore))))
+
 (defun split-window-below (&optional size)
   "Split the selected window into two windows, one above the other.
 The selected window is above.  The newly split-off window is
@@ -5575,9 +5593,7 @@ split-window-below
 	     (set-window-point new-window old-point)
 	     (select-window new-window))))
     ;; Always copy quit-restore parameter in interactive use.
-    (let ((quit-restore (window-parameter old-window 'quit-restore)))
-      (when quit-restore
-	(set-window-parameter new-window 'quit-restore quit-restore)))
+    (window--split-window-quit-restore old-window new-window)
     new-window))

 (defalias 'split-window-vertically 'split-window-below)
@@ -5604,9 +5620,7 @@ split-window-right
       (error "Size of new window too small"))
     (setq new-window (split-window nil size t))
     ;; Always copy quit-restore parameter in interactive use.
-    (let ((quit-restore (window-parameter old-window 'quit-restore)))
-      (when quit-restore
-	(set-window-parameter new-window 'quit-restore quit-restore)))
+    (window--split-window-quit-restore old-window new-window)
     new-window))

 (defalias 'split-window-horizontally 'split-window-right)

--------------F31D7A4D2398D283E065F2C5--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#45688; Package emacs. Full text available.

Message received at 45688 <at> debbugs.gnu.org:


Received: (at 45688) by debbugs.gnu.org; 11 Jan 2021 14:45:37 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Jan 11 09:45:37 2021
Received: from localhost ([127.0.0.1]:56277 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kyyRs-0003og-Q9
	for submit <at> debbugs.gnu.org; Mon, 11 Jan 2021 09:45:37 -0500
Received: from quimby.gnus.org ([95.216.78.240]:53792)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1kyyRo-0003oO-6N
 for 45688 <at> debbugs.gnu.org; Mon, 11 Jan 2021 09:45:36 -0500
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnus.org;
 s=20200322; h=Content-Type:MIME-Version:Message-ID:In-Reply-To:Date:
 References:Subject:Cc:To:From:Sender:Reply-To:Content-Transfer-Encoding:
 Content-ID:Content-Description:Resent-Date:Resent-From:Resent-Sender:
 Resent-To:Resent-Cc:Resent-Message-ID:List-Id:List-Help:List-Unsubscribe:
 List-Subscribe:List-Post:List-Owner:List-Archive;
 bh=ysUGI3CpHm47gO1AMZOwqkZoziLyvxt47bIwcqhjWUM=; b=hrOb4Ha3LDjP1+jskfXxEdQma9
 3jtXg6KJ4NeoMCHWn6ewqMqt40SodCnyIcDiwDjQtZA5lBh2Fq40fpd3ILm79g8/Qei7RTT/lH0Am
 GeAFrzP3YU1KZGRxN0COZdFbWxvnFJW1JRdEeWPH1jcH8cO6oXB3yb01eqPETyuGfOsw=;
Received: from cm-84.212.202.86.getinternet.no ([84.212.202.86] helo=xo)
 by quimby.gnus.org with esmtpsa (TLS1.3:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.92) (envelope-from <larsi@HIDDEN>)
 id 1kyyRf-0007pp-Ut; Mon, 11 Jan 2021 15:45:26 +0100
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: martin rudalics <rudalics@HIDDEN>
Subject: Re: bug#45688: 28.0.50; New action for display-buffer?
References: <87im8a1dff.fsf@HIDDEN> <83y2h6133r.fsf@HIDDEN>
 <8735ze0yp7.fsf@HIDDEN> <83o8i20w1f.fsf@HIDDEN>
 <87lfd5yny9.fsf@HIDDEN>
 <a25dc85e-cd8e-8164-676e-bb6a0f381c06@HIDDEN>
 <87o8i03gem.fsf@HIDDEN>
 <528b7d6b-403a-ffef-b0a0-4a0b6d92bec8@HIDDEN>
 <87turpvxv0.fsf@HIDDEN>
 <fe796e77-3248-b3fc-0f1b-35b12761e860@HIDDEN>
Face: iVBORw0KGgoAAAANSUhEUgAAADAAAAAwBAMAAAClLOS0AAAABGdBTUEAALGPC/xhBQAAACBj
 SFJNAAB6JgAAgIQAAPoAAACA6AAAdTAAAOpgAAA6mAAAF3CculE8AAAAD1BMVEWZmFdZNRefJBvT
 FQ3///9v0t8eAAAAAWJLR0QEj2jZUQAAAAd0SU1FB+UBCw4tCqpdENsAAAGbSURBVDjLZZSJkcMw
 CEXBaQBwAwY1kJX67205JF9xMuOYZwJ8QACAXJeYzV9MENcytzFOFPZysFGX6Qke9jH6Ivi0L0Lp
 IO0GRsVJ8LCPoQvI0z76AuVgTxe4OZjcXOBKqV/BNMHtSe6gHvoYvKsLk8H6CUx3YyvNvKoEfmv5
 N1mwhwwvLWApg5SwGkELKKemu07NWwQBdywgstokrSVglfgf8cxpNocD9MqG2DuQXRAtMHiqCUCr
 PToUdk9KWAniU8A2awotgR3RYzc7sAXUzFG8DYRUYzQCeDTXIdqMEPVJMy/Bg/sLrfdMDWH78/pC
 kwTti8YkUcbWLdsQwC9wtZA8BgP1O/jI180crJUHF2iu5pEu2GabITtrfGSqKC/w5c1jox3+UElN
 sFlnIvGk/WtbAQ/ieqjX5zdBV+BzDgOGdoghCiLSHIao1Ewp2y0ulLU5cDmJPYfjtiLw3o61IfC7
 HnPa8del10K/VnAuYXX5dwdp7rO1lwPNE0Deew7nmbF8TK+zpIbMSw4FrqPkOk7Y1rgDvMj9UPoH
 E0GBZX9haN4AAAAldEVYdGRhdGU6Y3JlYXRlADIwMjEtMDEtMTFUMTQ6NDU6MTArMDA6MDAidOsA
 AAAAJXRFWHRkYXRlOm1vZGlmeQAyMDIxLTAxLTExVDE0OjQ1OjEwKzAwOjAwUylTvAAAAABJRU5E
 rkJggg==
X-Now-Playing: Felix Da Housecat's _Kittenz and The Glitz_: "Harlot"
Date: Mon, 11 Jan 2021 15:45:22 +0100
In-Reply-To: <fe796e77-3248-b3fc-0f1b-35b12761e860@HIDDEN> (martin rudalics's
 message of "Sun, 10 Jan 2021 17:05:36 +0100")
Message-ID: <87pn2bh6rh.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview: martin rudalics <rudalics@HIDDEN> writes: >>> alone will bump
 the use time for a _reused_ window only. A freshly >>> popped up window will
 continue to be the first candidate for reuse and >>> only then enter the
 cycle of windows to reuse. >> [...] 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 45688
Cc: Eli Zaretskii <eliz@HIDDEN>, 45688 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

martin rudalics <rudalics@HIDDEN> writes:

>>> alone will bump the use time for a _reused_ window only.  A freshly
>>> popped up window will continue to be the first candidate for reuse and
>>> only then enter the cycle of windows to reuse.
>>
>> How do we bump the use to for a new window, then?
>
> By bumping the time stamp of _any_ window 'display-buffer' uses for
> displaying a buffer (just like XEmacs does).

But where would we do that?

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#45688; Package emacs. Full text available.

Message received at 45688 <at> debbugs.gnu.org:


Received: (at 45688) by debbugs.gnu.org; 11 Jan 2021 14:44:05 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Jan 11 09:44:05 2021
Received: from localhost ([127.0.0.1]:56271 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kyyQP-0003m2-Ax
	for submit <at> debbugs.gnu.org; Mon, 11 Jan 2021 09:44:05 -0500
Received: from quimby.gnus.org ([95.216.78.240]:53772)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1kyyQM-0003lQ-Oe
 for 45688 <at> debbugs.gnu.org; Mon, 11 Jan 2021 09:44:03 -0500
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnus.org;
 s=20200322; h=Content-Type:MIME-Version:Message-ID:In-Reply-To:Date:
 References:Subject:Cc:To:From:Sender:Reply-To:Content-Transfer-Encoding:
 Content-ID:Content-Description:Resent-Date:Resent-From:Resent-Sender:
 Resent-To:Resent-Cc:Resent-Message-ID:List-Id:List-Help:List-Unsubscribe:
 List-Subscribe:List-Post:List-Owner:List-Archive;
 bh=s8KHlRgrsTUYKqcjo93gm/68efFeRU/D0h/vVUlC5gc=; b=Y9FbEbrfYemgK17cW4BlNKFgyA
 ESaRTg9hXR/ZeaopAk0bRLZY0PNdA1hBDMS4J4LXVrudwdVbxiz+7B65s/jhxxkOUvG5Vtkw3wX8G
 svHMiaO1dtbcqcjtvi6LswFMfHAm4CtS96zyTPKGAGvEPgAFLK+PPSdkGNUHIi6Whhbw=;
Received: from cm-84.212.202.86.getinternet.no ([84.212.202.86] helo=xo)
 by quimby.gnus.org with esmtpsa (TLS1.3:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.92) (envelope-from <larsi@HIDDEN>)
 id 1kyyQ5-0007ok-L1; Mon, 11 Jan 2021 15:43:55 +0100
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: martin rudalics <rudalics@HIDDEN>
Subject: Re: bug#45688: 28.0.50; New action for display-buffer?
References: <87im8a1dff.fsf@HIDDEN> <83y2h6133r.fsf@HIDDEN>
 <8735ze0yp7.fsf@HIDDEN> <83o8i20w1f.fsf@HIDDEN>
 <87lfd5yny9.fsf@HIDDEN>
 <a25dc85e-cd8e-8164-676e-bb6a0f381c06@HIDDEN>
 <87o8i03gem.fsf@HIDDEN>
 <528b7d6b-403a-ffef-b0a0-4a0b6d92bec8@HIDDEN>
 <87turpvxv0.fsf@HIDDEN>
 <fe796e77-3248-b3fc-0f1b-35b12761e860@HIDDEN>
 <fb97d5c9-91eb-b8ce-5639-1a875bf40ae9@HIDDEN>
Face: iVBORw0KGgoAAAANSUhEUgAAADAAAAAwAgMAAAAqbBEUAAAABGdBTUEAALGPC/xhBQAAACBj
 SFJNAAB6JgAAgIQAAPoAAACA6AAAdTAAAOpgAAA6mAAAF3CculE8AAAADFBMVEWEkGrDzLe2R0//
 ///l4gB3AAAAAWJLR0QDEQxM8gAAAAd0SU1FB+UBCw4VJRYTkXkAAAGZSURBVCjPTdHBattAEAbg
 f4eoNDopIOXQU2wopPsUakGH+iQbjah8C0TC9lOkJi1Bp9bYpvikmNqs5yk7K9eQPc2nnZ1dzSBI
 cV5WHAKSy5pB49NuXh6OVfUNVJW85e2xnm/+eDRb3h2b6rQDcdmUHpv/4Hp3rJmnCq4f6t2hmU4X
 oGZ+KX3ypQURnfq7Aw9AkKRnaIaYsnuDXJ4QMDMMa2S7HnmiyK3oRy8PEtBmzJwWojmCd+vE5ymS
 EWjNCRc8dDAlKFKMeea0EijPEi0ws8YjzZJyzSN73aO4LfaDqX3x+B7fRiKrdnnGZCXyod3HFvSj
 KIYitO+W+ivPeT60He2d+wijwP0dxEkAc6X4hEjcnQFiBQj3djAA3eSTfgj2/SvoN08Qdght23mk
 CB1CaQ++o9DI90+RjeF3FE+KGz3ttI3yF9eZ6XcU2sU4u0DfFmuPddA6bUEQpbL86Qwv/OgrXrzQ
 K/PI4yt/+QVFn/a5QATtxkIsgocUUSgbhe7UwKrtoWceFQDnoccVSEdWwFczzx4m1Ze6f0EXt1tH
 VGuIAAAAJXRFWHRkYXRlOmNyZWF0ZQAyMDIxLTAxLTExVDE0OjIxOjM3KzAwOjAwRKi4ygAAACV0
 RVh0ZGF0ZTptb2RpZnkAMjAyMS0wMS0xMVQxNDoyMTozNyswMDowMDX1AHYAAAAASUVORK5CYII=
X-Now-Playing: Casino Music's _Mutant Disco Volume 2_: "Faites Le Proton"
Date: Mon, 11 Jan 2021 15:43:43 +0100
In-Reply-To: <fb97d5c9-91eb-b8ce-5639-1a875bf40ae9@HIDDEN> (martin rudalics's
 message of "Sun, 10 Jan 2021 17:14:09 +0100")
Message-ID: <87turnh6u8.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: multipart/mixed; boundary="=-=-="
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview:  martin rudalics <rudalics@HIDDEN> writes: > Sorry, no. Please
 assert first that the backsizing gets done inside the > following chunk:
 > > (when (and (listp quad) > (integerp (nth 3 quad)) > (> (nth 3 quad)
 (window-total-height window))) > (c [...] 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 45688
Cc: Eli Zaretskii <eliz@HIDDEN>, 45688 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

--=-=-=
Content-Type: text/plain

martin rudalics <rudalics@HIDDEN> writes:

> Sorry, no.  Please assert first that the backsizing gets done inside the
> following chunk:
>
>       (when (and (listp quad)
> 		 (integerp (nth 3 quad))
> 		 (> (nth 3 quad) (window-total-height window)))
> 	(condition-case nil
> 	    (window-resize window (- (nth 3 quad) (window-total-height window)))
> 	  (error nil)))
>
> Then we can try to find out who created that quad before and why.

I put some messaging in that code, and it is indeed that bit that does
the resizing.

Here's a reproducer from emacs -Q:

(progn
  (setq display-buffer-alist '((".*" display-buffer-use-least-recent-window)))
  (pop-to-buffer "file1")
  (pop-to-buffer "file2")
  (split-window-below)
  (pop-to-buffer "file3"))

I end up with the following, and file3 in an oddly large window.


--=-=-=
Content-Type: image/png
Content-Disposition: inline
Content-Transfer-Encoding: base64
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--=-=-=
Content-Type: text/plain




-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no

--=-=-=--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#45688; Package emacs. Full text available.

Message received at 45688 <at> debbugs.gnu.org:


Received: (at 45688) by debbugs.gnu.org; 10 Jan 2021 16:14:20 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Jan 10 11:14:20 2021
Received: from localhost ([127.0.0.1]:54785 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kydMB-0004eI-Qd
	for submit <at> debbugs.gnu.org; Sun, 10 Jan 2021 11:14:20 -0500
Received: from mout.gmx.net ([212.227.15.15]:54417)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <rudalics@HIDDEN>) id 1kydMA-0004e2-3t
 for 45688 <at> debbugs.gnu.org; Sun, 10 Jan 2021 11:14:18 -0500
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=gmx.net;
 s=badeba3b8450; t=1610295252;
 bh=MC48qx5U5NeuEChjxHVFGS6BGLhVMaq1z+M6EVblP9I=;
 h=X-UI-Sender-Class:Subject:To:Cc:References:From:Date:In-Reply-To;
 b=OcE437X4xHsbVIW44/+O5shTogoQudtionQfWm3xafB0f6drJA0C9Su7Xox+1/EJB
 swPNuG+t2ZcjtRRJDKQtrWs8wtPpNXHnQ0mdmmTcMIqrtFWuYsrA8Pk7XNqmWsKInQ
 6r3BWlxYd+rJWbgoogAoIZ4HsVamfH6oYObJdtMU=
X-UI-Sender-Class: 01bb95c1-4bf8-414a-932a-4f6e2808ef9c
Received: from [192.168.1.100] ([212.95.5.93]) by mail.gmx.com (mrgmx005
 [212.227.17.190]) with ESMTPSA (Nemesis) id 1MJVHe-1keuc73rdQ-00JvW9; Sun, 10
 Jan 2021 17:14:12 +0100
Subject: Re: bug#45688: 28.0.50; New action for display-buffer?
To: Lars Ingebrigtsen <larsi@HIDDEN>
References: <87im8a1dff.fsf@HIDDEN> <83y2h6133r.fsf@HIDDEN>
 <8735ze0yp7.fsf@HIDDEN> <83o8i20w1f.fsf@HIDDEN> <87lfd5yny9.fsf@HIDDEN>
 <a25dc85e-cd8e-8164-676e-bb6a0f381c06@HIDDEN> <87o8i03gem.fsf@HIDDEN>
 <528b7d6b-403a-ffef-b0a0-4a0b6d92bec8@HIDDEN> <87turpvxv0.fsf@HIDDEN>
 <fe796e77-3248-b3fc-0f1b-35b12761e860@HIDDEN>
From: martin rudalics <rudalics@HIDDEN>
Message-ID: <fb97d5c9-91eb-b8ce-5639-1a875bf40ae9@HIDDEN>
Date: Sun, 10 Jan 2021 17:14:09 +0100
MIME-Version: 1.0
In-Reply-To: <fe796e77-3248-b3fc-0f1b-35b12761e860@HIDDEN>
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Language: en-US
Content-Transfer-Encoding: 7bit
X-Provags-ID: V03:K1:Tsf6irz6ZHUseh8o+F89DLnMw063qNfDTkfALv4cEhoSDKaTEKa
 iogWBOswO/fG+B3pLkYKPDFOFWHhCl7bXOFC/ZZOVJgPb3T/L9DQdQWytH9G5riOKS9Q3FV
 xeQw1jTU0gMckVZDBCz/yuaqszVH9iJZB0JmCVl1eoS9k3eYqIHVa9qXoKrpt01DD37FQwM
 PHiOPGsvkyANLhSon0D3A==
X-Spam-Flag: NO
X-UI-Out-Filterresults: notjunk:1;V03:K0:sQt89PKYrUo=:+SX9KcHNwlldk7eIKAGGSQ
 0fLF5TH+fU8gfNp4/AXHiU16L7xZV19pQWaUJAsd69l46PHtc4+MXPsT/CK9yieDnQGrz6sz4
 ER6VJFb59wlxKCm9ABmQEmKd1itnbBJeilhBW0QnkpYrQajTQtH0np1ajvFIlN7lsUxtu10P1
 vYE05Pfb2R5cccsrSAEC8C+UEneTeAA+s52brllODKzVC6FoS26BJAZvUC6S3Ms5oeRQYVjcy
 8/iXB7oWe04wCRtORFVYhZBcjoxXuMtnvg6/7Ss+05vbgewB1rX77Ki1WtLlFn3zpBvbvu9u6
 +wOxsS/y+02lNMLBF2aLiwAD0tRuxWcmto9zzb258MoENpt2wYdWibu3TWnGXVqQaXqH3xCPv
 KmT2+piaXjEoA9biWLYvapijyyoCbECMqOfI5OSs3gy2P1tFfanA/D0hrVVHmDUzj/VYbT/IY
 KzEOyzr9/WOqwYjc4CJ82aeySbZHWjcMk0RnbNd4DQkP3nes8SB4QX3p62ZinyTQFW/B00zB9
 p3uMsIaunmjmxSqqDztghnWSPbtyTTNLk8bvfKD068kspAI4rKYYcBncsp+4k/z1dMKEMDVIj
 WlLPpFdBOixoPqKcgnpw1A8GRvVbBZAsL8RDw+XKXA1Hp/WARpvR4BMpfrcvGBoVsKDbhp7tP
 M0rhYqF7NtDGe89OyO6xDL93su6xY1BpOqg3X+a2hQ9Iz9sdPY40uLI7i8VEoHyCWX3pCvx9A
 wUozF5CWFmPoKSb/0wt87Rfq3zJuswwMC7gSWs8WH8/Ng15mUhAy2itt4oCijq2ixNl3pVdUM
 JHn/FI6PWEoLPoXm4glmqm9JTIQ0JeUHiYOSXBQCw1+yXuDKRshs2QwhPZMjM3SluoWktYTAN
 y47EzM+roQDwc7ZHW0aIxCS+Q4GMgUOL8vxPvS+Jk=
X-Spam-Score: 2.8 (++)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 Content preview: > Please put some silly function on
 'window-size-change-functions'
 and > make it produce a backtrace. Sorry, no. Please assert first that the
 backsizing gets done inside the following chunk: (when (and (listp quad)
 (integerp (nth 3 quad)) (> (nth 3 quad) (window-total-height window)))
 (condition-case
 nil (window-resize window (- (nth 3 quad) (window-total-height window)))
 (error nil))) 
 Content analysis details:   (2.8 points, 10.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -0.7 RCVD_IN_DNSWL_LOW      RBL: Sender listed at https://www.dnswl.org/,
 low trust [212.227.15.15 listed in list.dnswl.org]
 3.6 RCVD_IN_SBL_CSS        RBL: Received via a relay in Spamhaus SBL-CSS
 [212.95.5.93 listed in zen.spamhaus.org]
 0.0 FREEMAIL_FROM          Sender email is commonly abused enduser mail
 provider (rudalics[at]gmx.at)
 0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
 -0.0 SPF_PASS               SPF: sender matches SPF record
 -0.0 RCVD_IN_MSPIKE_H4      RBL: Very Good reputation (+4)
 [212.227.15.15 listed in wl.mailspike.net]
 -0.0 RCVD_IN_MSPIKE_WL      Mailspike good senders
X-Debbugs-Envelope-To: 45688
Cc: Eli Zaretskii <eliz@HIDDEN>, 45688 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 1.8 (+)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  > Please put some silly function on 'window-size-change-functions'
    and > make it produce a backtrace. Sorry, no. Please assert first that the
    backsizing gets done inside the following chunk: (when (and (listp quad)
   (integerp (nth 3 quad)) (> (nth 3 quad) (window-total-height window))) (condition-case
    nil (window-resize window (- (nth 3 quad) (window-total-height window)))
   (error nil))) 
 
 Content analysis details:   (1.8 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
  3.6 RCVD_IN_SBL_CSS        RBL: Received via a relay in Spamhaus SBL-CSS
                             [212.95.5.93 listed in zen.spamhaus.org]
 -0.7 RCVD_IN_DNSWL_LOW      RBL: Sender listed at https://www.dnswl.org/,
                             low trust
                             [212.227.15.15 listed in list.dnswl.org]
 -0.0 RCVD_IN_MSPIKE_H4      RBL: Very Good reputation (+4)
                             [212.227.15.15 listed in wl.mailspike.net]
  0.0 FREEMAIL_FROM          Sender email is commonly abused enduser mail
                             provider (rudalics[at]gmx.at)
  0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
 -0.0 SPF_PASS               SPF: sender matches SPF record
 -1.0 MAILING_LIST_MULTI     Multiple indicators imply a widely-seen list
                             manager
 -0.0 RCVD_IN_MSPIKE_WL      Mailspike good senders

 > Please put some silly function on 'window-size-change-functions' and
 > make it produce a backtrace.

Sorry, no.  Please assert first that the backsizing gets done inside the
following chunk:

       (when (and (listp quad)
		 (integerp (nth 3 quad))
		 (> (nth 3 quad) (window-total-height window)))
	(condition-case nil
	    (window-resize window (- (nth 3 quad) (window-total-height window)))
	  (error nil)))

Then we can try to find out who created that quad before and why.

martin




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#45688; Package emacs. Full text available.

Message received at 45688 <at> debbugs.gnu.org:


Received: (at 45688) by debbugs.gnu.org; 10 Jan 2021 16:05:47 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Jan 10 11:05:46 2021
Received: from localhost ([127.0.0.1]:54750 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kydDu-0004Kr-Lo
	for submit <at> debbugs.gnu.org; Sun, 10 Jan 2021 11:05:46 -0500
Received: from mout.gmx.net ([212.227.15.18]:47047)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <rudalics@HIDDEN>) id 1kydDs-0004Ka-R1
 for 45688 <at> debbugs.gnu.org; Sun, 10 Jan 2021 11:05:45 -0500
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=gmx.net;
 s=badeba3b8450; t=1610294739;
 bh=gVsGsvxj09TBiKISHbGrtDMJs4ftWmyAgObrzu9UMqo=;
 h=X-UI-Sender-Class:Subject:To:Cc:References:From:Date:In-Reply-To;
 b=lTInoi4fMbJYO26SXtGGVqXWkRHJ7XfoKhWacEpPaGgXMPZIelGj2jXSIjtuppakR
 n9B5H0Dq2cFBMajx595D/n2T4Ch2XIHUD9BTrQ5qmYypDwc1X6icHa0qYqmah51hsy
 3phhLgWL+JNgaZx92svwxotHC6ZMmAOzcOnj05MQ=
X-UI-Sender-Class: 01bb95c1-4bf8-414a-932a-4f6e2808ef9c
Received: from [192.168.1.100] ([212.95.5.93]) by mail.gmx.com (mrgmx005
 [212.227.17.190]) with ESMTPSA (Nemesis) id 1MFbW0-1kjlvA2Wv0-00H3sx; Sun, 10
 Jan 2021 17:05:38 +0100
Subject: Re: bug#45688: 28.0.50; New action for display-buffer?
To: Lars Ingebrigtsen <larsi@HIDDEN>
References: <87im8a1dff.fsf@HIDDEN> <83y2h6133r.fsf@HIDDEN>
 <8735ze0yp7.fsf@HIDDEN> <83o8i20w1f.fsf@HIDDEN> <87lfd5yny9.fsf@HIDDEN>
 <a25dc85e-cd8e-8164-676e-bb6a0f381c06@HIDDEN> <87o8i03gem.fsf@HIDDEN>
 <528b7d6b-403a-ffef-b0a0-4a0b6d92bec8@HIDDEN> <87turpvxv0.fsf@HIDDEN>
From: martin rudalics <rudalics@HIDDEN>
Message-ID: <fe796e77-3248-b3fc-0f1b-35b12761e860@HIDDEN>
Date: Sun, 10 Jan 2021 17:05:36 +0100
MIME-Version: 1.0
In-Reply-To: <87turpvxv0.fsf@HIDDEN>
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Language: en-US
Content-Transfer-Encoding: 7bit
X-Provags-ID: V03:K1:Q9O3IzDTcLkq7Slutmst83VePjeEJgx9tC/Dve2036YzIv5Gcdg
 4deXrjxoOHXcoFk/ZsVF5/UEXX8kJzALzKrK8ew4a3sLYKLebr3Qe2jC1aL070G6nMgErK0
 kxIHk1KN2W/dnaks9SFYiptgQD1w0afMDvtotXIIIDVOP9E8519KXwhNSep4BL7tR03WRnx
 GOmM1I8TGvOvD4hQc8DmA==
X-Spam-Flag: NO
X-UI-Out-Filterresults: notjunk:1;V03:K0:PLZWyJ3xzOk=:qsXbeYOl/L/HKUPiC7C5gm
 wa164RMe27OJYGmL8CTaGV0QLFW3ks3utrsHiooldQNXLbTkprUid8zQYfEOCSaG4hJuLz1oX
 pyChKiSR8SGnOkKh/KxyRG6xNndxGP78hCnFmtN1HkDqp6Y3E4suyEO7m/pThNYm3/QEB6L0V
 zqukCeuW5dGYA5yIdWOhaLP2JLkCkSA9wDYFi8nzfIF7s9gDqw/WPnZ6zcdRowAgFF52zVQaz
 F9UzQuVlg/THQcyDfmnCujy7+mndsnp0g+Zpzhez1Z8wnHYaRjNLrWE4/VRpVX/i1M2hnYLvh
 D+TNDPc5S/a8oyrUbR4/Sd41YLVAVTaf0cZiswPIEC6MqRkUwnWorQPpUbI59IJkx7P3BVpAM
 jP7donrXx+Fqjfqiy8qXMkFKoRIU2RPx3OmPHhVUaYidWsvJY11VKZLO3HCkVucxuZ7ez0QnY
 9grstJy1MWlJA6m3I43Ra8AmUsKsSVsUkK4ct0GbcYgFIKLKMWotop187DPo4Uwbqc42ZOQFo
 1dT4b1hc73VPC5RmH8K7wXAgLes8DEeTqNekBILyq5KdQeb4+S9hvK2PQkiI+dVDpy6o2ezrC
 V1qqJ3+nOnNF/eGvEYImlIMbLNovrXznNEMcS7oEGqcomikzM0TsSEkCiaIJjASlQ6JOtDjJ1
 y2Vpud+HXyPTB5/bnuwbz4N39euS4sBEhVmX84ktMZqmOSGqZh/LlUkMSyVOCJRwJE8sHc3kC
 0MZg06QenRdyVq2DEDEypJBr7fvWCO+JljEuv1eO9Ma197nqdSdFPaoipEwPnHLP9FgKsN2uR
 hu4zfG4Fg2DMs/yE5Bz6uZRvj3R1q+RgDpvzkSCNOdhRUmofXSWE2m9ZMFSTlS5z9e3Ca8Edh
 JryoWgq00pGYZMO90h6dVgewyKH3anzrL/DOAYx8M=
X-Spam-Score: 2.8 (++)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 Content preview: >> This >> >> + (when-let ((window
 (display-buffer-use-some-window
 >> + buffer (cons (cons 'inhibit-same-window t) alist)))) >> +
 (window-bump-use-time
 window))) >> >> alone will bump the use time fo [...] 
 Content analysis details:   (2.8 points, 10.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 3.6 RCVD_IN_SBL_CSS        RBL: Received via a relay in Spamhaus SBL-CSS
 [212.95.5.93 listed in zen.spamhaus.org]
 0.0 FREEMAIL_FROM          Sender email is commonly abused enduser mail
 provider (rudalics[at]gmx.at)
 0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
 -0.0 SPF_PASS               SPF: sender matches SPF record
 -0.7 RCVD_IN_DNSWL_LOW      RBL: Sender listed at https://www.dnswl.org/,
 low trust [212.227.15.18 listed in list.dnswl.org]
 -0.0 RCVD_IN_MSPIKE_H3      RBL: Good reputation (+3)
 [212.227.15.18 listed in wl.mailspike.net]
 -0.0 RCVD_IN_MSPIKE_WL      Mailspike good senders
X-Debbugs-Envelope-To: 45688
Cc: Eli Zaretskii <eliz@HIDDEN>, 45688 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 1.8 (+)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  >> This >> >> + (when-let ((window (display-buffer-use-some-window
    >> + buffer (cons (cons 'inhibit-same-window t) alist)))) >> + (window-bump-use-time
    window))) >> >> alone will bump the use time fo [...] 
 
 Content analysis details:   (1.8 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
  3.6 RCVD_IN_SBL_CSS        RBL: Received via a relay in Spamhaus SBL-CSS
                             [212.95.5.93 listed in zen.spamhaus.org]
 -0.7 RCVD_IN_DNSWL_LOW      RBL: Sender listed at https://www.dnswl.org/,
                             low trust
                             [212.227.15.18 listed in list.dnswl.org]
 -0.0 RCVD_IN_MSPIKE_H3      RBL: Good reputation (+3)
                             [212.227.15.18 listed in wl.mailspike.net]
  0.0 FREEMAIL_FROM          Sender email is commonly abused enduser mail
                             provider (rudalics[at]gmx.at)
  0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
 -0.0 SPF_PASS               SPF: sender matches SPF record
 -1.0 MAILING_LIST_MULTI     Multiple indicators imply a widely-seen list
                             manager
 -0.0 RCVD_IN_MSPIKE_WL      Mailspike good senders

 >> This
 >>
 >> +  (when-let ((window (display-buffer-use-some-window
 >> +                      buffer (cons (cons 'inhibit-same-window t) alist))))
 >> +    (window-bump-use-time window)))
 >>
 >> alone will bump the use time for a _reused_ window only.  A freshly
 >> popped up window will continue to be the first candidate for reuse and
 >> only then enter the cycle of windows to reuse.
 >
 > How do we bump the use to for a new window, then?

By bumping the time stamp of _any_ window 'display-buffer' uses for
displaying a buffer (just like XEmacs does).

 >> XEmacs treats _all_ windows it creates or uses equal in this regard
 >> including those on other frames.
 >
 > Oh, other frames, too...  I think we'll leave that as an exercise for
 > the reader.

Then when you switch from one frame to another, any problems you've
found on the previous frame will immediately reemerge on the new frame.

 >>> The only oddity is that it'll resize windows to their previous sizes --
 >>> is there any way to inhibit that?
 >>
 >> How comes that window gets ever resized in the first place?
 >
 > I have no idea, but it's totally repeatable -- the window that's
 > switched to becomes the largest window, and it's rather distracting.

Please put some silly function on 'window-size-change-functions' and
make it produce a backtrace.

martin




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#45688; Package emacs. Full text available.

Message received at 45688 <at> debbugs.gnu.org:


Received: (at 45688) by debbugs.gnu.org; 10 Jan 2021 11:26:58 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Jan 10 06:26:58 2021
Received: from localhost ([127.0.0.1]:53225 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kyYs6-0005Yj-1E
	for submit <at> debbugs.gnu.org; Sun, 10 Jan 2021 06:26:58 -0500
Received: from quimby.gnus.org ([95.216.78.240]:39828)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1kyYs4-0005YT-65
 for 45688 <at> debbugs.gnu.org; Sun, 10 Jan 2021 06:26:56 -0500
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnus.org;
 s=20200322; h=Content-Type:MIME-Version:Message-ID:In-Reply-To:Date:
 References:Subject:Cc:To:From:Sender:Reply-To:Content-Transfer-Encoding:
 Content-ID:Content-Description:Resent-Date:Resent-From:Resent-Sender:
 Resent-To:Resent-Cc:Resent-Message-ID:List-Id:List-Help:List-Unsubscribe:
 List-Subscribe:List-Post:List-Owner:List-Archive;
 bh=F2VfhgTBJPtUVMIxLdkBnTZYOjs5rl5j4ur6bLPzkIg=; b=QBu1Z/8+vc/XRXOMKx1L57LhKu
 1BIrs6bXciTYziOinHAo9eRFLLyo6oYXYHcPC9Gddx/3plgSRRrCcK/308Em9BPtn6YmTiIdziD+A
 Tfm3jJzABVJbu8FhIFvCPpjCYziwBehFgjkV+pm9fKte8dVPj1NIsMg1Pn4Sy6kBLYvw=;
Received: from cm-84.212.202.86.getinternet.no ([84.212.202.86] helo=xo)
 by quimby.gnus.org with esmtpsa (TLS1.3:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.92) (envelope-from <larsi@HIDDEN>)
 id 1kyYru-0005yl-Hs; Sun, 10 Jan 2021 12:26:50 +0100
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: martin rudalics <rudalics@HIDDEN>
Subject: Re: bug#45688: 28.0.50; New action for display-buffer?
References: <87im8a1dff.fsf@HIDDEN> <83y2h6133r.fsf@HIDDEN>
 <8735ze0yp7.fsf@HIDDEN> <83o8i20w1f.fsf@HIDDEN>
 <87lfd5yny9.fsf@HIDDEN> <87ft3cpoy9.fsf@HIDDEN>
 <6859d73c-da77-af77-481f-3046d5195d53@HIDDEN>
Face: iVBORw0KGgoAAAANSUhEUgAAADAAAAAwAgMAAAAqbBEUAAAABGdBTUEAALGPC/xhBQAAACBj
 SFJNAAB6JgAAgIQAAPoAAACA6AAAdTAAAOpgAAA6mAAAF3CculE8AAAADFBMVEXaOQLkViP2spH/
 //9y+Ee7AAAAAWJLR0QDEQxM8gAAAAd0SU1FB+UBCgo1FRr7Ss4AAAEsSURBVCjPrZK/boMwEMbP
 UWBOJSzRPUPapzBVG6kbSDFS2RoVRPwUyUgmWsVD2ToEhXvK+r94gHws9+POx/k7AJQiyFfAwIhw
 LusGMYcSg5gDgRPPTVnEXWC1MkcZENwPp+nUYSt7IOt9l11+uvRpULXr5vzajl36+N0r+OyK98M5
 3UgN9XCspaRJ6WYAUhQ8AaDcaadfaoL7KJrFxDRdWqDzL1QSeLgmZyC0EVZLnfGwmXdrQ6jcED6m
 qnbyJTdlFDrI8kX2NrrEhVbZ8Gf7k3GLDKWdllyriqGZjSiPp+xlMvDAYsRdbAE0/IpR2o0s9MK8
 Y9EBx5u/Nvlohj7Alj+zAH0u1N7cbFcQRweJetCXqeEsELsdYjO8VL/O1wIZCSYqiLg7AzEyyv8B
 CJdkPxkQ068AAAAldEVYdGRhdGU6Y3JlYXRlADIwMjEtMDEtMTBUMTA6NTM6MjErMDA6MDCozbPX
 AAAAJXRFWHRkYXRlOm1vZGlmeQAyMDIxLTAxLTEwVDEwOjUzOjIxKzAwOjAw2ZALawAAAABJRU5E
 rkJggg==
X-Now-Playing: The Smiths's _Complete (8): Louder Than Bombs_: "Stretch Out
 and Wait"
Date: Sun, 10 Jan 2021 12:26:45 +0100
In-Reply-To: <6859d73c-da77-af77-481f-3046d5195d53@HIDDEN> (martin rudalics's
 message of "Fri, 8 Jan 2021 09:31:28 +0100")
Message-ID: <87pn2dvxqi.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview: martin rudalics <rudalics@HIDDEN> writes: > We're asking too
 much from 'display-buffer' here. It can't second-guess > a user's intentions
 in particular with the interpretation of grep and > xref hits. I see three
 basic patterns here: 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 45688
Cc: 45688 <at> debbugs.gnu.org, Juri Linkov <juri@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

martin rudalics <rudalics@HIDDEN> writes:

> We're asking too much from 'display-buffer' here.  It can't second-guess
> a user's intentions in particular with the interpretation of grep and
> xref hits.  I see three basic patterns here:

I'm wondering whether there should be a separate
`display-buffer-command' that's bound to `C-x 4 C-o' with its own
display rules.  :-)  That is, when the user is using this command
explicitly, then it's not obvious that the user wants the same rules as
with the "automatic" display-buffer stuff (popping from *grep* buffers
and the like).

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#45688; Package emacs. Full text available.

Message received at 45688 <at> debbugs.gnu.org:


Received: (at 45688) by debbugs.gnu.org; 10 Jan 2021 11:24:25 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Jan 10 06:24:25 2021
Received: from localhost ([127.0.0.1]:53219 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kyYpd-0005LG-0Q
	for submit <at> debbugs.gnu.org; Sun, 10 Jan 2021 06:24:25 -0500
Received: from quimby.gnus.org ([95.216.78.240]:39808)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1kyYpZ-0005Kt-4k
 for 45688 <at> debbugs.gnu.org; Sun, 10 Jan 2021 06:24:23 -0500
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnus.org;
 s=20200322; h=Content-Type:MIME-Version:Message-ID:In-Reply-To:Date:
 References:Subject:Cc:To:From:Sender:Reply-To:Content-Transfer-Encoding:
 Content-ID:Content-Description:Resent-Date:Resent-From:Resent-Sender:
 Resent-To:Resent-Cc:Resent-Message-ID:List-Id:List-Help:List-Unsubscribe:
 List-Subscribe:List-Post:List-Owner:List-Archive;
 bh=dTbtyGT6CJfWtILquy8zzq92JxtYzcIo8fBdXvd/0uw=; b=UCoKwe42EAK1x2kLDYfcpYXUb/
 +PzMTikCD47wT9RiaoASLxzMdySogHuMjaq51TDrmIMUc6DqTjavwS9CRi6T/0ixmgFXIV+A5hIVE
 KEKr5i5nvAyUojni7a7WdI0NBTUFW1GCxbGFyBgDZLpnxjqFyJ1c7V//aXkmiMHHky78=;
Received: from cm-84.212.202.86.getinternet.no ([84.212.202.86] helo=xo)
 by quimby.gnus.org with esmtpsa (TLS1.3:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.92) (envelope-from <larsi@HIDDEN>)
 id 1kyYpI-0005xO-BD; Sun, 10 Jan 2021 12:24:14 +0100
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: martin rudalics <rudalics@HIDDEN>
Subject: Re: bug#45688: 28.0.50; New action for display-buffer?
References: <87im8a1dff.fsf@HIDDEN> <83y2h6133r.fsf@HIDDEN>
 <8735ze0yp7.fsf@HIDDEN> <83o8i20w1f.fsf@HIDDEN>
 <87lfd5yny9.fsf@HIDDEN>
 <a25dc85e-cd8e-8164-676e-bb6a0f381c06@HIDDEN>
 <87o8i03gem.fsf@HIDDEN>
 <528b7d6b-403a-ffef-b0a0-4a0b6d92bec8@HIDDEN>
Face: iVBORw0KGgoAAAANSUhEUgAAADAAAAAwAgMAAAAqbBEUAAAABGdBTUEAALGPC/xhBQAAACBj
 SFJNAAB6JgAAgIQAAPoAAACA6AAAdTAAAOpgAAA6mAAAF3CculE8AAAADFBMVEXaOQLkViP2spH/
 //9y+Ee7AAAAAWJLR0QDEQxM8gAAAAd0SU1FB+UBCgo1FRr7Ss4AAAEsSURBVCjPrZK/boMwEMbP
 UWBOJSzRPUPapzBVG6kbSDFS2RoVRPwUyUgmWsVD2ToEhXvK+r94gHws9+POx/k7AJQiyFfAwIhw
 LusGMYcSg5gDgRPPTVnEXWC1MkcZENwPp+nUYSt7IOt9l11+uvRpULXr5vzajl36+N0r+OyK98M5
 3UgN9XCspaRJ6WYAUhQ8AaDcaadfaoL7KJrFxDRdWqDzL1QSeLgmZyC0EVZLnfGwmXdrQ6jcED6m
 qnbyJTdlFDrI8kX2NrrEhVbZ8Gf7k3GLDKWdllyriqGZjSiPp+xlMvDAYsRdbAE0/IpR2o0s9MK8
 Y9EBx5u/Nvlohj7Alj+zAH0u1N7cbFcQRweJetCXqeEsELsdYjO8VL/O1wIZCSYqiLg7AzEyyv8B
 CJdkPxkQ068AAAAldEVYdGRhdGU6Y3JlYXRlADIwMjEtMDEtMTBUMTA6NTM6MjErMDA6MDCozbPX
 AAAAJXRFWHRkYXRlOm1vZGlmeQAyMDIxLTAxLTEwVDEwOjUzOjIxKzAwOjAw2ZALawAAAABJRU5E
 rkJggg==
X-Now-Playing: The Smiths's _Complete (8): Louder Than Bombs_: "Back To The
 Old House"
Date: Sun, 10 Jan 2021 12:24:03 +0100
In-Reply-To: <528b7d6b-403a-ffef-b0a0-4a0b6d92bec8@HIDDEN> (martin rudalics's
 message of "Thu, 7 Jan 2021 17:54:39 +0100")
Message-ID: <87turpvxv0.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview: martin rudalics <rudalics@HIDDEN> writes: > This > > +
 (when-let
 ((window (display-buffer-use-some-window > + buffer (cons (cons
 'inhibit-same-window
 t) alist)))) > + (window-bump-use-time window))) > > alone will bump the
 use time for a _reu [...] 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 45688
Cc: Eli Zaretskii <eliz@HIDDEN>, 45688 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

martin rudalics <rudalics@HIDDEN> writes:

> This
>
> +  (when-let ((window (display-buffer-use-some-window
> +                      buffer (cons (cons 'inhibit-same-window t) alist))))
> +    (window-bump-use-time window)))
>
> alone will bump the use time for a _reused_ window only.  A freshly
> popped up window will continue to be the first candidate for reuse and
> only then enter the cycle of windows to reuse.

How do we bump the use to for a new window, then?

> XEmacs treats _all_ windows it creates or uses equal in this regard
> including those on other frames.

Oh, other frames, too...  I think we'll leave that as an exercise for
the reader.

>> The only oddity is that it'll resize windows to their previous sizes --
>> is there any way to inhibit that?
>
> How comes that window gets ever resized in the first place?

I have no idea, but it's totally repeatable -- the window that's
switched to becomes the largest window, and it's rather distracting.

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#45688; Package emacs. Full text available.

Message received at 45688 <at> debbugs.gnu.org:


Received: (at 45688) by debbugs.gnu.org; 8 Jan 2021 08:31:39 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Jan 08 03:31:39 2021
Received: from localhost ([127.0.0.1]:49237 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kxnBL-0005QD-1K
	for submit <at> debbugs.gnu.org; Fri, 08 Jan 2021 03:31:39 -0500
Received: from mout.gmx.net ([212.227.15.19]:35195)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <rudalics@HIDDEN>) id 1kxnBJ-0005Pz-32
 for 45688 <at> debbugs.gnu.org; Fri, 08 Jan 2021 03:31:38 -0500
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=gmx.net;
 s=badeba3b8450; t=1610094690;
 bh=CkJxuKjEGK99uLDWQYqkg4b1n6YVGhKKwtnPPMGk1ho=;
 h=X-UI-Sender-Class:Subject:To:Cc:References:From:Date:In-Reply-To;
 b=REsPLkJZqPJb1d1aEtdBSiuhqmAw75Q0B/+QUntUcBODgHl/f32PaCgPauY0UaEsW
 7f7MUVc/PDTsI5Bhg6dcgBie0AsZPDMglUqIqsuxi/NMmuZFQMacY4XjMtrxUDQnuW
 Q871+TPSZC/+feszfvSW8cF+5VGCMURkITx8uaY0=
X-UI-Sender-Class: 01bb95c1-4bf8-414a-932a-4f6e2808ef9c
Received: from [192.168.1.100] ([212.95.5.50]) by mail.gmx.com (mrgmx005
 [212.227.17.190]) with ESMTPSA (Nemesis) id 1Mirna-1kLQ613pSO-00esCl; Fri, 08
 Jan 2021 09:31:30 +0100
Subject: Re: bug#45688: 28.0.50; New action for display-buffer?
To: Juri Linkov <juri@HIDDEN>, Lars Ingebrigtsen <larsi@HIDDEN>
References: <87im8a1dff.fsf@HIDDEN> <83y2h6133r.fsf@HIDDEN>
 <8735ze0yp7.fsf@HIDDEN> <83o8i20w1f.fsf@HIDDEN> <87lfd5yny9.fsf@HIDDEN>
 <87ft3cpoy9.fsf@HIDDEN>
From: martin rudalics <rudalics@HIDDEN>
Message-ID: <6859d73c-da77-af77-481f-3046d5195d53@HIDDEN>
Date: Fri, 8 Jan 2021 09:31:28 +0100
MIME-Version: 1.0
In-Reply-To: <87ft3cpoy9.fsf@HIDDEN>
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Language: en-US
Content-Transfer-Encoding: 7bit
X-Provags-ID: V03:K1:2Ej5oNb+xTJCj/KLJ+oxU+hISItxYJG7BPggOTo7MobjHmp8f6I
 iEY3SmuZZYEHy8K6p/fE4HW2xnC9Qvh1X4TxgHwo1+Yw0WlctnCeEcQAb/ixOw2iC+MXLZ0
 KaMgRtCmz6VHDd5fBXQEwDCpOxlagGehcC/npVJA5977H643R6YU3lpA0KiQ8oEyUfRFkUw
 4MYrSIrJyU4/+vAvxgoGg==
X-Spam-Flag: NO
X-UI-Out-Filterresults: notjunk:1;V03:K0:d2BlsWh5wBk=:f9OV8dK3lWLxDynRnXvIei
 RTFK+d85CekkoFZjiGiyMBPbxUriGqmc6Q42XDizAlKs9oCMXhQ9/mQGJP28A7jnAoWQL+HCz
 zSvkPKlZ+f2pTItjyPYyDkAkzm2dO8/p9ldUB01sGn/oXquIm9mJWaLFfgnt+CrNFvQufMD/r
 6va89sfuasKTFzX3swVeirl6bcQCp3CcwuDKeq0ficrvjfngn9+jEbz5XCNoVfUmhnFtSG35S
 BIHJOEU7Qvj3GZXkfFAMR0Ms/rMOtF7+zSU76OnNVPyPo0/1HEzx+xDoHWqmyVOsF57rgw2TY
 3+u24zu2hf6GBhkp/+hPB8BvOxnSEnE0LnNDR/XkXMN+JwuLXoIH9QqahaHpg4JyIK67I43RL
 Ri3j2m02lsC0RYKZooP5Fjy+QZ+Mw74NZKOd8dBqZAOItQo1DaW1mnNZT/xOPEn2OSLXcyrSq
 hfcLFTpJVgk0hG/49qEUNuK57Ogq1bkmyA0bJ++H9w9CHQ2qC7GImL9LMsVqrNgPDv3g3s4wY
 1VvuKfG2eBcXOoukOpnPmwYK1a2G+bdI8SJ1m7o339pIkAHPA7RyBjN3RzutWjxIxSdf8k/HI
 1PiaPRzy4POTE2U/+bg1L28ILW9c58FnauB9PmMZ9HXhGMEywAQcYdF/oxLpTUguMkm3bOFAP
 KLe71Cy5rmC6ElZ6KE8YaJd9dccIGC70/WYSKFYPnvuhm2HgIb1+DXTJdKCVWy3YC3IPnyF1U
 wgxM8Er91Nf0f1lwgEslnJgF9Z8RxwAdkUBGVF1RppbAQ0krbq9zhkz5uVTt7jwVdKwJ3qRz2
 TG/FS0u9TbBMrT7VRoh4pMTRVcE/YHXYPdamdptQlCsbS72K36tdVusOa26whm9v7Q+//J8pF
 yATx+lCbITNL7D5OF7BQ==
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 45688
Cc: 45688 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

 > XEmacs does absolutely the wrong thing.  When I have a window
 > with a source buffer, then run grep in another window, then
 > want to visit grep hits in the third window, visiting
 > the next file from the grep window obscures the window
 > with the source buffer, it doesn't use the same window
 > where I'm visiting grep hits.

We're asking too much from 'display-buffer' here.  It can't second-guess
a user's intentions in particular with the interpretation of grep and
xref hits.  I see three basic patterns here:

- a hit is detected in a buffer currently shown but that window's point
   is the position where I want to continue to work - show the hit in
   another window,

- a hit is detected in a buffer currently shown and I don't care about
   that window's current point - move that window's point to the hit,

- one or a few hits are already shown in windows and I would like to
   either compare them or at least for the moment not lose any of these
   windows (no matter how small they are) - try popping up yet another
   window.

Do you have more?  In either case, I cannot generally predict beforehand
which of these will apply in a specific situation so I'd like to see
some versatile grep/xref-DWIM layer that handles these patterns ad hoc,
possibly assisted by some simple M-g binding.  But we have to identify
all potentially useful patterns first.

 > I tried to replace get-lru-window with get-mru-window
 > but it selects the current window which is mru indeed,
 > but makes no sense - what is needed is mru-1, then
 > I tried to set the arg NOT-SELECTED of get-mru-window to t
 > in display-buffer-use-some-window, then it works sensibly.

Neither of these will catch all needs: mru-ish replaces the previous hit
found, lru-ish the oldest hit found so far.  Any of these might be the
most interesting one found so far.

martin




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#45688; Package emacs. Full text available.

Message received at 45688 <at> debbugs.gnu.org:


Received: (at 45688) by debbugs.gnu.org; 7 Jan 2021 18:48:17 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Jan 07 13:48:17 2021
Received: from localhost ([127.0.0.1]:48684 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kxaKW-0007Zg-V6
	for submit <at> debbugs.gnu.org; Thu, 07 Jan 2021 13:48:17 -0500
Received: from relay13.mail.gandi.net ([217.70.178.233]:17627)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <juri@HIDDEN>) id 1kxaKV-0007ZP-Ce
 for 45688 <at> debbugs.gnu.org; Thu, 07 Jan 2021 13:48:16 -0500
Received: from mail.gandi.net (m91-129-98-64.cust.tele2.ee [91.129.98.64])
 (Authenticated sender: juri@HIDDEN)
 by relay13.mail.gandi.net (Postfix) with ESMTPSA id 4C71E80005;
 Thu,  7 Jan 2021 18:48:07 +0000 (UTC)
From: Juri Linkov <juri@HIDDEN>
To: Lars Ingebrigtsen <larsi@HIDDEN>
Subject: Re: bug#45688: 28.0.50; New action for display-buffer?
Organization: LINKOV.NET
References: <87im8a1dff.fsf@HIDDEN> <83y2h6133r.fsf@HIDDEN>
 <8735ze0yp7.fsf@HIDDEN> <83o8i20w1f.fsf@HIDDEN>
 <87lfd5yny9.fsf@HIDDEN>
Date: Thu, 07 Jan 2021 20:43:58 +0200
In-Reply-To: <87lfd5yny9.fsf@HIDDEN> (Lars Ingebrigtsen's message of "Thu,
 07 Jan 2021 12:40:46 +0100")
Message-ID: <87ft3cpoy9.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (x86_64-pc-linux-gnu)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 45688
Cc: Eli Zaretskii <eliz@HIDDEN>, 45688 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

> then the XEmacs `display-buffer' does the right thing for that.

XEmacs does absolutely the wrong thing.  When I have a window
with a source buffer, then run grep in another window, then
want to visit grep hits in the third window, visiting
the next file from the grep window obscures the window
with the source buffer, it doesn't use the same window
where I'm visiting grep hits.

I tried to replace get-lru-window with get-mru-window
but it selects the current window which is mru indeed,
but makes no sense - what is needed is mru-1, then
I tried to set the arg NOT-SELECTED of get-mru-window to t
in display-buffer-use-some-window, then it works sensibly.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#45688; Package emacs. Full text available.

Message received at 45688 <at> debbugs.gnu.org:


Received: (at 45688) by debbugs.gnu.org; 7 Jan 2021 16:54:59 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Jan 07 11:54:59 2021
Received: from localhost ([127.0.0.1]:48437 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kxYYt-0001tJ-5a
	for submit <at> debbugs.gnu.org; Thu, 07 Jan 2021 11:54:59 -0500
Received: from mout.gmx.net ([212.227.15.19]:36717)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <rudalics@HIDDEN>) id 1kxYYr-0001t6-K5
 for 45688 <at> debbugs.gnu.org; Thu, 07 Jan 2021 11:54:58 -0500
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=gmx.net;
 s=badeba3b8450; t=1610038491;
 bh=8/rLFhoD4lEq4H9yWs6GW+Ktx4XcRVLUSyC1VOO+HtM=;
 h=X-UI-Sender-Class:Subject:To:Cc:References:From:Date:In-Reply-To;
 b=DXzc2gAWuWv7ETf6P2mN8mfzY7/8SH1+GbFdaLRPHvIntaNPMbotB2U56zZRxNY7g
 WH5RHn53Yi9I6HvXIWOAQi6rghhN4/urYDvIjixRvl/zIO50/Zf9IOyo5lfvhA013s
 PxZnfO09QplB4w7IKHO99stqHSf17aYOBuO9rMg0=
X-UI-Sender-Class: 01bb95c1-4bf8-414a-932a-4f6e2808ef9c
Received: from [192.168.1.100] ([212.95.5.167]) by mail.gmx.com (mrgmx004
 [212.227.17.190]) with ESMTPSA (Nemesis) id 1MYvY2-1kSm8R3N0i-00Uva0; Thu, 07
 Jan 2021 17:54:51 +0100
Subject: Re: bug#45688: 28.0.50; New action for display-buffer?
To: Lars Ingebrigtsen <larsi@HIDDEN>
References: <87im8a1dff.fsf@HIDDEN>
 <6d33f679-925e-78ee-2055-0520538f48f5@HIDDEN> <87ble217jy.fsf@HIDDEN>
 <8bc28c07-a4af-f58d-97f5-9d0a89ff58fe@HIDDEN> <87h7ntynpx.fsf@HIDDEN>
 <616655cc-9b87-cb93-6787-11e7037e8cbc@HIDDEN> <87sg7c3isu.fsf@HIDDEN>
 <dc27f714-8200-bc8b-af37-233bd6b69486@HIDDEN> <87k0so3fxb.fsf@HIDDEN>
From: martin rudalics <rudalics@HIDDEN>
Message-ID: <140175de-6194-bab4-a66e-4e2b8ab85034@HIDDEN>
Date: Thu, 7 Jan 2021 17:54:51 +0100
MIME-Version: 1.0
In-Reply-To: <87k0so3fxb.fsf@HIDDEN>
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Language: en-US
Content-Transfer-Encoding: 7bit
X-Provags-ID: V03:K1:hB0HZvmZjrP+D5nvef1MeNjgZCyWHC2EZ8/p/Pb7WRcds8N6O84
 iDwzEJAzpOA1CPmP05fW7+f5xoSIhxj0oeU5HIy7qK80BvvSzWj+ge0SOqCGQNGv8zu7Tz2
 C/rDGQ/p9vlq1jg2e6tGa/93QDbaxOo1t3Im1VSxm4jUNhGGeGswmadB9A8P7+lx84pwt/C
 JuAZei33K08/xey9W9r+A==
X-Spam-Flag: NO
X-UI-Out-Filterresults: notjunk:1;V03:K0:kQo9lgm2k78=:qWohSOuCqe3nYMtN+vtcid
 Ga8Ur3Xi3h7xbqDAKR5pfjKsUHS1/Nz3V1QvLRE8V+qqDsqCpNKvD7ZYilc4lhJHxs8m93SWA
 sUZYF+fbhOKA9VxQzwa/Jn9IVd1SpLGahPIYKEBPCDlEY1F85My9frPQoo+onrkTXHSrMiN+2
 zvaSjU61hL5D07Az/rnC40rbxP6xKv5hYwdHJrcGA/Hu5abwSnMWP4b3WoVwHadAOk/RsGQg7
 75KeT7mYWa+oZK9CrrZ4n2T5wsi6ZrYHy9JFiwCjacQ5UxraYr6y4vgfhnl64CGh7Wr4xzad0
 AoWS0rF+ErcbU0YiJTN/TOBLnVj+ALc75uaas7rn0bgKPXBStVtW12XaLe7Pq7eDuIA7sY5iW
 0D9+bNXNKfyBMdk4B5yMrauhGDcqVciGVGtNhE/lTmEHvMApPorRlKjrbURa4ygOTPV7IR6y7
 IP2QOM3G66Mg8cUxQRz5ue7bUBFs3rfLEvGT+fWXNmVAuNSIT0kZzCC9PTdXyPKE4Hy4MyGME
 jQ/EtL0PVBOiY96JgJeZq4DdCv2wbq4KG6kUZ4eb+sjmwBGNUU7OaI1b83Ag1MZS0hYkJ+uXQ
 pRzalB27V0OKEDFG/th6ksjXxm9ZS0szqaNAT0/V8XanamMIHjorUJc3lvACqrwiNhtXUN2OT
 DVXhIEnnYTNJrMyA1rXpJf8FMTNNTVvdJ/k/DGLIYwsHwfa+lBNzDhrQWxeQ/1W152sWkGD/O
 syQNrQIr8jUFrmqwBmeDnuJLA0249mTIw/XH4827QRkYClb3OZn63pNT5jrxhHqhaSeRVkE1A
 jwvv2D8M+oCYxGRv/pi31LpJiTPtdW3cod09P6eBL7O4O3UAJ8xw/k1OtHiOXO53xGAjSrBEP
 fMSf53UQs6+IiKgmZ3yQ==
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 45688
Cc: 45688 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

 > By the way, the example in the Emacs manual is this:
 >
 > (customize-set-variable
 >   'display-buffer-alist
 >   '("\\*scratch\\*" (display-buffer-same-window)))
 >
 > Which isn't an alist?

Darn.  No wonder that people complain.  Maybe we should use one of the
examples from the Zen of Buffer Display.  In either case this is for
Emacs 27.2!

martin




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#45688; Package emacs. Full text available.

Message received at 45688 <at> debbugs.gnu.org:


Received: (at 45688) by debbugs.gnu.org; 7 Jan 2021 16:54:52 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Jan 07 11:54:52 2021
Received: from localhost ([127.0.0.1]:48434 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kxYYl-0001sz-JQ
	for submit <at> debbugs.gnu.org; Thu, 07 Jan 2021 11:54:52 -0500
Received: from mout.gmx.net ([212.227.15.18]:39637)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <rudalics@HIDDEN>) id 1kxYYh-0001sk-9g
 for 45688 <at> debbugs.gnu.org; Thu, 07 Jan 2021 11:54:50 -0500
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=gmx.net;
 s=badeba3b8450; t=1610038481;
 bh=TdEpSBH53cbr73SbqkApF5zLuj0KeQpnQJ3FzLWFXYw=;
 h=X-UI-Sender-Class:Subject:To:Cc:References:From:Date:In-Reply-To;
 b=UP2etWbh++U9SOJJyA5kBy5+ra3YER/EoAvVkKGyJnW1UCzPgO8J9gjXVE5VPyfid
 WKBCTHbq9kTjfelwmanW9BMAuF5PxnPXAgQUsWaovxD97OJwia75LSZLT3OwCpr7/M
 jtGRJQCZuH53eoz6XG2UQGSAPZvD5u0rszxkaKT8=
X-UI-Sender-Class: 01bb95c1-4bf8-414a-932a-4f6e2808ef9c
Received: from [192.168.1.100] ([212.95.5.167]) by mail.gmx.com (mrgmx005
 [212.227.17.190]) with ESMTPSA (Nemesis) id 1MeCpR-1kMZNf3oBj-00bJcU; Thu, 07
 Jan 2021 17:54:41 +0100
Subject: Re: bug#45688: 28.0.50; New action for display-buffer?
To: Lars Ingebrigtsen <larsi@HIDDEN>
References: <87im8a1dff.fsf@HIDDEN> <83y2h6133r.fsf@HIDDEN>
 <8735ze0yp7.fsf@HIDDEN> <83o8i20w1f.fsf@HIDDEN> <87lfd5yny9.fsf@HIDDEN>
 <a25dc85e-cd8e-8164-676e-bb6a0f381c06@HIDDEN> <87o8i03gem.fsf@HIDDEN>
From: martin rudalics <rudalics@HIDDEN>
Message-ID: <528b7d6b-403a-ffef-b0a0-4a0b6d92bec8@HIDDEN>
Date: Thu, 7 Jan 2021 17:54:39 +0100
MIME-Version: 1.0
In-Reply-To: <87o8i03gem.fsf@HIDDEN>
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Language: en-US
Content-Transfer-Encoding: 7bit
X-Provags-ID: V03:K1:Di/NoxjHvNpzYGq5buA8pUiBFnwBnH7WV7GrgQ554pwq0C9gLh1
 UO/wCnAQWmvA0OnsbtZRjOoS0jXv2/JzJxV0MkVQbdRpEeacllwPqn3YRBiu5KufBdMFQ/M
 dov2KSsMpVczUojrNFgstKdgt6/3MUK8TqJY+e4K2H5T1jlIlTSzOJaWf0nr83HwQD/2Qrc
 0IJefK+d15wl6VSlwIY6w==
X-Spam-Flag: NO
X-UI-Out-Filterresults: notjunk:1;V03:K0:jRX5E+dJDH8=:wV/G2jn+AAMowU5uv49/12
 2sGoIsfDOkrIdW1e0TccaB175ECvtVAUd1Psv0EUm1iaZ6cMz1N53AJBpEqaYrJgDdswOdNBT
 95gnI9jIRDbFVOik0WOJI6Qm4M/SLr9GCgON+1KNutx2OkDzi631vPHCs+6uYQHbUyWb0QpRY
 UhASVP/u+7sfWKIjYih8whlq+/Ebvt9Mv2UWG7p8w6fJ8+c9nzkH7JGX0n6M9dWCwNieNKVKv
 YWgL+oJH3tsct7quHU4bTaBITafk8d9KkEsNQoxX7FBF/skk+rph/kAQIzojlvFScZk2M98Py
 llqCN0G4m2nZBZ+KWgGU1qGXhViiEHnmYfF4VHXIenxynJebfvEQ2djWagp+7pc8RiGyy0l7Z
 EnDAik9MXpJp6h9HFain+8zrZo4CHTubnNsZwWKSkM/pPu2g/aGnAxp3xj/0gSCysB9j7/eoI
 Xp0pZibTjB9+xSU8BuDlZw48EDXBshot7Z4pzrhag4RY6SozXuVhUN+TBMjHNPMg/vlLvjpRK
 QDscQWiASpEn0wIuAFy+RNvFypDs6yH482kWldkq8MD4jKevrs3pBWTbwnoqdrab74f2hwWis
 KE/ec4wxgIN6AAFYjKHb7yOfYjjTpUyunMPOrn93tZMp775RIIZWJnoIEhXFzsLALmPSPsl1D
 sUgjiV6WygFG0Rk6b8c4wRFAID1D/dDXBDkoRhhdjHRC23XNJn2dK7BnKwZMX47itbvIhZScu
 g7siIkdMRgud9NfxfLQm2HwJEFeTrNgUwAt6dALWYLhnMrPu4FU6zZcnSE7NqDIZtrEcplM5W
 fALd8NqwMkgYPBaWbKH/xII3ow46HScwq2W4KRlVLsS4P6AfTzG+gVEZj7IOYuTMzESGcVRXH
 P8vjBK0Q5CZg/Rm9Actw==
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 45688
Cc: Eli Zaretskii <eliz@HIDDEN>, 45688 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

 > But with this setting:
 >
 >    (setq display-buffer-base-action '(display-buffer-use-least-recent-window))
 >
 > it's quite XEmacs-like?

But this should be expressed in terms of `display-buffer-alist'.

 > I think?  At least in my tests.  So now we've
 > got that all-important ex-XEmacs market segment covered.

This

+  (when-let ((window (display-buffer-use-some-window
+                      buffer (cons (cons 'inhibit-same-window t) alist))))
+    (window-bump-use-time window)))

alone will bump the use time for a _reused_ window only.  A freshly
popped up window will continue to be the first candidate for reuse and
only then enter the cycle of windows to reuse.  XEmacs treats _all_
windows it creates or uses equal in this regard including those on other
frames.

 > The only oddity is that it'll resize windows to their previous sizes --
 > is there any way to inhibit that?

How comes that window gets ever resized in the first place?

martin




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#45688; Package emacs. Full text available.

Message received at 45688 <at> debbugs.gnu.org:


Received: (at 45688) by debbugs.gnu.org; 7 Jan 2021 15:50:06 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Jan 07 10:50:06 2021
Received: from localhost ([127.0.0.1]:48358 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kxXY6-0008WH-9G
	for submit <at> debbugs.gnu.org; Thu, 07 Jan 2021 10:50:06 -0500
Received: from quimby.gnus.org ([95.216.78.240]:39158)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1kxXY4-0008Ve-Dw
 for 45688 <at> debbugs.gnu.org; Thu, 07 Jan 2021 10:50:04 -0500
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnus.org;
 s=20200322; h=Content-Type:MIME-Version:Message-ID:In-Reply-To:Date:
 References:Subject:Cc:To:From:Sender:Reply-To:Content-Transfer-Encoding:
 Content-ID:Content-Description:Resent-Date:Resent-From:Resent-Sender:
 Resent-To:Resent-Cc:Resent-Message-ID:List-Id:List-Help:List-Unsubscribe:
 List-Subscribe:List-Post:List-Owner:List-Archive;
 bh=PLCMJJTpJkzQK4iQyKVyT4+PXZd0YAkMC2Ks/xIage0=; b=e2pKn++iuBxaAu17rc8/VjJX9p
 dIbcw1t6YGsTWF4JII+ar9NlEVll9YemnS0ytzR6rYT4CC98dPAM0ZWSGwoBrgUT66M9bJx+gqdlX
 SlU9CozXH2JbG72L3y+24Emeh018NC4oOnQNbHb1E/kWoZBAF/5qgC4opeByzrhvjRVc=;
Received: from cm-84.212.202.86.getinternet.no ([84.212.202.86] helo=xo)
 by quimby.gnus.org with esmtpsa (TLS1.3:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.92) (envelope-from <larsi@HIDDEN>)
 id 1kxXXt-0004fB-9m; Thu, 07 Jan 2021 16:49:58 +0100
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: martin rudalics <rudalics@HIDDEN>
Subject: Re: bug#45688: 28.0.50; New action for display-buffer?
References: <87im8a1dff.fsf@HIDDEN>
 <6d33f679-925e-78ee-2055-0520538f48f5@HIDDEN>
 <87ble217jy.fsf@HIDDEN>
 <8bc28c07-a4af-f58d-97f5-9d0a89ff58fe@HIDDEN>
 <87h7ntynpx.fsf@HIDDEN>
 <616655cc-9b87-cb93-6787-11e7037e8cbc@HIDDEN>
 <87sg7c3isu.fsf@HIDDEN>
 <dc27f714-8200-bc8b-af37-233bd6b69486@HIDDEN>
Face: iVBORw0KGgoAAAANSUhEUgAAADAAAAAwBAMAAAClLOS0AAAABGdBTUEAALGPC/xhBQAAACBj
 SFJNAAB6JgAAgIQAAPoAAACA6AAAdTAAAOpgAAA6mAAAF3CculE8AAAAD1BMVEU0P0OUYm+hqqnv
 8O7///8wBPU6AAAAAWJLR0QEj2jZUQAAAAd0SU1FB+UBBw8vJA+pqhkAAAG5SURBVDjLdZTbscQg
 CIbFNCCmAYQGEui/twVvcc7McfYhy5cfuSaldaqYNYD097jZj/5jXwS3HXgCI/+XOZUJcAN1U9kK
 wOXKJeARLAJ5240rYqnL1Qkyc8ElqQdIDpYCDmBUmWpXlBOovQmBlqv7A/z6lQsUPly9R+54Au2J
 nfkpyy6XzqC6BYvX0p/CxBswezDlZhdHDjLSq/JS8bCR0nVHgWEAriLcXn+zkosfB7ZAhNlmok/U
 zmFiZf9pq6VmzzzArQkLqN9c0kXJS9cSikax/cbsghwVGk011nSNmKW1SEsnUJ6gZKYAOcADZuJB
 BUDgpiYUoYNCtKp2AKBsKmSMzJICiPQ7ArCDONICaFfkxo3ZntG/GuNgA2ilSMuzF41BWiBxJjdq
 Lz15pHhNIPzsmbaooUyQSa9zfHqfPSavtsABxnNsQEpG31BPdfSvJHs/X/O+AFw80Q2KLoDVX3q2
 JG9Qa8zTkrzXduVj789LQkPQq9u8uGxlerIP1CZO9B4b+IGEzW3cvBtMKZ8AAX0hC8TmXRuE8Tse
 CXJtHZyk77XK6GA0ZHwTbtrflD6igDGyTLELuzI/gZ6Ak5LRf9kAAAAldEVYdGRhdGU6Y3JlYXRl
 ADIwMjEtMDEtMDdUMTU6NDc6MzUrMDA6MDA/PWjFAAAAJXRFWHRkYXRlOm1vZGlmeQAyMDIxLTAx
 LTA3VDE1OjQ3OjM1KzAwOjAwTmDQeQAAAABJRU5ErkJggg==
X-Now-Playing: It's Immaterial's _Life's Hard And Then You Die_: "Rope"
Date: Thu, 07 Jan 2021 16:49:52 +0100
In-Reply-To: <dc27f714-8200-bc8b-af37-233bd6b69486@HIDDEN> (martin rudalics's
 message of "Thu, 7 Jan 2021 16:35:40 +0100")
Message-ID: <87k0so3fxb.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview:  martin rudalics <rudalics@HIDDEN> writes: > Sorry, I didn't
 notice that you've pushed that already. So > > +To change which window is
 used, set `display-buffer-base-action' > +to a list containing one of these
 \"action\" functions: > > is ano [...] 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 45688
Cc: 45688 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

martin rudalics <rudalics@HIDDEN> writes:

> Sorry, I didn't notice that you've pushed that already.  So
>
> +To change which window is used, set `display-buffer-base-action'
> +to a list containing one of these \"action\" functions:
>
> is another wrong interpretation

:-)

> - a user should not set (or at least not start with setting)
> `display-buffer-base-action'.  The user's domain is
> `display-buffer-alist' the application's domain is the ACTION
> argument.  Please try to stick to these two, maybe not even mentioning
> the rest at all.

I've now changed it to `display-buffer-alist'.

By the way, the example in the Emacs manual is this:

(customize-set-variable
 'display-buffer-alist
 '("\\*scratch\\*" (display-buffer-same-window)))

Which isn't an alist?

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#45688; Package emacs. Full text available.

Message received at 45688 <at> debbugs.gnu.org:


Received: (at 45688) by debbugs.gnu.org; 7 Jan 2021 15:39:42 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Jan 07 10:39:42 2021
Received: from localhost ([127.0.0.1]:48347 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kxXO2-0008Gb-1B
	for submit <at> debbugs.gnu.org; Thu, 07 Jan 2021 10:39:42 -0500
Received: from quimby.gnus.org ([95.216.78.240]:39102)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1kxXNz-0008GN-Rf
 for 45688 <at> debbugs.gnu.org; Thu, 07 Jan 2021 10:39:40 -0500
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnus.org;
 s=20200322; h=Content-Type:MIME-Version:Message-ID:In-Reply-To:Date:
 References:Subject:Cc:To:From:Sender:Reply-To:Content-Transfer-Encoding:
 Content-ID:Content-Description:Resent-Date:Resent-From:Resent-Sender:
 Resent-To:Resent-Cc:Resent-Message-ID:List-Id:List-Help:List-Unsubscribe:
 List-Subscribe:List-Post:List-Owner:List-Archive;
 bh=pTaFELhSNTYiKyrzOHijab74GZ7TBgWKvAojqz+PnCY=; b=jkb3ps4wxVJdbb4qxGpPiJ1qqq
 iWk6HdywGwifdMprGOxjG2YSv3dvwnsXX8SYLRRtmSRwM7c6afZTJKSVnF4yLd9TCLqdNj8NTvA1J
 4G9qaq2InYHw5eAO2Nrh22xBf7NxG7sxz2icYEkX5IJFr1BhajX+ZK23a9qluTF0w3VA=;
Received: from cm-84.212.202.86.getinternet.no ([84.212.202.86] helo=xo)
 by quimby.gnus.org with esmtpsa (TLS1.3:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.92) (envelope-from <larsi@HIDDEN>)
 id 1kxXNq-0004Y7-PS; Thu, 07 Jan 2021 16:39:33 +0100
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: martin rudalics <rudalics@HIDDEN>
Subject: Re: bug#45688: 28.0.50; New action for display-buffer?
References: <87im8a1dff.fsf@HIDDEN> <83y2h6133r.fsf@HIDDEN>
 <8735ze0yp7.fsf@HIDDEN> <83o8i20w1f.fsf@HIDDEN>
 <87lfd5yny9.fsf@HIDDEN>
 <a25dc85e-cd8e-8164-676e-bb6a0f381c06@HIDDEN>
Face: iVBORw0KGgoAAAANSUhEUgAAADAAAAAwBAMAAAClLOS0AAAABGdBTUEAALGPC/xhBQAAACBj
 SFJNAAB6JgAAgIQAAPoAAACA6AAAdTAAAOpgAAA6mAAAF3CculE8AAAAD1BMVEXt9Ni5w6KIknZR
 Tkn///+5aDmTAAAAAWJLR0QEj2jZUQAAAAd0SU1FB+UBBw8kEbrut/EAAAGjSURBVDjLbZOBkcQg
 CEUl24CwDQRs4CL993YfMW7cOzKTmfAE5ENKCeOwWv4YMZsOBGiPA8xiwky1aKFaC8H1AQZA+Nbx
 plUCgFVZ+cAZIv4APGqiVcSM9bqLR+lKqFIUVUTPda2ve95XG03k17jzfqpdeZh2P0vrmXVFRH5R
 0Qnw3JXh7x0g1KClGuGSSG8mLjWbqutm0lTM+4z4SEsCcd29j7ZoAeHm9ga46t3SAJiEwZr7SCXn
 Aia9eWc306c8ZAO4uWsfmW2G9A6fO4KKR4Kllcf5KF0Oz3HOXGY+Qs7yDoApawKxzFVLcygbmiR4
 e6ZSa1rDd8wiBwr38Md3JcxchmiFoEWDumhMThYRpZzlESqNVNZ+cjz1TjWsQ5Wr3EuYqYZBsQHO
 J7hktN40tZtB0RzllWPqbLxAh7AD2HNS0ATjS+D1CbDFPrv3bQulYRHcppIPOwJwgp8NeNM5kx28
 vNXZ5J8IRkQ8fu3AYm9fOd/nj+F2No5F6a7br+HWrthEl2470FbRpeFX2Bos7RpL+uWNdejFvv/b
 BFr+N/rH9ws+hkt2nuNQ0QAAACV0RVh0ZGF0ZTpjcmVhdGUAMjAyMS0wMS0wN1QxNTozNjoxNysw
 MDowMCx+ACwAAAAldEVYdGRhdGU6bW9kaWZ5ADIwMjEtMDEtMDdUMTU6MzY6MTcrMDA6MDBdI7iQ
 AAAAAElFTkSuQmCC
X-Now-Playing: Michelle Shocked's _The Texas Campfire Tapes_: "The Secret To
 A Long Life (Is Knowing When It's Time To Go)"
Date: Thu, 07 Jan 2021 16:39:29 +0100
In-Reply-To: <a25dc85e-cd8e-8164-676e-bb6a0f381c06@HIDDEN> (martin rudalics's
 message of "Thu, 7 Jan 2021 14:17:22 +0100")
Message-ID: <87o8i03gem.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview: martin rudalics <rudalics@HIDDEN> writes: >> As Martin
 explained, 
 display-buffer-use-some-window almost does this, >> but since switching to
 the buffer doesn't count as "use", it doesn't >> work for this particular
 use case. > > Switching to [...] 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 45688
Cc: Eli Zaretskii <eliz@HIDDEN>, 45688 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

martin rudalics <rudalics@HIDDEN> writes:

>> As Martin explained, display-buffer-use-some-window almost does this,
>> but since switching to the buffer doesn't count as "use", it doesn't
>> work for this particular use case.
>
> Switching to the buffer does count as "use" but 'display-buffer' doesn't
> switch to the buffer because it doesn't select it.

Sorry; I meant "use the window".

> Add a function say 'window-bump-use-time' that does
>
>       w->use_time = ++window_select_count;
>
> and call that from `display-buffer'.

Thanks!

I've now pushed this -- like I said, my familiarity with this area in
Emacs is approx. nil, so if this implementation is beyond stupid, please
feel free to pipe up.  :-)

But with this setting:

  (setq display-buffer-base-action '(display-buffer-use-least-recent-window))

it's quite XEmacs-like?  I think?  At least in my tests.  So now we've
got that all-important ex-XEmacs market segment covered.

The only oddity is that it'll resize windows to their previous sizes --
is there any way to inhibit that?

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#45688; Package emacs. Full text available.

Message received at 45688 <at> debbugs.gnu.org:


Received: (at 45688) by debbugs.gnu.org; 7 Jan 2021 15:35:51 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Jan 07 10:35:51 2021
Received: from localhost ([127.0.0.1]:48338 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kxXKJ-0008AO-2u
	for submit <at> debbugs.gnu.org; Thu, 07 Jan 2021 10:35:51 -0500
Received: from mout.gmx.net ([212.227.15.18]:58749)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <rudalics@HIDDEN>) id 1kxXKF-0008A7-VJ
 for 45688 <at> debbugs.gnu.org; Thu, 07 Jan 2021 10:35:49 -0500
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=gmx.net;
 s=badeba3b8450; t=1610033741;
 bh=AyazaW8lYXJqie0ZwPqrnryY7ABuOJqBHACE3S1d3Ro=;
 h=X-UI-Sender-Class:Subject:To:Cc:References:From:Date:In-Reply-To;
 b=hUNrdZgHrPJD9QKGSIh5H11Q5AhtrHNULyS4N8ZNilifd0sR3LY5h/9ILVaHgIPMJ
 jOLShD4zvn31EmsbjtmcyywASiIt9KLvxdcAWs1epyGltEOkAKOnD7dcX/qnEIlXp7
 7wa3R6o2GXRCaXj7BhHQXs8WOdxSymOOhU65dENI=
X-UI-Sender-Class: 01bb95c1-4bf8-414a-932a-4f6e2808ef9c
Received: from [192.168.1.100] ([212.95.5.167]) by mail.gmx.com (mrgmx005
 [212.227.17.190]) with ESMTPSA (Nemesis) id 1MHoRA-1kiflL2u9u-00EqsB; Thu, 07
 Jan 2021 16:35:41 +0100
Subject: Re: bug#45688: 28.0.50; New action for display-buffer?
To: Lars Ingebrigtsen <larsi@HIDDEN>
References: <87im8a1dff.fsf@HIDDEN>
 <6d33f679-925e-78ee-2055-0520538f48f5@HIDDEN> <87ble217jy.fsf@HIDDEN>
 <8bc28c07-a4af-f58d-97f5-9d0a89ff58fe@HIDDEN> <87h7ntynpx.fsf@HIDDEN>
 <616655cc-9b87-cb93-6787-11e7037e8cbc@HIDDEN> <87sg7c3isu.fsf@HIDDEN>
From: martin rudalics <rudalics@HIDDEN>
Message-ID: <dc27f714-8200-bc8b-af37-233bd6b69486@HIDDEN>
Date: Thu, 7 Jan 2021 16:35:40 +0100
MIME-Version: 1.0
In-Reply-To: <87sg7c3isu.fsf@HIDDEN>
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Language: en-US
Content-Transfer-Encoding: 7bit
X-Provags-ID: V03:K1:/9Z/kuwFe9tiNksBiHn7cNJrm1h/5zGpjakSHuOp9Txh6K02h50
 ngOK4VQP48biJME+Y+RLx5BRp7pCImWSo9Z58tis0MRrHs/2EXoQDhmysZh/tcntbY88RRQ
 a3j0U6Lhj5xlM7Lmsv38H2Pn71iuMzrt8jENbp9uP9Irtl6jeZMkOPXbAkKj05LNQ709zek
 xtYaf2Wwey9r18pQymFRg==
X-Spam-Flag: NO
X-UI-Out-Filterresults: notjunk:1;V03:K0:Uwo8JDERdd4=:WODw+k7mjs2DG8FHtOtDyZ
 b4IhIWMCMxWjrlDll+rluCGoRSPaY7M4l8HXRyMhtQaowK0AZO7irV44cQ3HT9bxhHvZYpRmV
 /jDzO2xm0N+oLMQY+42kPBM8jtguuED0cKH29rNP4ZDySi+uwldSlLUPF9PWslyIs1J9kNy6L
 360lKHJ9h1qixRmZPqZbDObT4ENypCGT3+ktErcyF2j1jY5eanYg6oqCcw91WsiJaRjGEnF3j
 AWjh7UUzmPrpwh1Hu7c/b0R221wHFRyeUinzUCHHz3oF9UdhIP5lChroPw6/a46CSxMkAEbAT
 SzR+50o7ho23wi/zhLUMbsU3v848ZH7WAv08SK41UIO669JYAwu9veAbHJVziOcoo6HzmQYDC
 U2wW9o/2VR3nRKfZqfyw0TXcNfghbCJiESnoBDy6KE15MOw/21EmKGcu4ccK9AYg/mPzoMi4u
 UQcem/l0wOXgflYTGTajZaJLTXoRmasoTKRJAGxZgj5rEJ/JgKWapCTsa/PWIjpEb6RGPmG5/
 ymH6Dh7m/EUpIN4UhftQlqNkvfN9Rp856H5t6oA8uQYcyJ3iXmUDurUL397wAzFrsodfypMSN
 kxvIeh7QPYmypRZYBoLfuNqVtAbsoZrIQcvB2LFot8lqjuoXXZ6mZ8HopwszvsApFKuWwaVz8
 RXC3zFLG2Fy+VnrPtObeJZlygwTG57zKkrvei90rIoGeuaREAbjFS/Sx0fNVQO2kA1sXvwWjM
 1u5DPvnGi7Dvpqowgou3uFn6/zVYmpDY2/x3sITNWWJGgkeBX31y2QN8Rk8HaHuvgYQnGsYIW
 +XhHvd3YpJHvKt3EMpPTVc5+9tBk11NCtLp44aFAU/aR7+gZ7mTq6YsdwuLcRLBi6Sv2Y+g9y
 0W8Hc7P0quRg9JHaO3CQ==
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 45688
Cc: 45688 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

 > I've now shuffled it
 > to the front, and given a bit more introductory text to make it sound
 > less intimidating.

Sorry, I didn't notice that you've pushed that already.  So

+To change which window is used, set `display-buffer-base-action'
+to a list containing one of these \"action\" functions:

is another wrong interpretation - a user should not set (or at least not
start with setting) `display-buffer-base-action'.  The user's domain is
`display-buffer-alist' the application's domain is the ACTION argument.
Please try to stick to these two, maybe not even mentioning the rest at
all.

martin




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#45688; Package emacs. Full text available.

Message received at 45688 <at> debbugs.gnu.org:


Received: (at 45688) by debbugs.gnu.org; 7 Jan 2021 15:18:02 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Jan 07 10:18:02 2021
Received: from localhost ([127.0.0.1]:48321 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kxX33-0007j9-Rv
	for submit <at> debbugs.gnu.org; Thu, 07 Jan 2021 10:18:02 -0500
Received: from mout.gmx.net ([212.227.15.15]:56127)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <rudalics@HIDDEN>) id 1kxX31-0007in-NT
 for 45688 <at> debbugs.gnu.org; Thu, 07 Jan 2021 10:18:00 -0500
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=gmx.net;
 s=badeba3b8450; t=1610032673;
 bh=NDpygpibSJiKJ/GgCK4SIv1wAdcB7+4aitmXZFQUO9s=;
 h=X-UI-Sender-Class:Subject:To:Cc:References:From:Date:In-Reply-To;
 b=LSKVdQFuuH3IGrD/u47ZHjSiCF+uq2geFTpcKS27zHKp/pvXInIgODiqOdJJh8HrJ
 HoyjU8GBgOKIQSoTzju/WPfrvstYZTVt4tO7OTzhGvIIrhIC0FasMfyVvE80HEZno1
 +ZqyViNbCyw3s0iuYxPszqNlW40pLdGiibBSlHzo=
X-UI-Sender-Class: 01bb95c1-4bf8-414a-932a-4f6e2808ef9c
Received: from [192.168.1.100] ([212.95.5.167]) by mail.gmx.com (mrgmx005
 [212.227.17.190]) with ESMTPSA (Nemesis) id 1MUXtS-1kXAUT1JL6-00QUJC; Thu, 07
 Jan 2021 16:17:53 +0100
Subject: Re: bug#45688: 28.0.50; New action for display-buffer?
To: Lars Ingebrigtsen <larsi@HIDDEN>
References: <87im8a1dff.fsf@HIDDEN>
 <6d33f679-925e-78ee-2055-0520538f48f5@HIDDEN> <87ble217jy.fsf@HIDDEN>
 <8bc28c07-a4af-f58d-97f5-9d0a89ff58fe@HIDDEN> <87h7ntynpx.fsf@HIDDEN>
 <616655cc-9b87-cb93-6787-11e7037e8cbc@HIDDEN> <87sg7c3isu.fsf@HIDDEN>
From: martin rudalics <rudalics@HIDDEN>
Message-ID: <3a1fc415-75f1-8b91-216d-0cad63a3eaa0@HIDDEN>
Date: Thu, 7 Jan 2021 16:17:52 +0100
MIME-Version: 1.0
In-Reply-To: <87sg7c3isu.fsf@HIDDEN>
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Language: en-US
Content-Transfer-Encoding: quoted-printable
X-Provags-ID: V03:K1:5LcPDLalYl3P4KfS3IzjOz3zuuHVJEINfofUdQkUeZulzKZScRd
 S210t49r9LL4Qn/wymw52fz6u47Rc40SngVDxzRCrR0QbScmVHMJHs/lP3H92lk2YP0Tv/b
 JMo4q9cSGiMjJlBVwvc285t+nDr6T1dm1Y7dDt5LDRWJs8RYgYXAQTtST5pfJQHPGuKovb4
 B4IsB4W+DeAsJN5jt5iVQ==
X-Spam-Flag: NO
X-UI-Out-Filterresults: notjunk:1;V03:K0:jhBigScxzBI=:zOlScZBf2R9AOi3NYqr8qL
 GPn+Ov2RZlCx/hVA0ibtIXqSssPYp1O2iNYhW/0oLUcEU511JVWGx0JTxecDwmAxVcvZQufMv
 OQiNQUdgCMaTMjBE66zT/QhdKtq7jQS1nFJYFLXfVKVGS8pf3nszcdcTVr4RQdzN6wT4OGuNS
 wp2C2MEM59HV1T0JAJCpWhycHPmFKfTgrYX4k4TM+2a8lrlwFwnz+CFv4f+4BJ4ve3hE9biJm
 wkJlwJBZ2QNRONqqSfiqG02cQDz0dl5e7OKgoa8B6z81hNFTlOU5xvIlbkFc8Qwy/xpH4Bwxa
 KZLFO2RhHjqXoNB5XEeD3ptFbFlW+akvBnv6mUcguwmL57W/Z6HGaRF5kgesVhmpRmei6OZHd
 mkogVLAzI6em3WYiRu8S9foRslGao7zfk3mdJ49yQxBLtZTjz3RLuXXk4ntdb41wt867UdOvl
 w8tZ3DxBUS2UvtVqbYmtNdqYB9Lne27pgcohF+b+8fUUxIhIqGNeXPpNkWlg9caTFBBSVvBZ8
 mBpbAJyHQsXy/97UVbQWWMOKlbqbCLmkkg37l31jIHFVCliQcNhVd7funj8bcQDrnhEYUW46/
 hIXRQOPi3fy9hj6qtjo+w+P33r6joAhvT8R/31JZE/xUQ9rbMe0c8GcryCnvSsihmU/iLkO/Z
 1mAURB62ZwO0fPsTtNFk/n14Fnv15AX1OC+2Zulm/Y/4We4Nayc0Nj2d+E76C9EircypL2gIV
 BdA6Ql5Q6iQI6ddCfjWRUyk+/gaKPNVuNheknRVS5HagHyZ4ZteNkQlpmlCZrxlyEm4lqkKCo
 gg9h39uUE/JtJyovvT6hJdwckpyFXJPjPoBWC6xLdkp267VcHWA23uslJ7HyTUfBBvTaTVmBE
 KmjJGXUTmLxBAVcEdPeQ==
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 45688
Cc: 45688 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

 >> By no means.  `display-buffer-overriding-action' is _not_ intended fo=
r
 >> the user.  It's an emergency exit for applications.  Better not even
 >> mention it in the user manual and the doc-string.
 >
 > See, I didn't even get that bit from the doc string.  :-)

Given that 'display-buffer-overriding-action' figures first in

   =E2=80=98display-buffer=E2=80=99 builds a list of action functions and=
 an action
   alist by combining any action functions and alists specified by
   =E2=80=98display-buffer-overriding-action=E2=80=99, =E2=80=98display-b=
uffer-alist=E2=80=99, the
   ACTION argument, =E2=80=98display-buffer-base-action=E2=80=99, and
   =E2=80=98display-buffer-fallback-action=E2=80=99 (in order).  Then it =
calls each
   function in the combined function list in turn, passing the
   buffer as the first argument and the combined action alist as the
   second argument, until one of the functions returns non-nil.

your interpretation is quite logical.  The problem here is that we talk
in operative terms like "builds" "combining" "calls" "passing" which
hardly contributes anything to the understanding of an average user.

In a first approximation it should suffice to talk here about
`display-buffer-alist' and the ACTION argument only and ...

 >> In every other regard, feel free to change it in a way that sounds le=
ss
 >> imitating.  For example, listing the action functions and alist entri=
es
 >> in the doc-string is merely distracting.  We started out with small s=
ets
 >> and every time a new function or entry was added, we also added it to=

 >> those lists.
 >
 > It's an overwhelming doc string, but I think listing the action
 > functions is one of the best bits about it.  :-)

=2E.. here I'd just say what they can do - reuse the selected window, a
window showing the buffer already, some other window, pop up a new
window on this or another frame.

 > I've now shuffled it
 > to the front, and given a bit more introductory text to make it sound
 > less intimidating.
 >
 >> And while you're there you could try to make the Emacs
 >> manual entry more amenable for its audience.  IIUC that's what the bl=
og
 >> you mentioned criticized even more than the doc-string.
 >
 > Yeah, the manual is rather abrupt here, too, but the entire thing is
 > really complicated, and caters for many different use cases, so I don'=
t
 > really even know where to begin.

By dropping what you understand least.  If this makes it an empty
entrance, start from scratch with what you wanted to know first.  If
anything is incorrect, I'll fix it.  But making this readable for a user
is next to impossible, at least for me (I'm repeating myself whenever I
talk about this subject).  Have a look at the Elisp manual where I try,
maybe it helps.

martin





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#45688; Package emacs. Full text available.

Message received at 45688 <at> debbugs.gnu.org:


Received: (at 45688) by debbugs.gnu.org; 7 Jan 2021 14:48:01 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Jan 07 09:48:01 2021
Received: from localhost ([127.0.0.1]:46931 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kxWa0-0006dK-Mz
	for submit <at> debbugs.gnu.org; Thu, 07 Jan 2021 09:48:00 -0500
Received: from quimby.gnus.org ([95.216.78.240]:38538)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1kxWZv-0006d3-Nz
 for 45688 <at> debbugs.gnu.org; Thu, 07 Jan 2021 09:47:59 -0500
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnus.org;
 s=20200322; h=Content-Type:MIME-Version:Message-ID:In-Reply-To:Date:
 References:Subject:Cc:To:From:Sender:Reply-To:Content-Transfer-Encoding:
 Content-ID:Content-Description:Resent-Date:Resent-From:Resent-Sender:
 Resent-To:Resent-Cc:Resent-Message-ID:List-Id:List-Help:List-Unsubscribe:
 List-Subscribe:List-Post:List-Owner:List-Archive;
 bh=/7pELpIIGRkcAqZQMEDg9mh5+HCkkhJ6E6pws1KLJmw=; b=mbPuJ1k5GKYVFtqkFdqv0++uzI
 oDQT/MXyf6N9SVFHef9lvl9K8PKLk+LKVRNiquXRpZQzWMmvpIAKkQialiH2HNYJlEmvJO0I+yrl/
 doGrvJlSB50rlmywHeiz0wNG/MOMOhOwjLQC6vP1jXWvfuozHoSjDPz4ywgODT4SM1kw=;
Received: from cm-84.212.202.86.getinternet.no ([84.212.202.86] helo=xo)
 by quimby.gnus.org with esmtpsa (TLS1.3:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.92) (envelope-from <larsi@HIDDEN>)
 id 1kxWZm-00041R-Qj; Thu, 07 Jan 2021 15:47:49 +0100
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: martin rudalics <rudalics@HIDDEN>
Subject: Re: bug#45688: 28.0.50; New action for display-buffer?
References: <87im8a1dff.fsf@HIDDEN>
 <6d33f679-925e-78ee-2055-0520538f48f5@HIDDEN>
 <87ble217jy.fsf@HIDDEN>
 <8bc28c07-a4af-f58d-97f5-9d0a89ff58fe@HIDDEN>
 <87h7ntynpx.fsf@HIDDEN>
 <616655cc-9b87-cb93-6787-11e7037e8cbc@HIDDEN>
Face: iVBORw0KGgoAAAANSUhEUgAAADAAAAAwBAMAAAClLOS0AAAABGdBTUEAALGPC/xhBQAAACBj
 SFJNAAB6JgAAgIQAAPoAAACA6AAAdTAAAOpgAAA6mAAAF3CculE8AAAAG1BMVEWtp5nl3ci0rqPN
 vq+alYyRf2dbUFETCgz///+G0CkAAAAAAWJLR0QIht6VegAAAAd0SU1FB+UBBw4tCuCLr2MAAAFc
 SURBVDjLldTdboMgFAdwykx67Zrd02Oz3baebrvtBcYH8OveVniBTl5/gCJKNNn+iTHyywH5ULKL
 10OOf4YDmmg4UDBhxIXrlDHZHQhdtFu5GaABRBMEBXNgQU+cu8FDuG3BVAFBOx/HqGyKdJhQ5KEW
 NuOtm+DUC9mrnpeNMvmZgAkhhWzxU9/7WgQgksR2FVQIecezaZchiBQxZTyTqnssoAW7D9h0VbcA
 SEwzwVrUzzk8UgN71eZSPE8DgAVIri+oVL/X16ICk7xI9ezyEAjmxaVR/UcIlQbU0Dg4zkHatfIA
 erYa7huwv1/FHGILPYf34kstACyAnvr3GhANb1uQrgLVi9WsjsEysVZhtk6NrxtNkFUuJedZ6QER
 fNyBi8dHG+YOqQcrw/E2cPEAlFlgQVdAGB0/0iioAPeVLrtihLoSV5EMJw3PzFdkBtzf5BX8+0UG
 Nv4l/4ZfnCnXdaRaFEoAAAAldEVYdGRhdGU6Y3JlYXRlADIwMjEtMDEtMDdUMTQ6NDU6MTArMDA6
 MDD2Q0mnAAAAJXRFWHRkYXRlOm1vZGlmeQAyMDIxLTAxLTA3VDE0OjQ1OjEwKzAwOjAwhx7xGwAA
 AABJRU5ErkJggg==
X-Now-Playing: Blaine L. Reininger's _Live in Brussels_: "track"
Date: Thu, 07 Jan 2021 15:47:45 +0100
In-Reply-To: <616655cc-9b87-cb93-6787-11e7037e8cbc@HIDDEN> (martin rudalics's
 message of "Thu, 7 Jan 2021 14:18:04 +0100")
Message-ID: <87sg7c3isu.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview: martin rudalics <rudalics@HIDDEN> writes: > By no means.
 `display-buffer-overriding-action'
 is _not_ intended for > the user. It's an emergency exit for applications.
 Better not even > mention it in the user manual and the doc-string. 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 45688
Cc: 45688 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

martin rudalics <rudalics@HIDDEN> writes:

> By no means.  `display-buffer-overriding-action' is _not_ intended for
> the user.  It's an emergency exit for applications.  Better not even
> mention it in the user manual and the doc-string.

See, I didn't even get that bit from the doc string.  :-)

> In every other regard, feel free to change it in a way that sounds less
> imitating.  For example, listing the action functions and alist entries
> in the doc-string is merely distracting.  We started out with small sets
> and every time a new function or entry was added, we also added it to
> those lists.

It's an overwhelming doc string, but I think listing the action
functions is one of the best bits about it.  :-)  I've now shuffled it
to the front, and given a bit more introductory text to make it sound
less intimidating.

> And while you're there you could try to make the Emacs
> manual entry more amenable for its audience.  IIUC that's what the blog
> you mentioned criticized even more than the doc-string.

Yeah, the manual is rather abrupt here, too, but the entire thing is
really complicated, and caters for many different use cases, so I don't
really even know where to begin.

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#45688; Package emacs. Full text available.

Message received at 45688 <at> debbugs.gnu.org:


Received: (at 45688) by debbugs.gnu.org; 7 Jan 2021 13:18:16 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Jan 07 08:18:15 2021
Received: from localhost ([127.0.0.1]:46800 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kxVB9-0004M6-LW
	for submit <at> debbugs.gnu.org; Thu, 07 Jan 2021 08:18:15 -0500
Received: from mout.gmx.net ([212.227.17.20]:34427)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <rudalics@HIDDEN>) id 1kxVB4-0004Ln-V0
 for 45688 <at> debbugs.gnu.org; Thu, 07 Jan 2021 08:18:15 -0500
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=gmx.net;
 s=badeba3b8450; t=1610025485;
 bh=m/7NWDTb8w+63sQpPIRMqXAB/TGRrwHk7YaK6+y8vaY=;
 h=X-UI-Sender-Class:Subject:To:Cc:References:From:Date:In-Reply-To;
 b=JIYNoGk/FmCbgbLU52slgBnNUDxABcJeJOywrSZ9Os9NemBEUN5Ok1vQG0huH5mwR
 I6koTaczP+eHfA1Dx2Gr/bOMTLsoz5SoTyqelG2NMa4Z6Bjm8ZGW+m+2E29Y+uv//r
 e+d3vOY2gLdnhcFR2t9PnLGYB3cQnc8ZWEw0oD3g=
X-UI-Sender-Class: 01bb95c1-4bf8-414a-932a-4f6e2808ef9c
Received: from [192.168.1.100] ([212.95.5.167]) by mail.gmx.com (mrgmx104
 [212.227.17.168]) with ESMTPSA (Nemesis) id 1MmULx-1kFP493Skb-00iVgP; Thu, 07
 Jan 2021 14:18:04 +0100
Subject: Re: bug#45688: 28.0.50; New action for display-buffer?
To: Lars Ingebrigtsen <larsi@HIDDEN>
References: <87im8a1dff.fsf@HIDDEN>
 <6d33f679-925e-78ee-2055-0520538f48f5@HIDDEN> <87ble217jy.fsf@HIDDEN>
 <8bc28c07-a4af-f58d-97f5-9d0a89ff58fe@HIDDEN> <87h7ntynpx.fsf@HIDDEN>
From: martin rudalics <rudalics@HIDDEN>
Message-ID: <616655cc-9b87-cb93-6787-11e7037e8cbc@HIDDEN>
Date: Thu, 7 Jan 2021 14:18:04 +0100
MIME-Version: 1.0
In-Reply-To: <87h7ntynpx.fsf@HIDDEN>
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Language: en-US
Content-Transfer-Encoding: quoted-printable
X-Provags-ID: V03:K1:eka98lVsaL6myujdPbAgoYoWdVvxCPrgsa7Z2+epPDj2Y/I1APQ
 j+LtXGgvSbfjNhacvSW4CIrevn/ALu0+oo3KOMYhZ2nYypAugpwli7yzcnK/TEo33yrqe23
 PnszKRJ+FF0XA7Rh629++gL7bYC+XkTR7OHUqTKvUPRkApHMgvhbd5LzOE08Kk5HW22CGs2
 R3bbWoehzRofNwctpR8tw==
X-Spam-Flag: NO
X-UI-Out-Filterresults: notjunk:1;V03:K0:+HnhxqdOKG8=:WDEGfOdUKAvBlJYiyIiyqb
 S0mnOUgGlxy+hsai1P6ZsanRzA88FFNeVljEfovQVxN7RAFTgy4G121E+3FUwtYqNsnu2AwG2
 BoktGFEacXNkU+jqnbSZeW5568jzNucNrrMGreI4X5x+SnhaYpHXC7UMIpeYilWsNbzCy8QnC
 2PUqhorPYM+Xn0zPAe1LIaI1IwW0CUX6AAiqEhdilI4SXPkyHpvrGgptmxOYSlsvMwtsYRjOR
 u6ASOV4BRosJJJJPBTu5aKFbt8BCZOaNuHantEUAI4oZgnMeoDsL+h5ASEOONFXWLLk1mkH6o
 mrkfBeZIflD4wV/qjsg6FzR8RVLdJHww5/Fa37PhE6eCvchKO/yUUcVMZRlBldBYa68qaXIic
 +O6JtpdrQtIzQV08piMCPOhv3vX+/+IdO+lhNGg5rSQP9a+YmIdSxAUaQ23V55nkjwBqDEB9x
 wrhKqcWCBoU9dDVAmP7NtB6akY+CISEBEY3uWmjTTW/jWGGbYywhS1dW8tm0dBl8youCFOO34
 Lqk0Rvt3GEWswb1DVpaFgFmo31AoQSOU7LOqH7QQEQVV/IDhvZZuP12nnysWTz90iZHz0vft0
 QioG5ZzM6J/UQzqjgnfI2uegawHhiHlJArDoDtRKRzm02ArjvM2eAp6irRBOrn4JNx2k/uYbj
 TiyP/klRV79eCALQb3gzQ4Cp3Ww3XSVDiXqk9EmRjyHutoDVAJ9SF0fAPCW0LDWjEcg4/G6UU
 RNzZMBGL09/BSZ7HA4RMkwlBdmPtyiQjgwmE7g9sdp509exzSD8Jo9pVkSt2qeP1TSLTbaD6z
 TQ8dbq5H8K8/4H/98z7qfM6UI5ALMfX4behWCaqOcibCdQbBG+kjvtpEnfrrUOY3AfPlDC3uo
 3z6MJvLqTFd/mlKjwisA==
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 45688
Cc: 45688 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

 > I think the doc string for `display-buffer' is pretty intimidating now=
,
 > and seems more geared towards programmers than usage now.  Would it ma=
ke
 > sense to rearrange it a bit?  That is, start off with something like:
 >
 > -----
 >
 > Display BUFFER-OR-NAME in some window, without selecting it.  To chang=
e
 > what window is used, set `display-buffer-overriding-action' to a list
 > containing one or more of the following functions:
 >
 > Action functions and the action they try to perform are:
 >   =E2=80=98display-buffer-same-window=E2=80=99 -- Use the selected win=
dow.
 >   =E2=80=98display-buffer-reuse-window=E2=80=99 -- Use a window alread=
y showing
 >      the buffer.
 >   =E2=80=98display-buffer-in-previous-window=E2=80=99 -- Use a window =
that did
 >      show the buffer before.
 >
 > etc etc, and then give the details about ACTION and the rest?

By no means.  `display-buffer-overriding-action' is _not_ intended for
the user.  It's an emergency exit for applications.  Better not even
mention it in the user manual and the doc-string.

In every other regard, feel free to change it in a way that sounds less
imitating.  For example, listing the action functions and alist entries
in the doc-string is merely distracting.  We started out with small sets
and every time a new function or entry was added, we also added it to
those lists.  And while you're there you could try to make the Emacs
manual entry more amenable for its audience.  IIUC that's what the blog
you mentioned criticized even more than the doc-string.

martin





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#45688; Package emacs. Full text available.

Message received at 45688 <at> debbugs.gnu.org:


Received: (at 45688) by debbugs.gnu.org; 7 Jan 2021 13:17:35 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Jan 07 08:17:35 2021
Received: from localhost ([127.0.0.1]:46796 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kxVAV-0004Kk-9R
	for submit <at> debbugs.gnu.org; Thu, 07 Jan 2021 08:17:35 -0500
Received: from mout.gmx.net ([212.227.17.22]:40599)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <rudalics@HIDDEN>) id 1kxVAQ-0004KR-Lh
 for 45688 <at> debbugs.gnu.org; Thu, 07 Jan 2021 08:17:33 -0500
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=gmx.net;
 s=badeba3b8450; t=1610025444;
 bh=wcUcy6hr80nAagPzJiG04Tc0lRbAbcHuvoX263F2knU=;
 h=X-UI-Sender-Class:Subject:To:Cc:References:From:Date:In-Reply-To;
 b=CpqHY0ut81pakFKQ2c1jiu8qjjTqund9gc3Qs3Kl/qRb+l8KR5g2/8ZGNESorQWuO
 365rKHwPtd9QyrhLbSDpAOyXsHZYHAlMGprFs+yJwGItdUYH6pE5jwvdh8Pr8vCg8l
 jkswmUF9C+/N9Mv+XiDOAxMSVn6/gQFu38ADOCYY=
X-UI-Sender-Class: 01bb95c1-4bf8-414a-932a-4f6e2808ef9c
Received: from [192.168.1.100] ([212.95.5.167]) by mail.gmx.com (mrgmx104
 [212.227.17.168]) with ESMTPSA (Nemesis) id 1MJVDM-1kiA8p3pEm-00Jr5k; Thu, 07
 Jan 2021 14:17:24 +0100
Subject: Re: bug#45688: 28.0.50; New action for display-buffer?
To: Lars Ingebrigtsen <larsi@HIDDEN>, Eli Zaretskii <eliz@HIDDEN>
References: <87im8a1dff.fsf@HIDDEN> <83y2h6133r.fsf@HIDDEN>
 <8735ze0yp7.fsf@HIDDEN> <83o8i20w1f.fsf@HIDDEN> <87lfd5yny9.fsf@HIDDEN>
From: martin rudalics <rudalics@HIDDEN>
Message-ID: <a25dc85e-cd8e-8164-676e-bb6a0f381c06@HIDDEN>
Date: Thu, 7 Jan 2021 14:17:22 +0100
MIME-Version: 1.0
In-Reply-To: <87lfd5yny9.fsf@HIDDEN>
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Language: en-US
Content-Transfer-Encoding: 7bit
X-Provags-ID: V03:K1:oRyGcnjNikUET9YvoKKRgU4dW1e3QphEnU+eU7xQ69iwTARRtdg
 bjeXKdwV1qcdBTTXVtU0Y9+3OxwN/JBGwBRFejhJ4sO5iPultMM4XQsJwmKP/EAi0vReHgl
 DMKenMHWWKi3k3qW3BGOCYXuJDRWcb/kB1f9veUBzkjVTvyQW8DlihqMfpLHdZN+hxn/M5t
 yix5KtTnuPU/18WRKmbbQ==
X-Spam-Flag: NO
X-UI-Out-Filterresults: notjunk:1;V03:K0:b3cgTXopgcg=:5ZvxG1YipJLl9p1T81yMtf
 dPVyxj9/zMOhymbLtPibm4MGom4G35fm04+PVZw8wwnkRyM9XwxhjCQMFwtlmM/Ge4Ba7oQdt
 QJWuYk2YmFjaRmV3pSBJ5x5OP6ODZ0X2m/URP9A1oc0szMCeShbBxXbLECR8uVNIXp5Nj8qh6
 SpCyxqDID63pMYiajbZEALkSXDu/m3VI2t0yKSNHWspDCJOMP37LgZw6OeViwh7kw4UqGD8X7
 /8U2yGl8xqDt+UdkPOCvgR2WwFCRUyh1+aQ8oMZmw+26bqHcVjtNDx9/nGvYeZHB6NrxsITV/
 bziHS+TKuC1yI27Q63GZhf449Hs3A+ah2X1GK3Zv8HGHeXn0PfXN8n8ZfF9BGF9IBShG26U26
 0TyexDteA6NXkC5bdeW++7S+QrxLr/ayZgIoJSHKUAEWCBv7Edku0bXTg6zdP7X8w56g619T8
 /gBepN05GCUtLXPCS5JzG9tqHwGWoVMLiA1dpkScLPN3vtT4OfCHQdz1pvxFxuvQeWgeMhlY8
 /xwzZGvZdNeTx9WEb2xopKsGknNVY5ISejHiLa42FZRuKardIsoA0OO+LlIpibIP6f4DbBxXJ
 5Z6RiKXITbskeIWxh0BdTcP/h6GJuwIdD/jnjipJeyl4/k6GdtP0wHwcwnxcr4H58uqcgV8xO
 R8iAo8bhBY9+R34zFTmKbvVu/dxAOCJRT48WmXjz0OBYeSzRdH9az/zB/B6p8XylofAdfjDKu
 7AJA9QkdLxDc7XRyrhshwzKuf4sJ2GdC24bl/NyTIO4z5mgaFMbIaJyPUrobyyFsh/tw2Iklj
 9M1Ar8U0cnL/jzS9GPGHqDdqeIgngvVbjJ3dWpN1MiEzp0isPxM3k8gmA9s6C51RvIcDJWDuM
 EiwWEzQFFY9ferYeF4Kw==
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 45688
Cc: 45688 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

 > As Martin explained, display-buffer-use-some-window almost does this,
 > but since switching to the buffer doesn't count as "use", it doesn't
 > work for this particular use case.

Switching to the buffer does count as "use" but 'display-buffer' doesn't
switch to the buffer because it doesn't select it.

 > Adding another action here (that just calls
 > display-buffer-use-some-window, but then marks the window as having been
 > used) seems trivial, so I think I'll try doing that and see what that
 > feels like.

Add a function say 'window-bump-use-time' that does

       w->use_time = ++window_select_count;

and call that from `display-buffer'.

martin




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#45688; Package emacs. Full text available.

Message received at 45688 <at> debbugs.gnu.org:


Received: (at 45688) by debbugs.gnu.org; 7 Jan 2021 11:46:03 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Jan 07 06:46:03 2021
Received: from localhost ([127.0.0.1]:46699 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kxTju-0008ON-U6
	for submit <at> debbugs.gnu.org; Thu, 07 Jan 2021 06:46:03 -0500
Received: from quimby.gnus.org ([95.216.78.240]:36640)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1kxTjt-0008Ni-3l
 for 45688 <at> debbugs.gnu.org; Thu, 07 Jan 2021 06:46:01 -0500
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnus.org;
 s=20200322; h=Content-Transfer-Encoding:Content-Type:MIME-Version:Message-ID
 :In-Reply-To:Date:References:Subject:Cc:To:From:Sender:Reply-To:Content-ID:
 Content-Description:Resent-Date:Resent-From:Resent-Sender:Resent-To:Resent-Cc
 :Resent-Message-ID:List-Id:List-Help:List-Unsubscribe:List-Subscribe:
 List-Post:List-Owner:List-Archive;
 bh=PbkqLwMabPp3nCEkNlQ55SZnbWlmKpJPqCzBevq6zuw=; b=GFa7/qyHJ2/fRgRRAT+s7CEkPU
 dRg/8R1cHnR0wt4BvDKX1uDekDBDyMwL5msSbstGbVjk/UDyd9tyRm6TXl9AiFmi/FRZBMZMXEmSL
 MWOAUwxWpPfJw4yGxyAXZkxORj320FrdrXICiw7Hs0XYIJG4hOPL4q+wabc8oe3iglC8=;
Received: from cm-84.212.202.86.getinternet.no ([84.212.202.86] helo=xo)
 by quimby.gnus.org with esmtpsa (TLS1.3:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.92) (envelope-from <larsi@HIDDEN>)
 id 1kxTjf-000205-Ox; Thu, 07 Jan 2021 12:45:54 +0100
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: martin rudalics <rudalics@HIDDEN>
Subject: Re: bug#45688: 28.0.50; New action for display-buffer?
References: <87im8a1dff.fsf@HIDDEN>
 <6d33f679-925e-78ee-2055-0520538f48f5@HIDDEN>
 <87ble217jy.fsf@HIDDEN>
 <8bc28c07-a4af-f58d-97f5-9d0a89ff58fe@HIDDEN>
Face: iVBORw0KGgoAAAANSUhEUgAAADAAAAAwBAMAAAClLOS0AAAABGdBTUEAALGPC/xhBQAAACBj
 SFJNAAB6JgAAgIQAAPoAAACA6AAAdTAAAOpgAAA6mAAAF3CculE8AAAAElBMVEX03LSVgWXr2rwU
 DgheTjv////FslQwAAAAAWJLR0QF+G/pxwAAAAd0SU1FB+UBBwsVA4gDadcAAAGSSURBVDjLfZSL
 ba0wDIah6gC1yQBNYIEce4HE3n+m2uYQ0it6LUUR+cjvJyzLn7ZCBvC1Anz9Rh/ftpbvh0t240kL
 M5lhmS1A2RzU8+QAvIE44DjPDO0GRENrr5NUPkH3A2H8DZQDZFIoOID50PQGUHKfnDeAAAdpOXCS
 6keJqHYL7ph9VCgRzmbpjHDXZElAPoMizq8BItZQzkr16EPKK8Lqj6BS97sku50LRz1UmvQ8AY1S
 baIta4cbsAQgA0XB6/v2oQF2FuUJrJY4eY02NsmiaYDohiiwbQZae4PPANqS+g6cFPEGppVFSCwM
 SAinlAZgEK+NmDfUE0Ail4dmO3trGp/AmuHvYknUvGdyAVXLgyyWjVLEofUCPj/N5+4cJKp3Htar
 ttNlrykPae0YoM8JYsEBKk43sNSYYYicpszxiJikC6Wab8CweZp02At98mHTcV70ofuniNfM7zam
 M7gC+gu8TKo8AYaij4BsdFN/ArUAJnwADPZ5pqtRbgrDlvVr/DNK8XUN5//tozz9XpYf84OP1yk2
 CiQAAAAldEVYdGRhdGU6Y3JlYXRlADIwMjEtMDEtMDdUMTE6MjE6MDIrMDA6MDBRB4E6AAAAJXRF
 WHRkYXRlOm1vZGlmeQAyMDIxLTAxLTA3VDExOjIxOjAyKzAwOjAwIFo5hgAAAABJRU5ErkJggg==
X-Now-Playing: Jon Eberson Group's _Stories_: "So Much Better"
Date: Thu, 07 Jan 2021 12:45:46 +0100
In-Reply-To: <8bc28c07-a4af-f58d-97f5-9d0a89ff58fe@HIDDEN> (martin rudalics's
 message of "Wed, 6 Jan 2021 16:52:58 +0100")
Message-ID: <87h7ntynpx.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview: martin rudalics <rudalics@HIDDEN> writes: > You really have
 to "use" such a window which means selecting it. Just > displaying a buffer
 in a window does not count as using it. Ah, thanks. That makes sense; I'll
 try playing around with a new action that calls display-buffer-use-some-window,
 but marks the window as having been used. 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 45688
Cc: 45688 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

martin rudalics <rudalics@HIDDEN> writes:

> You really have to "use" such a window which means selecting it.  Just
> displaying a buffer in a window does not count as using it.

Ah, thanks.  That makes sense; I'll try playing around with a new action
that calls display-buffer-use-some-window, but marks the window as
having been used.

I've never actually encountered this bit of Emacs before -- I'm just
using the defaults for all the window stuff.  :-)

I think the doc string for `display-buffer' is pretty intimidating now,
and seems more geared towards programmers than usage now.  Would it make
sense to rearrange it a bit?  That is, start off with something like:

-----

Display BUFFER-OR-NAME in some window, without selecting it.  To change
what window is used, set `display-buffer-overriding-action' to a list
containing one or more of the following functions:

Action functions and the action they try to perform are:
 =E2=80=98display-buffer-same-window=E2=80=99 -- Use the selected window.
 =E2=80=98display-buffer-reuse-window=E2=80=99 -- Use a window already show=
ing
    the buffer.
 =E2=80=98display-buffer-in-previous-window=E2=80=99 -- Use a window that d=
id
    show the buffer before.

etc etc, and then give the details about ACTION and the rest?

--=20
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#45688; Package emacs. Full text available.

Message received at 45688 <at> debbugs.gnu.org:


Received: (at 45688) by debbugs.gnu.org; 7 Jan 2021 11:40:58 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Jan 07 06:40:58 2021
Received: from localhost ([127.0.0.1]:46689 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kxTf0-0008CA-7z
	for submit <at> debbugs.gnu.org; Thu, 07 Jan 2021 06:40:58 -0500
Received: from quimby.gnus.org ([95.216.78.240]:36594)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1kxTey-0008Bx-P8
 for 45688 <at> debbugs.gnu.org; Thu, 07 Jan 2021 06:40:57 -0500
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnus.org;
 s=20200322; h=Content-Type:MIME-Version:Message-ID:In-Reply-To:Date:
 References:Subject:Cc:To:From:Sender:Reply-To:Content-Transfer-Encoding:
 Content-ID:Content-Description:Resent-Date:Resent-From:Resent-Sender:
 Resent-To:Resent-Cc:Resent-Message-ID:List-Id:List-Help:List-Unsubscribe:
 List-Subscribe:List-Post:List-Owner:List-Archive;
 bh=UtLFnuH3Wzo11gNGGL9XFvLMwN64tn2zza6gRrotW/k=; b=DWekwt47raWCEXjUJlFdqJIIEW
 0thB+Wl9/ynRBQUCuvjrdbrr/PbNw9J5075U/Ince1x2WI5YADDXYacOj6+I/RcTaLqrMXHvSzcPK
 Vg1iD04SRfjfEMrfOsI4LhPFCsZp4VqEqnXX4I/p8NwmQvgQhr++mfA2Db5dGV5baIWo=;
Received: from cm-84.212.202.86.getinternet.no ([84.212.202.86] helo=xo)
 by quimby.gnus.org with esmtpsa (TLS1.3:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.92) (envelope-from <larsi@HIDDEN>)
 id 1kxTep-0001yM-R3; Thu, 07 Jan 2021 12:40:50 +0100
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#45688: 28.0.50; New action for display-buffer?
References: <87im8a1dff.fsf@HIDDEN> <83y2h6133r.fsf@HIDDEN>
 <8735ze0yp7.fsf@HIDDEN> <83o8i20w1f.fsf@HIDDEN>
Face: iVBORw0KGgoAAAANSUhEUgAAADAAAAAwBAMAAAClLOS0AAAABGdBTUEAALGPC/xhBQAAACBj
 SFJNAAB6JgAAgIQAAPoAAACA6AAAdTAAAOpgAAA6mAAAF3CculE8AAAAElBMVEX03LSVgWXr2rwU
 DgheTjv////FslQwAAAAAWJLR0QF+G/pxwAAAAd0SU1FB+UBBwsVA4gDadcAAAGSSURBVDjLfZSL
 ba0wDIah6gC1yQBNYIEce4HE3n+m2uYQ0it6LUUR+cjvJyzLn7ZCBvC1Anz9Rh/ftpbvh0t240kL
 M5lhmS1A2RzU8+QAvIE44DjPDO0GRENrr5NUPkH3A2H8DZQDZFIoOID50PQGUHKfnDeAAAdpOXCS
 6keJqHYL7ph9VCgRzmbpjHDXZElAPoMizq8BItZQzkr16EPKK8Lqj6BS97sku50LRz1UmvQ8AY1S
 baIta4cbsAQgA0XB6/v2oQF2FuUJrJY4eY02NsmiaYDohiiwbQZae4PPANqS+g6cFPEGppVFSCwM
 SAinlAZgEK+NmDfUE0Ail4dmO3trGp/AmuHvYknUvGdyAVXLgyyWjVLEofUCPj/N5+4cJKp3Htar
 ttNlrykPae0YoM8JYsEBKk43sNSYYYicpszxiJikC6Wab8CweZp02At98mHTcV70ofuniNfM7zam
 M7gC+gu8TKo8AYaij4BsdFN/ArUAJnwADPZ5pqtRbgrDlvVr/DNK8XUN5//tozz9XpYf84OP1yk2
 CiQAAAAldEVYdGRhdGU6Y3JlYXRlADIwMjEtMDEtMDdUMTE6MjE6MDIrMDA6MDBRB4E6AAAAJXRF
 WHRkYXRlOm1vZGlmeQAyMDIxLTAxLTA3VDExOjIxOjAyKzAwOjAwIFo5hgAAAABJRU5ErkJggg==
X-Now-Playing: Jon Eberson Group's _Stories_: "So Much Better"
Date: Thu, 07 Jan 2021 12:40:46 +0100
In-Reply-To: <83o8i20w1f.fsf@HIDDEN> (Eli Zaretskii's message of "Wed, 06 Jan
 2021 20:17:48 +0200")
Message-ID: <87lfd5yny9.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview:  Eli Zaretskii <eliz@HIDDEN> writes: > I use it myself, when
 some buffer pops up in a window I use for > another buffer, and fails to
 pop down (example: *Shell Command > Output*). But then why would I want the
 buffer be displayed in a > [...] 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 45688
Cc: 45688 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Eli Zaretskii <eliz@HIDDEN> writes:

> I use it myself, when some buffer pops up in a window I use for
> another buffer, and fails to pop down (example: *Shell Command
> Output*).  But then why would I want the buffer be displayed in a
> random window?

Not in a random window, but not in the last-chosen window, either.  That
way, if you're `display-buffer'-ing a number of buffers, you'll get them
all in the other windows, instead of reusing the same one.

> I guess I'm missing something here, if this feature is deemed so
> important that it caused jwz to post a complete blog about that.

It would have been nice if he had been more specific; yes.  But the
XEmacs behaviour seems quite natural to me -- if you have three windows,
and you're working in one, and you want to look at two other buffers at
the same time, then the XEmacs `display-buffer' does the right thing for
that.

As Martin explained, display-buffer-use-some-window almost does this,
but since switching to the buffer doesn't count as "use", it doesn't
work for this particular use case.

Adding another action here (that just calls
display-buffer-use-some-window, but then marks the window as having been
used) seems trivial, so I think I'll try doing that and see what that
feels like.

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#45688; Package emacs. Full text available.

Message received at 45688 <at> debbugs.gnu.org:


Received: (at 45688) by debbugs.gnu.org; 6 Jan 2021 18:48:05 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Jan 06 13:48:05 2021
Received: from localhost ([127.0.0.1]:45542 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kxDqn-0008Pw-4A
	for submit <at> debbugs.gnu.org; Wed, 06 Jan 2021 13:48:05 -0500
Received: from mout.gmx.net ([212.227.17.21]:45293)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <rudalics@HIDDEN>) id 1kxDql-0008P5-UB
 for 45688 <at> debbugs.gnu.org; Wed, 06 Jan 2021 13:48:04 -0500
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=gmx.net;
 s=badeba3b8450; t=1609958877;
 bh=VbSIzsaLwWWoCwwVA+VT4Xf64fy78OarLKGMZYd1PJQ=;
 h=X-UI-Sender-Class:Subject:To:Cc:References:From:Date:In-Reply-To;
 b=WOBJct+6rPHxaan3T09x5HWEjNyy+zOjYpR864gWTQr4KAS+Euqx1mFa93t6QbzLY
 WsLMMZVstCVhbbz9n0pi5u4PG06Spk4D7dlpDsnyStr5ty2uyk13+13DwiaE7TYQAb
 YXh8ttfVb8rYOOjH1ind9W2PH8yWdL9y98aM0nQk=
X-UI-Sender-Class: 01bb95c1-4bf8-414a-932a-4f6e2808ef9c
Received: from [192.168.1.100] ([212.95.5.112]) by mail.gmx.com (mrgmx104
 [212.227.17.168]) with ESMTPSA (Nemesis) id 1Ma20q-1kRRM03fj2-00VuSu; Wed, 06
 Jan 2021 19:47:57 +0100
Subject: Re: bug#45688: 28.0.50; New action for display-buffer?
To: Juri Linkov <juri@HIDDEN>, Lars Ingebrigtsen <larsi@HIDDEN>
References: <87im8a1dff.fsf@HIDDEN> <87o8i29eiv.fsf@HIDDEN>
From: martin rudalics <rudalics@HIDDEN>
Message-ID: <d6de679a-84b8-735d-7cf4-30e3b33d1d08@HIDDEN>
Date: Wed, 6 Jan 2021 19:47:55 +0100
MIME-Version: 1.0
In-Reply-To: <87o8i29eiv.fsf@HIDDEN>
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Language: en-US
Content-Transfer-Encoding: 7bit
X-Provags-ID: V03:K1:Dn83BCQlCkTioUn6KqFnTPZpFpVngCcFO1CpQPuG/ankmGk4zI4
 EBVJSAW3hqKvkqA6moSVyv+mDBb7/DsrIB+dougYPWLTQ7jtvszbgo1mvJIX+cph03Y6+HN
 /yXeNwXI0QvKJ4xryBiBK0nBDBEc0GPdp3UR2HBctWn5a/kmiiR8JyvNVlIeZOdx45etvrQ
 ReKPwLBl68NSGlHFaPJZg==
X-Spam-Flag: NO
X-UI-Out-Filterresults: notjunk:1;V03:K0:FC3iDLPY0zc=:NzZblUXQ4XVTYu9pJGKFD9
 usAW6OX9S1KW0nK/Euh9IP1y4Ebpw1pHLPyfaeI2yB+qWHXoUw3q3C9OATf2pb7GAAiMDiB+u
 yrvQowAQeB4BkIFoM7DyAvW8hxB4Au4fcbnnN9Tt8jCLbAuWzdKC3UnkZc/6cKWze/Je2R8Ah
 nuN1TY6RgVvmFOwTTlNS4hRMY9LLA50N0W48p1jT0bWvItSrDsjpc3ZTkeCA7lNeaieDzqjcJ
 RSRKRSSQO9+oflKo58bwLglIJv+ggkjscReNkbQ4poC/mhk7VSxuGB923ZEzITWAklyoGnrjr
 Avr4Gd6ju49J9n/2AbuzLu1u9Nv7F6NLAVdlV/I8xDOJteAuo3WdkeeNB3zcv91W0UjC27nzl
 aTjbhGohdNoXPHAl5WGL3jmIAjgD06XGbBap50/zUeqq2PEYhloMQAzQ97LSMr8lg/+ktgLbW
 /CB5GNgJDuFA4lgyuLbJTyzxySVw4yogqc3HqHHkJ3xK2RTVdOhJu5YlHKQknq2ac0nuI9S0j
 wgEhnrBhSD9OftVcJjZm+QDdqXNa4vELPgf6XbK5BuvVvXz5AaAwImSa/T3LyLdl0jRz+xfGM
 3SuCB7v4LJU6VJWXqJczqul9Q0JlyldVpGPNqEwFWZOJRFf1skDyJ0/EZr51u4mIhtZzj8YCY
 p4hR9SD6XEapsThI1s6QkyuDIirdqRONMGJinY9RExGf4b/StORnF1mYYXiHTVM160V6ZIPo7
 a1J11ltYdoQKnWUdPUOYG0KCJfdSTIPeBAFUwVNw6OPoVxtCh0OUsbHmM5zSC5Av9Pk394KIB
 W58vYdlPh8Ibe7EJGNP+kRJ3yc0mcvRCO0CEUXuAxtddphPSndSpUxU0lBQ2h6CH/3O4HdkGY
 UzDbAT66C2Jl7GzNbOvA==
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 45688
Cc: 45688 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

 >> I was curious how XEmacs did this command, so I installed XEmacs.  If
 >> there's two (or one) window, the command works the same in Emacs and
 >> XEmacs, but it's interesting what XEmacs does when there's more than two
 >> windows: It cycles the windows.
 >
 > This is how Emacs already works - exactly as XEmacs
 > it uses get-lru-window that caused a lot of sadness
 > for many years.  Many times I asked to fix this to
 > use get-mru-window instead.  Maybe now is a good moment to
 > finally change this to work differently from XEmacs.

Emacs doesn't work like XEmacs here.  When XEmacs has found a window to
display the buffer in, it does

               ;; Bring the window's previous buffer to the top of the
               ;; MRU chain.
               (if (window-buffer window)
                   (save-excursion
                     (save-selected-window
                       (select-window window)
                       (record-buffer (window-buffer window)))))

which selects the window and, as a side effect, updates its use time.
Which makes that window less likely for `display-buffer' to be used
again.

martin




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#45688; Package emacs. Full text available.

Message received at 45688 <at> debbugs.gnu.org:


Received: (at 45688) by debbugs.gnu.org; 6 Jan 2021 18:28:43 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Jan 06 13:28:43 2021
Received: from localhost ([127.0.0.1]:45518 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kxDY3-0007wB-5c
	for submit <at> debbugs.gnu.org; Wed, 06 Jan 2021 13:28:43 -0500
Received: from userp2130.oracle.com ([156.151.31.86]:40956)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <drew.adams@HIDDEN>) id 1kxDXy-0007vw-SN
 for 45688 <at> debbugs.gnu.org; Wed, 06 Jan 2021 13:28:41 -0500
Received: from pps.filterd (userp2130.oracle.com [127.0.0.1])
 by userp2130.oracle.com (8.16.0.42/8.16.0.42) with SMTP id 106I9Orn193084;
 Wed, 6 Jan 2021 18:28:32 GMT
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=oracle.com;
 h=mime-version :
 message-id : date : from : sender : to : cc : subject : references :
 in-reply-to : content-type : content-transfer-encoding; s=corp-2020-01-29;
 bh=ruh/4RibNnWe0J3EuQTXU60btnhSqBcC+FHM/g2Aakw=;
 b=RArtjq98tQF4SMiJ9QbOhDih9JKil5L2Yv/O5o2YaQWPudbK1QZamnsy26vsV86pba3k
 HMaz1CXn33lENRKMOqwy6U6mJx3SoSPXv+e0qnxO3NyZkoDcX50n9qQ6ZkkjpXBna3HD
 Cd41R+HHL596bW6sWYMYGn7K47x1H8XbRuDuj1hJC1UNsxkWAbe+BKvcNm0MiZYr1KI7
 olPwfwomRje2hobYzDJaQ+OBOkVazf+WyNvuBZxnfe+p0vDpLerJSQftyCAFy8MrC0yP
 15cnrjgePIHNlWLKVhMBKBfc/i5XQG/g62b8Wv7Zumc+/mGVTeMzTb8m6Qlocez8uwCY hw== 
Received: from aserp3030.oracle.com (aserp3030.oracle.com [141.146.126.71])
 by userp2130.oracle.com with ESMTP id 35wftx8unh-1
 (version=TLSv1.2 cipher=ECDHE-RSA-AES256-GCM-SHA384 bits=256 verify=FAIL);
 Wed, 06 Jan 2021 18:28:32 +0000
Received: from pps.filterd (aserp3030.oracle.com [127.0.0.1])
 by aserp3030.oracle.com (8.16.0.42/8.16.0.42) with SMTP id 106IASbv008560;
 Wed, 6 Jan 2021 18:28:32 GMT
Received: from aserv0121.oracle.com (aserv0121.oracle.com [141.146.126.235])
 by aserp3030.oracle.com with ESMTP id 35v4rd03t0-1
 (version=TLSv1.2 cipher=ECDHE-RSA-AES256-GCM-SHA384 bits=256 verify=OK);
 Wed, 06 Jan 2021 18:28:31 +0000
Received: from abhmp0002.oracle.com (abhmp0002.oracle.com [141.146.116.8])
 by aserv0121.oracle.com (8.14.4/8.13.8) with ESMTP id 106ISTBI011859;
 Wed, 6 Jan 2021 18:28:30 GMT
MIME-Version: 1.0
Message-ID: <82084bed-f646-46a2-b52f-e80b763968b8@default>
Date: Wed, 6 Jan 2021 10:28:28 -0800 (PST)
From: Drew Adams <drew.adams@HIDDEN>
To: Juri Linkov <juri@HIDDEN>, Lars Ingebrigtsen <larsi@HIDDEN>
Subject: RE: bug#45688: 28.0.50; New action for display-buffer?
References: <87im8a1dff.fsf@HIDDEN> <87o8i29eiv.fsf@HIDDEN>
In-Reply-To: <87o8i29eiv.fsf@HIDDEN>
X-Priority: 3
X-Mailer: Oracle Beehive Extensions for Outlook 2.0.1.9.1  (1003210) [OL
 16.0.5095.0 (x86)]
Content-Type: text/plain; charset=us-ascii
Content-Transfer-Encoding: quoted-printable
X-Proofpoint-Virus-Version: vendor=nai engine=6000 definitions=9856
 signatures=668683
X-Proofpoint-Spam-Details: rule=notspam policy=default score=0 mlxlogscore=999
 mlxscore=0 bulkscore=0
 suspectscore=0 spamscore=0 adultscore=0 malwarescore=0 phishscore=0
 classifier=spam adjust=0 reason=mlx scancount=1 engine=8.12.0-2009150000
 definitions=main-2101060104
X-Proofpoint-Virus-Version: vendor=nai engine=6000 definitions=9856
 signatures=668683
X-Proofpoint-Spam-Details: rule=notspam policy=default score=0 phishscore=0
 suspectscore=0 mlxscore=0
 bulkscore=0 priorityscore=1501 impostorscore=0 clxscore=1011
 lowpriorityscore=0 mlxlogscore=999 malwarescore=0 spamscore=0 adultscore=0
 classifier=spam adjust=0 reason=mlx scancount=1 engine=8.12.0-2009150000
 definitions=main-2101060104
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 45688
Cc: 45688 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> Many times I asked to fix this to
> use get-mru-window instead.  Maybe now is a good moment to
> finally change this to work differently from XEmacs.

If such a change is made, please provide an option for choosing mru or lru.

I suspect that there are a fair number of users and libraries that expect l=
ru to be used as the default (first in order), if only because that's been =
the case for a long time.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#45688; Package emacs. Full text available.

Message received at 45688 <at> debbugs.gnu.org:


Received: (at 45688) by debbugs.gnu.org; 6 Jan 2021 18:17:59 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Jan 06 13:17:59 2021
Received: from localhost ([127.0.0.1]:45496 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kxDNf-0007g7-Gq
	for submit <at> debbugs.gnu.org; Wed, 06 Jan 2021 13:17:59 -0500
Received: from eggs.gnu.org ([209.51.188.92]:58376)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1kxDNe-0007fv-3V
 for 45688 <at> debbugs.gnu.org; Wed, 06 Jan 2021 13:17:58 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:38136)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1kxDNY-0002NV-SM; Wed, 06 Jan 2021 13:17:52 -0500
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:2945
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1kxDNX-0004ZH-Vr; Wed, 06 Jan 2021 13:17:52 -0500
Date: Wed, 06 Jan 2021 20:17:48 +0200
Message-Id: <83o8i20w1f.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Lars Ingebrigtsen <larsi@HIDDEN>
In-Reply-To: <8735ze0yp7.fsf@HIDDEN> (message from Lars Ingebrigtsen on Wed, 
 06 Jan 2021 18:20:20 +0100)
Subject: Re: bug#45688: 28.0.50; New action for display-buffer?
References: <87im8a1dff.fsf@HIDDEN> <83y2h6133r.fsf@HIDDEN>
 <8735ze0yp7.fsf@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 45688
Cc: 45688 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Lars Ingebrigtsen <larsi@HIDDEN>
> Cc: 45688 <at> debbugs.gnu.org
> Date: Wed, 06 Jan 2021 18:20:20 +0100
> 
> Eli Zaretskii <eliz@HIDDEN> writes:
> 
> > I'm not sure I understand what kind of use case would find the above
> > convenient.  display-buffer is supposed to be for temporary display of
> > some buffer that you soon enough want to go away, so why does it
> > matter which buffer it replaces? 
> 
> It's a user command (on `C-x 4 C-o'), and apparently some people use it
> a lot?

I use it myself, when some buffer pops up in a window I use for
another buffer, and fails to pop down (example: *Shell Command
Output*).  But then why would I want the buffer be displayed in a
random window?

> I've never used it myself, but I see the charm -- if you want
> to look at a different buffer while working in the current buffer, it
> seems quite convenient.

Sure, but once again: why do that in some random window, as opposed to
a fixed one?  I'm not asking about the utility of display-buffer, I'm
asking about this particular aspect: the fact that it doesn't pop up
in a fixed window.

I guess I'm missing something here, if this feature is deemed so
important that it caused jwz to post a complete blog about that.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#45688; Package emacs. Full text available.

Message received at 45688 <at> debbugs.gnu.org:


Received: (at 45688) by debbugs.gnu.org; 6 Jan 2021 18:10:48 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Jan 06 13:10:48 2021
Received: from localhost ([127.0.0.1]:45465 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kxDGh-0005O7-S0
	for submit <at> debbugs.gnu.org; Wed, 06 Jan 2021 13:10:48 -0500
Received: from relay2-d.mail.gandi.net ([217.70.183.194]:53005)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <juri@HIDDEN>) id 1kxDGf-0005Ns-Ks
 for 45688 <at> debbugs.gnu.org; Wed, 06 Jan 2021 13:10:46 -0500
X-Originating-IP: 91.129.98.64
Received: from mail.gandi.net (m91-129-98-64.cust.tele2.ee [91.129.98.64])
 (Authenticated sender: juri@HIDDEN)
 by relay2-d.mail.gandi.net (Postfix) with ESMTPSA id 332CA40007;
 Wed,  6 Jan 2021 18:10:37 +0000 (UTC)
From: Juri Linkov <juri@HIDDEN>
To: Lars Ingebrigtsen <larsi@HIDDEN>
Subject: Re: bug#45688: 28.0.50; New action for display-buffer?
Organization: LINKOV.NET
References: <87im8a1dff.fsf@HIDDEN>
Date: Wed, 06 Jan 2021 19:41:20 +0200
In-Reply-To: <87im8a1dff.fsf@HIDDEN> (Lars Ingebrigtsen's message of "Wed,
 06 Jan 2021 13:02:12 +0100")
Message-ID: <87o8i29eiv.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (x86_64-pc-linux-gnu)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 45688
Cc: 45688 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

> Reading this:
>
> https://www.jwz.org/blog/2021/01/very-much-do-not-have-my-emacs-setup-just-how-i-like-it/
>
> I was curious how XEmacs did this command, so I installed XEmacs.  If
> there's two (or one) window, the command works the same in Emacs and
> XEmacs, but it's interesting what XEmacs does when there's more than two
> windows: It cycles the windows.

This is how Emacs already works - exactly as XEmacs
it uses get-lru-window that caused a lot of sadness
for many years.  Many times I asked to fix this to
use get-mru-window instead.  Maybe now is a good moment to
finally change this to work differently from XEmacs.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#45688; Package emacs. Full text available.

Message received at 45688 <at> debbugs.gnu.org:


Received: (at 45688) by debbugs.gnu.org; 6 Jan 2021 17:20:34 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Jan 06 12:20:34 2021
Received: from localhost ([127.0.0.1]:45417 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kxCU6-0004DB-3O
	for submit <at> debbugs.gnu.org; Wed, 06 Jan 2021 12:20:34 -0500
Received: from quimby.gnus.org ([95.216.78.240]:55438)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1kxCU3-0004Cx-Mu
 for 45688 <at> debbugs.gnu.org; Wed, 06 Jan 2021 12:20:32 -0500
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnus.org;
 s=20200322; h=Content-Type:MIME-Version:Message-ID:In-Reply-To:Date:
 References:Subject:Cc:To:From:Sender:Reply-To:Content-Transfer-Encoding:
 Content-ID:Content-Description:Resent-Date:Resent-From:Resent-Sender:
 Resent-To:Resent-Cc:Resent-Message-ID:List-Id:List-Help:List-Unsubscribe:
 List-Subscribe:List-Post:List-Owner:List-Archive;
 bh=GKWropvdAlfnTiXFFHZpK0fxyDms7opHsKfMnAvfwrg=; b=FfgbA0CbCHbLNZugvNxsnpDTly
 AUIPKWF660U0SVx1RIbYmggIOuYsjPbD96To2ICL4sBuGaVHC6mys9vK9/sJoD9JbQcSF8XsocS0Q
 LA5Qa7N+/WilIz5ZSHoRxj0q89Nt13kuTRDkWO+hKY7pbdEi++MDkv8QzDRmkIagaR9Q=;
Received: from cm-84.212.202.86.getinternet.no ([84.212.202.86] helo=xo)
 by quimby.gnus.org with esmtpsa (TLS1.3:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.92) (envelope-from <larsi@HIDDEN>)
 id 1kxCTt-000857-GI; Wed, 06 Jan 2021 18:20:24 +0100
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#45688: 28.0.50; New action for display-buffer?
References: <87im8a1dff.fsf@HIDDEN> <83y2h6133r.fsf@HIDDEN>
Face: iVBORw0KGgoAAAANSUhEUgAAADAAAAAwBAMAAAClLOS0AAAABGdBTUEAALGPC/xhBQAAACBj
 SFJNAAB6JgAAgIQAAPoAAACA6AAAdTAAAOpgAAA6mAAAF3CculE8AAAAKlBMVEUQDBAnERdaHyWm
 ZSzlkCxfbYoyKS8lGyZ2krmOpcdRUV83N0lIQEz///+TTnCNAAAAAWJLR0QN9rRh9QAAAAd0SU1F
 B+UBBhERHMhq4OUAAAGgSURBVDjLdZKxboJQFIbPXSBRB64mNbELpUkfQHwDfYAuJMYJh2LSMsAC
 SdMHsG+gm2mC0SsDEzWdSAeaoA/VewHbcqBnuCH34z//fw4A/FvdW70s7bdUDnqjSVkjfTwejSf8
 mKh/FUNNMy4K5aeh5PNDfjUD7HRl8ZfkdbSPmoC2q4NrDoimq40KRV5F+wRPMxTm66QO7kqwqd5T
 z8tTbXYIeCzNFZsjAv2AFXMckQcJ2MIVHg84bsZ8L5WXDSDse6m3ip5NBFgo+Vm23HoOBgfJGWRT
 44QAYQfLBTKdnZGHbLDUBXCoS2sg5gB8l1SBZMxi3l3B308A0SrEYaFdgGWAVgWdz1k6BwhOWwRa
 n7niq+bReWNCAbQGwlAoQMG5OizM56hJ2ueTVYuaz3GOrXx9ChpSsixfaQKy33fFDXEQIArltlQh
 LsFWAhBqmyTB4EYIByZgBREAXiIEWllCRSR7jjx663tKuLmFW/V0tQBz4lRAVxMA4HGB1tjViu19
 vFcFJeDmW7R3Sovfxo4RIGVr26otvgBPC2guz788fQNjUYa4+UzhwgAAACV0RVh0ZGF0ZTpjcmVh
 dGUAMjAyMS0wMS0wNlQxNzoxNzoyOCswMDowMC0jgQMAAAAldEVYdGRhdGU6bW9kaWZ5ADIwMjEt
 MDEtMDZUMTc6MTc6MjgrMDA6MDBcfjm/AAAAAElFTkSuQmCC
X-Now-Playing: Depeche Mode's _Black Celebration_: "World Full of Nothing"
Date: Wed, 06 Jan 2021 18:20:20 +0100
In-Reply-To: <83y2h6133r.fsf@HIDDEN> (Eli Zaretskii's message of "Wed, 06 Jan
 2021 17:45:12 +0200")
Message-ID: <8735ze0yp7.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview: Eli Zaretskii <eliz@HIDDEN> writes: > I'm not sure I
 understand
 what kind of use case would find the above > convenient. display-buffer is
 supposed to be for temporary display of > some buffer that you soon enough
 want to go away, so wh [...] 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 45688
Cc: 45688 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Eli Zaretskii <eliz@HIDDEN> writes:

> I'm not sure I understand what kind of use case would find the above
> convenient.  display-buffer is supposed to be for temporary display of
> some buffer that you soon enough want to go away, so why does it
> matter which buffer it replaces? 

It's a user command (on `C-x 4 C-o'), and apparently some people use it
a lot?  I've never used it myself, but I see the charm -- if you want
to look at a different buffer while working in the current buffer, it
seems quite convenient.  (You don't have to pop back to the original
buffer as with `switch-to-buffer-other-window' or the like.)

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#45688; Package emacs. Full text available.

Message received at 45688 <at> debbugs.gnu.org:


Received: (at 45688) by debbugs.gnu.org; 6 Jan 2021 15:53:07 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Jan 06 10:53:07 2021
Received: from localhost ([127.0.0.1]:45295 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kxB7T-0001y2-Ag
	for submit <at> debbugs.gnu.org; Wed, 06 Jan 2021 10:53:07 -0500
Received: from mout.gmx.net ([212.227.17.22]:49597)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <rudalics@HIDDEN>) id 1kxB7R-0001xA-Mk
 for 45688 <at> debbugs.gnu.org; Wed, 06 Jan 2021 10:53:06 -0500
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=gmx.net;
 s=badeba3b8450; t=1609948379;
 bh=mdVyDxY2ct3vvcXrvHjeHn1vGRlHEj58fVOPfqT7YQE=;
 h=X-UI-Sender-Class:Subject:To:Cc:References:From:Date:In-Reply-To;
 b=KJZgVYR2z/8jbkDYTagm+Pypn0bhbqnJMxstT4o46dHRkY4+Xr/vie9vyOcSDlM0I
 VzxItELNTfBnGBGq8fv/1Ra+64+zWxycH79ozlFc+6IyAjU1s0vehMW+di9IDP2XJw
 Ca+I5nZF6q0tYz30RoBAE5XBxmQBAL1wupAxM2p0=
X-UI-Sender-Class: 01bb95c1-4bf8-414a-932a-4f6e2808ef9c
Received: from [192.168.1.100] ([212.95.5.112]) by mail.gmx.com (mrgmx105
 [212.227.17.168]) with ESMTPSA (Nemesis) id 1M4s0t-1kwLu80etL-001wF7; Wed, 06
 Jan 2021 16:52:59 +0100
Subject: Re: bug#45688: 28.0.50; New action for display-buffer?
To: Lars Ingebrigtsen <larsi@HIDDEN>
References: <87im8a1dff.fsf@HIDDEN>
 <6d33f679-925e-78ee-2055-0520538f48f5@HIDDEN> <87ble217jy.fsf@HIDDEN>
From: martin rudalics <rudalics@HIDDEN>
Message-ID: <8bc28c07-a4af-f58d-97f5-9d0a89ff58fe@HIDDEN>
Date: Wed, 6 Jan 2021 16:52:58 +0100
MIME-Version: 1.0
In-Reply-To: <87ble217jy.fsf@HIDDEN>
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Language: en-US
Content-Transfer-Encoding: 7bit
X-Provags-ID: V03:K1:Akxp0FYClKqKS5KSE21SjoEivF9SjHSCGRmDQWwr1AS9mPoEds5
 2z9jHfkJjGQxk2Znff2yNrLHY64NosWeiu78XM1+H+W5ITM3NbBbtAeHw45WS4wpJ1ePKjY
 CXFYpQ9Tpdq7MFnW4aSlwAmkdtp2pvfDqyQSd4VbwAXdnY/HkuqcBNBB1Ap13uU2WAAkR69
 qe2P3OsSmfnVujc7TWXag==
X-Spam-Flag: NO
X-UI-Out-Filterresults: notjunk:1;V03:K0:K0b84VKvbcw=:K/OWQMRsbuQSM5TatxVDe4
 LDNhUNw2vqe2vjPhKwrkSlW1HkwT7QWpJzhGK0KwBoUm2ZheHWsLWRF5R/bIT7DipagIeFWNa
 YeTeK9sdEA7QSefUiZjn/jhHuYiJQ5OCWN5CrBzDiK0fjraFa4rsTx35mw6e7PJZl1h4p4E3h
 mBbLehCPiPEpMQmzv1Zw7F5LLuKxCg7wkjGqTVuOvjPah9XaMnPHQhod2T3VQ1yaRGIDmV9lh
 rIg7K3u4ZH0+tLhujEKJZfjanpUdQXiFjbSl5/kvmh1ngSd8pZf8FmESdkX04Fl9vdOfBPqly
 FX1nzJRwPMXMiXHOtWcXNFrD1gKnvCFwQRYJULUtV7a33cXiA0Ksu/VptNKEwdEb86J9PfocW
 //Wg/C78B0JAgZf7H2XqOHdgZMfq4B5PANYAujci5pf5u4Kjj1V5WeP4S/S/2Ud2h2bJz6/7y
 1t6dqCchEXAPbzTflhjHDuGzW2OD5d/ZjuxlslL/GOc0gIizcNHyOtT/902iFoP00tKXC/U8F
 5hfTqcGt6pw/fQTehJMtNlNkUJ//DuH9/ZGtiLpo8aSKNcrQyk/O/B3qsJZ+1ubhEiZC3Fwq5
 coeRUockUx2DdeggKoZyOpjpCBA3srnzjrAbe/IlasPChR/UdbEsYUmZP+WYLMDoj+JonX0fI
 mDp74nawaXjsfC9tTHboxgAJIbQOwag02RYSggwfjj1becyS5ae79TBvbx7Q9LVW3+M7IuSFw
 ufwP2l3ZpDjaImSWMwhVuzyn3LNe0y7+7zj/MBiqqhJN7zSv9lCBIf+Hei3cbss4pcF62Xkmr
 Rpz2LKu/j3Z6mii14EoI3mlFWdCGzHUyiVLnDhWd7XhQZR5KDHbOwAJlKtWk/OYfhIRQKX5jA
 28aWZTKYmyERWuWF3Fhw==
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 45688
Cc: 45688 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

 > I tried
 >
 > (setq display-buffer-overriding-action '(display-buffer-use-some-window))
 >
 > but I don't see any difference -- display-buffer always uses the same
 > window when displaying buffers.

You really have to "use" such a window which means selecting it.  Just
displaying a buffer in a window does not count as using it.  The use
time of a window that was never selected stays at zero, so such a window
is always a good candidate for 'display-buffer-use-some-window'.  That's
how use times and `get-lru-window' work.  Feel free to install something
more appropriate here.

martin




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#45688; Package emacs. Full text available.

Message received at 45688 <at> debbugs.gnu.org:


Received: (at 45688) by debbugs.gnu.org; 6 Jan 2021 15:45:38 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Jan 06 10:45:38 2021
Received: from localhost ([127.0.0.1]:45286 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kxB0E-0001kp-7A
	for submit <at> debbugs.gnu.org; Wed, 06 Jan 2021 10:45:38 -0500
Received: from eggs.gnu.org ([209.51.188.92]:47132)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1kxB0D-0001kd-He
 for 45688 <at> debbugs.gnu.org; Wed, 06 Jan 2021 10:45:37 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:34762)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1kxB07-0001Iq-CM; Wed, 06 Jan 2021 10:45:32 -0500
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:1520
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1kxAzr-0004DZ-2R; Wed, 06 Jan 2021 10:45:30 -0500
Date: Wed, 06 Jan 2021 17:45:12 +0200
Message-Id: <83y2h6133r.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Lars Ingebrigtsen <larsi@HIDDEN>
In-Reply-To: <87im8a1dff.fsf@HIDDEN> (message from Lars Ingebrigtsen on Wed, 
 06 Jan 2021 13:02:12 +0100)
Subject: Re: bug#45688: 28.0.50; New action for display-buffer?
References: <87im8a1dff.fsf@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 45688
Cc: 45688 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Lars Ingebrigtsen <larsi@HIDDEN>
> Date: Wed, 06 Jan 2021 13:02:12 +0100
> 
> 
> Say you start with this:
> 
> -----
> buf 1
> -----
> buf 2
> -----
> buf 3
> -----
> 
> and you're in buf 1.  `M-x display-buffer RET RET' then gives you:
> 
> -----
> buf 1
> -----
> buf 4
> -----
> buf 3
> -----
> 
> Repeat, and:
> 
> -----
> buf 1
> -----
> buf 4
> -----
> buf 2
> -----
> 
> Repeat, and:
> 
> -----
> buf 1
> -----
> buf 3
> -----
> buf 2
> -----
> 
> Repeat, and:
> 
> -----
> buf 1
> -----
> buf 3
> -----
> buf 4
> -----
> 
> Repeat, and:
> 
> -----
> buf 1
> -----
> buf 2
> -----
> buf 4
> -----
> 
> That is, it cycles the windows.  If there are more windows, it'll go
> through all the other windows in order, choosing the
> least-recently-switched-to window.

I'm not sure I understand what kind of use case would find the above
convenient.  display-buffer is supposed to be for temporary display of
some buffer that you soon enough want to go away, so why does it
matter which buffer it replaces?  Or if it does matter, wouldn't it be
more reasonable to have explicit control on that, instead of letting
it cycle?

I feel that I'm missing something here.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#45688; Package emacs. Full text available.

Message received at 45688 <at> debbugs.gnu.org:


Received: (at 45688) by debbugs.gnu.org; 6 Jan 2021 14:09:21 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Jan 06 09:09:21 2021
Received: from localhost ([127.0.0.1]:43828 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kx9V2-0005Bq-To
	for submit <at> debbugs.gnu.org; Wed, 06 Jan 2021 09:09:21 -0500
Received: from quimby.gnus.org ([95.216.78.240]:53696)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1kx9V1-0005Ba-3v
 for 45688 <at> debbugs.gnu.org; Wed, 06 Jan 2021 09:09:19 -0500
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnus.org;
 s=20200322; h=Content-Transfer-Encoding:Content-Type:MIME-Version:Message-ID
 :In-Reply-To:Date:References:Subject:Cc:To:From:Sender:Reply-To:Content-ID:
 Content-Description:Resent-Date:Resent-From:Resent-Sender:Resent-To:Resent-Cc
 :Resent-Message-ID:List-Id:List-Help:List-Unsubscribe:List-Subscribe:
 List-Post:List-Owner:List-Archive;
 bh=U6lIBxBgoIc3WpHKoydy+BsCX0l9rwLaguaF1CeDSjI=; b=aufQwd0h43lBdpDwUF9MXn0kys
 zzSh+wHaUEVBDyf6inheOX/CsvchVNCXJB0fpYDUnfkTytC3EcVQmk6k1cByhSFAWdSSUPRvxF4+q
 KG9hooJc+woZIHIYIlQeNvikYXes/trDP8eP3zP38bY+5A5PC0SUcB1MIiRd6Ec/ZRIs=;
Received: from cm-84.212.202.86.getinternet.no ([84.212.202.86] helo=xo)
 by quimby.gnus.org with esmtpsa (TLS1.3:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.92) (envelope-from <larsi@HIDDEN>)
 id 1kx9Uo-0006YS-Sz; Wed, 06 Jan 2021 15:09:12 +0100
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: martin rudalics <rudalics@HIDDEN>
Subject: Re: bug#45688: 28.0.50; New action for display-buffer?
References: <87im8a1dff.fsf@HIDDEN>
 <6d33f679-925e-78ee-2055-0520538f48f5@HIDDEN>
Face: iVBORw0KGgoAAAANSUhEUgAAADAAAAAwBAMAAAClLOS0AAAABGdBTUEAALGPC/xhBQAAACBj
 SFJNAAB6JgAAgIQAAPoAAACA6AAAdTAAAOpgAAA6mAAAF3CculE8AAAAElBMVEUQDAl5jYpVUzSe
 ZDzRoDf///+B18jYAAAAAWJLR0QF+G/pxwAAAAd0SU1FB+UBBg4HG13sJNwAAAG+SURBVDjLbdOB
 ddwgDAZglVugOB0AJA9wJzHApbD/TP0l2+Ck4b2Ee3wIYQFEP7RfVQaV/4aFUt0PSP43Z+zvmhEh
 ZmzMjH6YBvQDBlpXkIuHseQNS+XVMMEj2PCz3yFnBBTiF0C/wMaQxPUO9SRESMUMpjFihDm6356j
 5hLgu8p14xMeVDHtAq6beqxH3GGIinr/l0ohRE8wVrYAbGvBZ1ZUxWvwThOaZ3ixV6sDfFc5tovi
 qfgU5A/gACUfsgDl0d5Rw8yoFeraPh0EYE8/qJwbduHJI4UBusPDoTv0WKkzjzFhUOt+fg6K/T7T
 BL5ax7GtHHfgvZtHiJ8ljvYc3wEoDJ3QyfQACXvSjDCbi+1j6AIfiUuDDz2+44KSLsDKntwuoKQB
 7QR+/fHkODHBPUvHET/joBBhmJnaBRYRAYr7xQG+kMUHUsVSjN66BZi1Xo5b0rrDPjZUDnu1Fs9g
 ApYv9PCr0OmCWAobpIDYk8PWhq6n51dmwfjp0aKiLUBEcZVXqxvulCdXG0WIywI+wPBhQrLgIyDh
 Py7jDeJtx/MFcFpLcQmIF+41W8knoC/f4LWAvsAHHRdL7xA5/gFjM4HAXID+bwAAACV0RVh0ZGF0
 ZTpjcmVhdGUAMjAyMS0wMS0wNlQxNDowNzoyNyswMDowMKcvQuQAAAAldEVYdGRhdGU6bW9kaWZ5
 ADIwMjEtMDEtMDZUMTQ6MDc6MjcrMDA6MDDWcvpYAAAAAElFTkSuQmCC
X-Now-Playing: The Wolfgang Press's _The Legendary Wolfgang Press and Other
 Tall Stories_: "Deserve"
Date: Wed, 06 Jan 2021 15:09:05 +0100
In-Reply-To: <6d33f679-925e-78ee-2055-0520538f48f5@HIDDEN> (martin rudalics's
 message of "Wed, 6 Jan 2021 14:36:41 +0100")
Message-ID: <87ble217jy.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 
 Content preview:  martin rudalics <rudalics@HIDDEN> writes: >> ‘display-buffer-use-some-window’
    -- Use some existing window. > > This would use 'get-lru-window' but if you
    display always the same small > set of buffers, 'display-buffer-in-previous-window'
    [...] 
 
 Content analysis details:   (-2.9 points, 5.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
                             [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 45688
Cc: 45688 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

martin rudalics <rudalics@HIDDEN> writes:

>>   =E2=80=98display-buffer-use-some-window=E2=80=99 -- Use some existing =
window.
>
> This would use 'get-lru-window' but if you display always the same small
> set of buffers, 'display-buffer-in-previous-window' prevails.

I tried

(setq display-buffer-overriding-action '(display-buffer-use-some-window))

but I don't see any difference -- display-buffer always uses the same
window when displaying buffers.

--=20
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#45688; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 6 Jan 2021 13:36:55 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Jan 06 08:36:55 2021
Received: from localhost ([127.0.0.1]:43814 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kx8zf-0004KW-3a
	for submit <at> debbugs.gnu.org; Wed, 06 Jan 2021 08:36:55 -0500
Received: from lists.gnu.org ([209.51.188.17]:58950)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <rudalics@HIDDEN>) id 1kx8ze-0004KP-3t
 for submit <at> debbugs.gnu.org; Wed, 06 Jan 2021 08:36:54 -0500
Received: from eggs.gnu.org ([2001:470:142:3::10]:39464)
 by lists.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <rudalics@HIDDEN>) id 1kx8zd-0000lq-9E
 for bug-gnu-emacs@HIDDEN; Wed, 06 Jan 2021 08:36:53 -0500
Received: from mout.gmx.net ([212.227.17.20]:37181)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <rudalics@HIDDEN>) id 1kx8zW-0001dL-K5
 for bug-gnu-emacs@HIDDEN; Wed, 06 Jan 2021 08:36:53 -0500
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=gmx.net;
 s=badeba3b8450; t=1609940203;
 bh=i/eWcMmU8suKbgbDfZ7e+klAtmcXXTYjip4oeslKty4=;
 h=X-UI-Sender-Class:Subject:To:References:From:Date:In-Reply-To;
 b=YrxSN/E9eMtc0XwDbyxSnevHBtk0Wp0CSsLv+dFn3mn6GtynRlQbHJ/3D7G8Bjvau
 Wjn5SZ8Txz5o5FTuTMrBWuYqdvtMqBBvkY5jMrGPsqp5qtcM+jyMWdYjL6fpAnq8WG
 8m21mZmZe41MQ8c+swJ2O9baRL7kd7EfwG+0dF78=
X-UI-Sender-Class: 01bb95c1-4bf8-414a-932a-4f6e2808ef9c
Received: from [192.168.1.100] ([212.95.5.112]) by mail.gmx.com (mrgmx105
 [212.227.17.168]) with ESMTPSA (Nemesis) id 1MsHru-1k91NI3q4Q-00tmPq; Wed, 06
 Jan 2021 14:36:43 +0100
Subject: Re: 28.0.50; New action for display-buffer?
To: Lars Ingebrigtsen <larsi@HIDDEN>, bug-gnu-emacs@HIDDEN
References: <87im8a1dff.fsf@HIDDEN>
From: martin rudalics <rudalics@HIDDEN>
Message-ID: <6d33f679-925e-78ee-2055-0520538f48f5@HIDDEN>
Date: Wed, 6 Jan 2021 14:36:41 +0100
MIME-Version: 1.0
In-Reply-To: <87im8a1dff.fsf@HIDDEN>
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Language: en-US
Content-Transfer-Encoding: quoted-printable
X-Provags-ID: V03:K1:MENubnrQNJGi77Lb//cIOZ1oV4ALc2ZhWpYab9SvQG9WLY6SNKR
 hQ7AKnDaGdiqm0G7D6c6qnGMk7LLvVcZwwLv9qMTveQQKLC6IDgUb5zmO8+quvL2oIRvrGy
 C4yXwQMb5dDT+ZAgCrwxEjUIWUGaR/a/uqZJp/2aMxScnnNQVVJ9epXUfNDmspNXyGEQnKd
 1MJqi3iQe3HovAfA88inA==
X-Spam-Flag: NO
X-UI-Out-Filterresults: notjunk:1;V03:K0:dl/NVoZmtHk=:jpmbxC5BuyhxBqBMRc2RCm
 xT6I1JlapN7AazdzQ4NzKDALviPeXa9eCsq+26VGhcl7C2e6cJyvNlxdEYeVLRxJWy3ddUasE
 cbkrbkOAdCp+1fql3eAPf051FrJZHT426ahqu/Yp7EufL3MjHIYpCdJthR+77lqDc8lZr8MkM
 wwGhs7ban+9ckpnabSj+U1fgg4QvdRDR3PZASM1KQ5mR+BiFZUflbmBPImJXERbEc6xFX6LQN
 t69QqWJbudGs4eWxoK+wpzPT2/x+iFTzCCsTTFdoGWSaTtiEsSclofAD3aNEBJk0ArfT1r39J
 Quk9qZv+QD2fdmT18Cf0eC8a/i/JGnE/8NN7weHykn9GlUx8aLWTazGkfzsoMpzA6dWER0saT
 rOrhcnDTl96p0dAPnpTCzD9HytROaN1v+2cy3bdCUrZ8SFhVtbww/07YTmpoQiUrsQODBBzZC
 N8vIy9a1Uw8HEEU8wyCtchYjksCXgXKgWl93bx6iqKSd4HZ/3lxFLJDdeZJ06B6MVJTaiT9q7
 hwJGYFYs6S/4mQJKuvui2JUn43j4JKkOmFsNr5aqDelBmFatpTBaMiUujEjtTFuUpPYnGpBCc
 /gQfi6Tk0wp1G1CG8kS7xWMe+hcJ7fg6rbKE6AedyRIgkRuRwXmwtwfBktEnb6EuEdvDVU4rQ
 bvL/+QwiY9J45MVgSnVTyKIJLGkg8YtSHlIbVqnLq3xZs75oP9qVEy9tLcd0wvIXWMGjM/aQy
 4ugvExfaYja4W1Z0qcmSwphIFsCFoxWOzlzpB0epcruPt8WVSLGl4w0ERgovhPAuY3nFHN+RV
 IBErtKInuYqZ7YGZmYCqG/95YzAHJ2PMcupf0myA6r/ID4KkXHxHXzci+Bx3DW72ftp7Z55xT
 Wzn040WqHhez2UgUy6EQ==
Received-SPF: pass client-ip=212.227.17.20; envelope-from=rudalics@HIDDEN;
 helo=mout.gmx.net
X-Spam_score_int: -25
X-Spam_score: -2.6
X-Spam_bar: --
X-Spam_report: (-2.6 / 5.0 requ) BAYES_00=-1.9, DKIM_SIGNED=0.1,
 DKIM_VALID=-0.1, FREEMAIL_FROM=0.001, RCVD_IN_DNSWL_LOW=-0.7,
 RCVD_IN_MSPIKE_H4=0.001, RCVD_IN_MSPIKE_WL=0.001, SPF_HELO_NONE=0.001,
 SPF_PASS=-0.001 autolearn=ham autolearn_force=no
X-Spam_action: no action
X-Spam-Score: -1.4 (-)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -2.4 (--)

 >   =E2=80=98display-buffer-use-some-window=E2=80=99 -- Use some existin=
g window.

This would use 'get-lru-window' but if you display always the same small
set of buffers, 'display-buffer-in-previous-window' prevails.

martin





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#45688; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 6 Jan 2021 12:02:30 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Jan 06 07:02:30 2021
Received: from localhost ([127.0.0.1]:43652 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kx7WI-00086g-0F
	for submit <at> debbugs.gnu.org; Wed, 06 Jan 2021 07:02:30 -0500
Received: from lists.gnu.org ([209.51.188.17]:32986)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1kx7WG-00086V-A1
 for submit <at> debbugs.gnu.org; Wed, 06 Jan 2021 07:02:28 -0500
Received: from eggs.gnu.org ([2001:470:142:3::10]:46156)
 by lists.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <larsi@HIDDEN>) id 1kx7WG-0002lo-2K
 for bug-gnu-emacs@HIDDEN; Wed, 06 Jan 2021 07:02:28 -0500
Received: from quimby.gnus.org ([2a01:4f9:2b:f0f::2]:42522)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <larsi@HIDDEN>) id 1kx7WE-0000cs-Bg
 for bug-gnu-emacs@HIDDEN; Wed, 06 Jan 2021 07:02:27 -0500
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnus.org;
 s=20200322; h=Content-Transfer-Encoding:Content-Type:MIME-Version:Message-ID
 :Date:Subject:Cc:To:From:Sender:Reply-To:Content-ID:Content-Description:
 Resent-Date:Resent-From:Resent-Sender:Resent-To:Resent-Cc:Resent-Message-ID:
 In-Reply-To:References:List-Id:List-Help:List-Unsubscribe:List-Subscribe:
 List-Post:List-Owner:List-Archive;
 bh=ipyg62zUlwPHC/a+WxRUg3vtkgKVrgnv/kKK53K9y9k=; b=Fzv2TN7h/WH+6C0AB8d6kubijR
 heGEvTpqO+729X8NcwD022Xz/PeJ/hfuCVyv3dWGPAqHjJp+t/AEah0HhlcUuyiksWpU7tmwXzMS5
 /Tj91Xelad6/k3DA49UByVreahAcII8c4AhWysAyg/NxS/Qp54vm4eG2t7Y2tQXPQrzM=;
Received: from cm-84.212.202.86.getinternet.no ([84.212.202.86] helo=xo)
 by quimby.gnus.org with esmtpsa (TLS1.3:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.92) (envelope-from <larsi@HIDDEN>)
 id 1kx7W2-0005ap-1H; Wed, 06 Jan 2021 13:02:20 +0100
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: bug-gnu-emacs@HIDDEN
Subject: 28.0.50; New action for display-buffer?
X-Now-Playing: Jane Siberry's _The Speckless Sky_: "The Empty City"
Date: Wed, 06 Jan 2021 13:02:12 +0100
Message-ID: <87im8a1dff.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details. Content preview: Reading this:
 https://www.jwz.org/blog/2021/01/very-much-do-not-have-my-emacs-setup-just-how-i-like-it/
 I was curious how XEmacs did this command, so I installed XEmacs. If there's
 two (or one) window, the command works the same in Emacs and XEmacs, but
 it's interesting what XEmacs does when there's mor [...] 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
Received-SPF: pass client-ip=2a01:4f9:2b:f0f::2; envelope-from=larsi@HIDDEN;
 helo=quimby.gnus.org
X-Spam_score_int: -20
X-Spam_score: -2.1
X-Spam_bar: --
X-Spam_report: (-2.1 / 5.0 requ) BAYES_00=-1.9, DKIM_SIGNED=0.1,
 DKIM_VALID=-0.1, DKIM_VALID_AU=-0.1, DKIM_VALID_EF=-0.1,
 RCVD_IN_DNSWL_NONE=-0.0001, SPF_HELO_NONE=0.001,
 SPF_PASS=-0.001 autolearn=ham autolearn_force=no
X-Spam_action: no action
X-Spam-Score: -1.3 (-)
X-Debbugs-Envelope-To: submit
Cc: Martin Rudalics <rudalics@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -2.3 (--)


Reading this:

https://www.jwz.org/blog/2021/01/very-much-do-not-have-my-emacs-setup-just-=
how-i-like-it/

I was curious how XEmacs did this command, so I installed XEmacs.  If
there's two (or one) window, the command works the same in Emacs and
XEmacs, but it's interesting what XEmacs does when there's more than two
windows: It cycles the windows.

Say you start with this:

-----
buf 1
-----
buf 2
-----
buf 3
-----

and you're in buf 1.  `M-x display-buffer RET RET' then gives you:

-----
buf 1
-----
buf 4
-----
buf 3
-----

Repeat, and:

-----
buf 1
-----
buf 4
-----
buf 2
-----

Repeat, and:

-----
buf 1
-----
buf 3
-----
buf 2
-----

Repeat, and:

-----
buf 1
-----
buf 3
-----
buf 4
-----

Repeat, and:

-----
buf 1
-----
buf 2
-----
buf 4
-----

That is, it cycles the windows.  If there are more windows, it'll go
through all the other windows in order, choosing the
least-recently-switched-to window.

This does indeed seem quite nice, and apparently none of the built-in
actions has this effect?

Action functions and the action they try to perform are:
 =E2=80=98display-buffer-same-window=E2=80=99 -- Use the selected window.
 =E2=80=98display-buffer-reuse-window=E2=80=99 -- Use a window already show=
ing
    the buffer.
 =E2=80=98display-buffer-in-previous-window=E2=80=99 -- Use a window that d=
id
    show the buffer before.
 =E2=80=98display-buffer-use-some-window=E2=80=99 -- Use some existing wind=
ow.
 =E2=80=98display-buffer-pop-up-window=E2=80=99 -- Pop up a new window.
 =E2=80=98display-buffer-below-selected=E2=80=99 -- Use or pop up a window =
below
    the selected one.
 =E2=80=98display-buffer-at-bottom=E2=80=99 -- Use or pop up a window at the
    bottom of the selected frame.
 =E2=80=98display-buffer-pop-up-frame=E2=80=99 -- Show the buffer on a new =
frame.
 =E2=80=98display-buffer-in-child-frame=E2=80=99 -- Show the buffer in a
    child frame.
 =E2=80=98display-buffer-no-window=E2=80=99 -- Do not display the buffer and
    have =E2=80=98display-buffer=E2=80=99 return nil immediately.

So I wonder whether it would make sense to add this.=20



In GNU Emacs 28.0.50 (build 1, x86_64-pc-linux-gnu, GTK+ Version 3.24.23, c=
airo version 1.16.0)
 of 2020-12-31 built on xo
Repository revision: 72b8430fea79cb1ebb8c3652babf42a12569ab8a
Repository branch: master
Windowing system distributor 'The X.Org Foundation', version 11.0.12008000
System Description: Debian GNU/Linux bullseye/sid


--=20
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no





Acknowledgement sent to Lars Ingebrigtsen <larsi@HIDDEN>:
New bug report received and forwarded. Copy sent to bug-gnu-emacs@HIDDEN. Full text available.
Report forwarded to bug-gnu-emacs@HIDDEN:
bug#45688; Package emacs. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Wed, 20 Jan 2021 21:45:01 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.